{  This file is part of Gum_Mc, uncertainty calculation software
    Copyright (C) 2010  Jean-Marie Biansan
        Contact: jeanmarie.biansan@free.fr
    Web site: http://jeanmarie.biansan.free.fr/logiciel.html
 Gum_Mc is distribued under the terms of the
 GNU General Public License.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA}

unit Unit1;

{$mode objfpc}{$H+} {$R-}

interface

uses
  Classes, charencstreams, SysUtils, FileUtil, TAGraph, TASources, TASeries,
  LResources, Forms, Controls, Graphics, Dialogs, ExtCtrls, StdCtrls, Grids,
  ComCtrls, Buttons, Menus, Symbolic, unit_type_evaluation,Unit_ecart_max,
  Unit_genere_distribution, Unit_incertitude_trop_grande, UTF8Process,
  unit_dois_je_calculer, Unit_saisie_proprietes_dune_grandeur, Math,UnitAvertissement1,UnitAvertissement2,
  Unitsaisiemontecarlo, Unit_trace, specfunx , Unit_aidecalcul, UnitGPL, Unit4,unit_saisie_estimateur,Unit_affiche_correlations,
  LCLType, UnitScaleFont, LCLIntf ,LazHelpHTML, UChaines,unit_descriptif, gettext, translations, clipbrd ,amath ,Unit_affichage_valeur_individuelle,Unit_affichage_incertitude
  {$ifdef windows},windows,shellapi,registry{$endif};




type
      TExtRec  = packed record     {Extended as sign, exponent, significand}
               lm: longint;    {low  32 bit of significand}
               hm: longint;    {high 32 bit of significand}
               xp: word;       {biased exponent and sign  }
             end;


  { TForm1 }

  TForm1 = class(TForm)
    BitBtn1: TBitBtn;



    BitBtn10: TBitBtn;
    BitBtn11: TBitBtn;
    BitBtn12: TBitBtn;
    BitBtn13: TBitBtn;
    BitBtn14: TBitBtn;
    BitBtn15: TBitBtn;
    BitBtn_correlations: TBitBtn;
    BitBtn_theorie1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    BitBtn5: TBitBtn;
    BitBtn6: TBitBtn;
    BitBtn7: TBitBtn;
    BitBtn8: TBitBtn;
    BitBtn9: TBitBtn;
    BitBtn_fonction: TBitBtn;
    BitBtn_theorie2: TBitBtn;
    Chart1: TChart;
    Chart1BarSeries1: TBarSeries;
    Chart2: TChart;
    Chart2PieSeries1: TPieSeries;
    Edit_saisie_unite: TEdit;
    ex1_expression: TEdit;
    ex2_expression: TEdit;
    ex1_sortie: TEdit;
    edit_nom_grandeur_sortie: TEdit;
    Edit_autre_taux_normale: TEdit;
    Edit_autre_taux_student: TEdit;
    Edit_degre_global: TEdit;
    Edit_saisie_expression: TEdit;
    ex3_expression: TEdit;
    ex2_sortie: TEdit;
    ex3_sortie: TEdit;
    Image_sortie_densite: TImage;
    ImageList1: TImageList;
    Image_sortie_integre: TImage;
    Label1: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label2: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label3: TLabel;
    ListChartSource1: TListChartSource;
    MainMenu1: TMainMenu;
    Memo1: TMemo;
    Memo_commentaires: TMemo;
    MenuItem1: TMenuItem;
    MenuItem10: TMenuItem;
    MenuItem11: TMenuItem;
    MenuItem12: TMenuItem;
    MenuItem13: TMenuItem;
    MenuItem14: TMenuItem;
    MenuItem15: TMenuItem;
    MenuItemavertissement: TMenuItem;
    MenuItem_affichage_incertitude: TMenuItem;
    MenuItem_affichage_individuel: TMenuItem;
    MenuItem_historique: TMenuItem;
    MenuItem17: TMenuItem;
    MenuItem_enregistrer: TMenuItem;
    MenuItem_enregistrer_exemples: TMenuItem;
    MenuItem_enregistrer_perso: TMenuItem;
    MenuItem_ouvrir_dernier: TMenuItem;
    MenuItem_nouveau: TMenuItem;
    MenuItem_enregistrer_sous: TMenuItem;
    MenuItem_ouvrir_personnel: TMenuItem;
    MenuItem_ouvrir_exemples: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem3: TMenuItem;
    MenuItem4: TMenuItem;
    MenuItem5: TMenuItem;
    MenuItem6: TMenuItem;
    MenuItem7: TMenuItem;
    MenuItem8: TMenuItem;
    MenuItem9: TMenuItem;
    MenuItem_arrondi_normal_inc: TMenuItem;
    MenuItem_arrondi_sup_inc: TMenuItem;
    MenuItem_arrondi_inc: TMenuItem;
    MenuItem_incertitude: TMenuItem;
    MenuItem_montecarlo: TMenuItem;
    MenuItem_tutoriel: TMenuItem;
    OpenDialog2: TOpenDialog;
    PageControl1: TPageControl;
    PageControl2: TPageControl;
    PageControl_resultats_propagation: TPageControl;
    Panel_gum2: TPanel;
    Panel_intervalle_mc: TPanel;
    Panel_estimateur_mc: TPanel;
    Panel_intervalle_2: TPanel;
    Panel_intervalle_1: TPanel;
    Panel_gum: TPanel;
    Panel_mc: TPanel;
    RadioGroup1: TRadioGroup;
    SaveDialog1: TSaveDialog;
    SpeedButton1: TSpeedButton;
    SpeedButton10: TSpeedButton;
    SpeedButton11: TSpeedButton;
    SpeedButton12: TSpeedButton;
    SpeedButton13: TSpeedButton;
    SpeedButton14: TSpeedButton;
    SpeedButton15: TSpeedButton;
    SpeedButton_paslegitime2: TSpeedButton;
    SpeedButton_paslegitime1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    SpeedButton7: TSpeedButton;
    SpeedButton8: TSpeedButton;
    SpeedButton9: TSpeedButton;
    StaticText1: TStaticText;
    StaticText10: TStaticText;
    StaticText11: TStaticText;
    StaticText12: TStaticText;
    StaticText13: TStaticText;
    StaticText14: TStaticText;
    StaticText15: TStaticText;
    StaticText16: TStaticText;
    StaticText17: TStaticText;
    StaticText18: TStaticText;
    StaticText19: TStaticText;
    StaticText2: TStaticText;
    StaticText20: TStaticText;
    StaticText21: TStaticText;
    StaticText22: TStaticText;
    StaticText23: TStaticText;
    StaticText24: TStaticText;
    StaticText3: TStaticText;
    StaticText4: TStaticText;
    StaticText5: TStaticText;
    StaticText6: TStaticText;
    StaticText7: TStaticText;
    StaticText8: TStaticText;
    StaticText9: TStaticText;
    StringGrid1: TStringGrid;
    StringGrid_incertitudes_mesurandes: TStringGrid;
    StringGrid_autre_taux_normale: TStringGrid;
    StringGrid_autre_taux_student: TStringGrid;
    StringGrid_entree: TStringGrid;
    StringGrid2: TStringGrid;
    StringGrid3: TStringGrid;
    StringGrid4: TStringGrid;
    StringGrid5: TStringGrid;
    StringGrid6: TStringGrid;
    StringGrid7: TStringGrid;
    StringGrid8: TStringGrid;
    StringGrid9: TStringGrid;
    TabSheet_gum2: TTabSheet;
    TabSheet_commentaires: TTabSheet;
    TabSheet_expression: TTabSheet;
    TabSheet_intervalle_mc: TTabSheet;
    TabSheet_densite: TTabSheet;
    TabSheet_integre: TTabSheet;
    TabSheet_estimation_mc: TTabSheet;
    TabSheet_intervalle_student: TTabSheet;
    TabSheet_intervalles_normale: TTabSheet;
    TabSheet_gum1: TTabSheet;
    TabSheet_entree: TTabSheet;
    TabSheet_resultats: TTabSheet;
    TabSheet_mc: TTabSheet;
    TabSheet_bienvenue: TTabSheet;
    procedure BitBtn10Click(Sender: TObject);
    procedure BitBtn11Click(Sender: TObject);
    procedure BitBtn12Click(Sender: TObject);
    procedure BitBtn13Click(Sender: TObject);
    procedure BitBtn14Click(Sender: TObject);
    procedure BitBtn15Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn_correlationsClick(Sender: TObject);
    procedure BitBtn_theorie2Click(Sender: TObject);
    procedure Edit_autre_taux_normaleKeyPress(Sender: TObject; var Key: char);
    procedure Edit_autre_taux_studentKeyPress(Sender: TObject; var Key: char);
    procedure MenuItem11Click(Sender: TObject);
    procedure MenuItemavertissementClick(Sender: TObject);
    procedure MenuItem_affichage_incertitudeClick(Sender: TObject);
    procedure MenuItem_affichage_individuelClick(Sender: TObject);
    procedure MenuItem_historiqueClick(Sender: TObject);
    procedure rafraichitstringgridentree(sender:tobject);
    procedure MenuItem_tutorielClick(Sender: TObject);




    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn33Click(Sender: TObject);

    procedure BitBtn4Click(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
    procedure BitBtn6Click(Sender: TObject);
    procedure BitBtn7Click(Sender: TObject);
    procedure BitBtn8Click(Sender: TObject);
    procedure BitBtn9Click(Sender: TObject);
    procedure BitBtnpropagationClick(Sender: TObject);

    procedure BitBtn_fonctionClick(Sender: TObject);
    procedure Edit_saisie_expressionChange(Sender: TObject);


    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Label1Click(Sender: TObject);
    procedure MenuItem13Click(Sender: TObject);
    procedure MenuItem3Click(Sender: TObject);
    procedure MenuItem5Click(Sender: TObject);
    procedure MenuItem8Click(Sender: TObject);
    procedure MenuItem9Click(Sender: TObject);
    procedure MenuItem_arrondi_normal_incClick(Sender: TObject);
    procedure MenuItem_arrondi_sup_incClick(Sender: TObject);
    procedure Enregistrer(nom_fifichier:string;Sender: TObject);
    procedure MenuItem_enregistrerClick(Sender: TObject);
    procedure MenuItem_enregistrer_exemplesClick(Sender: TObject);
    procedure MenuItem_enregistrer_persoClick(Sender: TObject);
    procedure MenuItem_incertitudeClick(Sender: TObject);
    procedure MenuItem_montecarloClick(Sender: TObject);
    procedure MenuItem_nouveauClick(Sender: TObject);
    procedure MenuItem_ouvrir_dernierClick(Sender: TObject);
    procedure MenuItem_ouvrir_exemplesClick(Sender: TObject);
    procedure MenuItem_ouvrir_personnelClick(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
     procedure SpeedButton15Click(Sender: TObject);
    procedure SpeedButton10Click(Sender: TObject);
    procedure SpeedButton11Click(Sender: TObject);
    procedure SpeedButton12Click(Sender: TObject);
    procedure SpeedButton13Click(Sender: TObject);
    procedure SpeedButton14Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure AffichePageDansNavigateur(nom_fichier_html:string; Sender: TObject);


    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);



    procedure RemetAZero(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
    procedure SpeedButton7Click(Sender: TObject);
    procedure SpeedButton8Click(Sender: TObject);
    procedure SpeedButton9Click(Sender: TObject);
    procedure SpeedButton_paslegitime1Click(Sender: TObject);
    procedure SpeedButton_paslegitime2Click(Sender: TObject);
    procedure StaticText11Click(Sender: TObject);
    procedure StaticText13Click(Sender: TObject);
    procedure ChargerFichier(nom_fifichier:string;Sender: TObject);
    procedure StringGrid1PrepareCanvas(sender: TObject; aCol, aRow: Integer;
      aState: TGridDrawState);
    procedure StringGrid_entreeMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure StringGrid_entreeMouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: Integer);
    procedure StringGrid_entreePrepareCanvas(sender: TObject; aCol,
      aRow: Integer; aState: TGridDrawState);

    procedure TabSheet_entreeShow(Sender: TObject);
    procedure TabSheet_expressionShow(Sender: TObject);
    procedure TabSheet_gum2Show(Sender: TObject);
    procedure TabSheet_mcShow(Sender: TObject);
    procedure TabSheet_resultatsShow(Sender: TObject);
  private
      encreation:boolean;
    { private declarations }
  public
    { public declarations }
  end; 

  type
    type_correlation=(c_correlation,c_covariance);
    descripteur_correlation=object
      valeur:extended;
      t_correlation:type_correlation ;
    end;
    distribution_descripteur_correlation=array of array of descripteur_correlation;

    type_AB=(type_A,type_B);
    type_distribution=(d_normale,d_student,d_rectangle,d_triangle,d_trapeze,d_arcsin);
    type_defini_par=(par_incertitude_type,par_ecart_type_echantionnal,par_incertitude_elargie,par_demi_etendue);
    distribution=object
      tyty:type_distribution;
    tyAB:type_AB;
    nom_variable,descriptif:string;
   moyenne,incertitude_type,demi_etendue,incertitude_elargie,
     pourcentage,ecart_type_echantionnal,demi_etendue_bas,demi_etendue_haut:extended;
   degres_de_liberte:integer;
   indice_de_la_variable_correspondante:integer;
   defini_par:type_defini_par;
   inc_rel_sur_inc, degres_de_liberte_effectif:extended;
      student_nombre_mesures:integer;
   student_liste_mesures:array of extended;
    end;

    distributionarray=array of distribution;
    defini_par_array=array of type_defini_par;
    booleanarray=array of boolean;

    mesurande=object
      estimateur:extended;
      nom_mesurande,descriptif_mesurande:string;
           nombre_erreurs:integer;
           liste_des_indices_des_sources_derreur:integerarray;
      incertitude_type:extended;
    end;
    mesurandearray=array of mesurande;


var
  mon_genre_affichage_incertitude:type_affichage_incertitude;
  mon_genre_affichage_valeur_individuelle:type_affichage_valeur_individuelle;
  ma_longueur_chaine_agreable_valeur_individuelle,ma_longueur_chaine_agreable_incertitude:integer;
  existe_correlation:boolean;
  liste_descripteur_correlation:distribution_descripteur_correlation;
  echantillon_inexploitable:boolean;    parametre_ligne_commande:boolean;
  Form1: TForm1;    tous_calculs_faits:boolean;
   Liste_Variables : TStringList;
 old_chaine_expr,chaine_expr:string;
   expr_temp:texpression;
   nombre_mesurandes,nombre_distributions:integer;
   estimations,incertitudes_type:extendedarray;
   liste_mesurandes:mesurandearray;
   liste_distributions:distributionarray;
   liste_distribution_est_traitee,liste_mesurande_est_traitee:booleanarray;
     { colonne,ligne,}indice_distribution,indice_mesurande:integer;
   copie_liste_echantillons_entree,liste_echantillons_entree:extendedarrayarray;
    nombre_par_echantillon:longint;
    puissance_de_nombre_par_echantillon:longint;
    nombre_de_classes:longint;    skewness_sortie,kurtosis_sortie:extended;
    liste_images_densite,liste_images_integre:imagearray ;
    hauteur_image_densite,largeur_image_densite,hauteur_image_integre,largeur_image_integre:integer;
     moyenne_sortie,ecart_type_sortie,borne_inf_court_95,borne_sup_court_95,borne_inf_sym_95,borne_sup_sym_95,
     borne_inf_court_99,borne_sup_court_99,borne_inf_sym_99,borne_sup_sym_99,
     borne_inf_court_75,borne_sup_court_75,borne_inf_sym_75,borne_sup_sym_75:extended;
     Eval_f    : TEvaluator;
     eval_derivees:array of tevaluator;
     expr_derivees:array of texpression;
     eval_derivees_secondes:array of array of tevaluator;
     expr_derivees_secondes:array of array of texpression;
      eval_derivees_troisiemes:array of array of tevaluator;
     expr_derivees_troisiemes:array of array of texpression;

     liste_echantillon_sortie,valeur_derivees:extendedarray;
     valeur_derivees_secondes:array of array of extended;

      valeur_derivees_troisiemes:array of array of extended;

    contributions_croisees:array of array of extended;

     estimateur_sortie,incertitude_type_sortie,incertitude_type_sortie_ordre1,incertitude_type_sortie_ordre2,degre_effectif_global:extended;
     expression_validee:boolean;
      coef_elarg_95_normale,coef_elarg_99_normale,coef_elarg_75_normale,
coef_elarg_95_student,coef_elarg_99_student,coef_elarg_75_student:extended;
 symbole_grandeur_sortie,symbole_unite:string;

 option_tronque_a_zero_quand_incertitude_trop_grande:boolean;
   option_arrondi_superieur_incertitude:boolean;


   repertoire_executable,repertoire_images,nomexecutable,repertoire_exemples:string;
   repertoire_aide,repertoire_config_perso,repertoire_propagation_perso:string;
    lang,FallbackLang,nom_ini_file,chemin_po,nom_fichier_sauvegarde:string;
    liste_langues:tstringlist;

     Search:sysutils.TSearchRec;
        ID_lang:string;   nom_fichier_chargement,
        dernier_repertoire_utilise_chargement,dernier_repertoire_utilise_sauvegarde,PODirectory: String;
          f_ini:textfile;

     ecart_normale_avec_mc,une_seule_rectangulaire,ecart_student_avec_mc:boolean;
       ecart_max_tolere:integer;

     function isnanorinfinite(x:float):boolean;

  procedure CopyStringGridToClipboard(st:tstringgrid);
  function myfloattostr(x:extended):string;
  function mystrtofloat(s:string):extended;
  function isligne_distribution(row:integer; var indice_variable_pour_modif_source_erreur_a_debut_zero,
  indice_distribution_a_debut_zero:integer):boolean;
  procedure initialise_correlations;
  function isligne_mesurande(row:integer; var indice_variable_pour_ajout_source_erreur_a_debut_zero:integer):boolean;
var i,li:integer;

           procedure Effacer_Element_Tableau_Distributions(var A: distributionArray; const Index: Cardinal);
            procedure Effacer_Element_Tableau_Reel(var A: extendedArray; const Index: Cardinal);
             procedure Effacer_Element_Tableau_Tableau_Correlation(const Index: integer);
          function isligne_intercalaire(row:integer):boolean;
implementation

label 1888;

  procedure Effacer_Element_Tableau_Tableau_Correlation(const Index: integer);
var             i,j:integer;
          begin

     if index=nombre_distributions-1 then begin
          setlength(liste_descripteur_correlation,nombre_distributions-1,nombre_distributions-1);
     exit;
     end;

     for i:=index+1 to nombre_distributions-1 do
     for j:=0 to nombre_distributions-1 do
     liste_descripteur_correlation[i-1,j]:=liste_descripteur_correlation[i,j];

      for j:=index+1 to nombre_distributions-1 do
     for i:=0 to nombre_distributions-1 do
     liste_descripteur_correlation[i,j-1]:=liste_descripteur_correlation[i,j];


     setlength(liste_descripteur_correlation,nombre_distributions-1,nombre_distributions-1);

                   end;


          procedure Effacer_Element_Tableau_Reel(var A: extendedArray; const Index: Cardinal);
           var
                  ALength: Cardinal;
                   TailElements: Cardinal;
                 begin
                    ALength := Length(A);
                    if ALength=0 then exit;
                     if Index>=ALength then exit;
                     if Index<0 then exit;
                     Finalize(A[Index]);
                      TailElements := ALength - Index-1;
                      if TailElements > 0 then
                        Move(A[Index + 1], A[Index], SizeOf(float) * TailElements);
                       Initialize(A[ALength - 1]);
                       SetLength(A, ALength - 1);
                   end;

     procedure Effacer_Element_Tableau_Distributions(var A: distributionArray; const Index: Cardinal);
           var
                  ALength: Cardinal;
                   TailElements: Cardinal;
                 begin
                    ALength := Length(A);
                    if ALength=0 then exit;
                     if Index>=ALength then exit;
                     if Index<0 then exit;
                     Finalize(A[Index]);
                      TailElements := ALength - Index-1;
                      if TailElements > 0 then
                        Move(A[Index + 1], A[Index], SizeOf(distribution) * TailElements);
                       Initialize(A[ALength - 1]);
                       SetLength(A, ALength - 1);
                   end;





   function myfloattostr(x:extended):string;
   begin
   if not(isnanorinfinite(x)) then result:=(floattostr(x)) else
      result:=('NAN');



   end;

  function mystrtofloat(s:string):extended;
   begin
   if upcase(s)<>'NAN' then result:=strtofloat(s) else
      result:=NAN;
   end;

procedure CopyStringGridToClipboard(st:tstringgrid);
  var
  i, j : integer;
  text : string;
begin
  for i:= 0 to (st.RowCount - 1) do   //Pour chaque ligne
  begin
    for j := 0 to (st.ColCount - 1) do   //Pour chaque colonne
    begin
      if j < (st.ColCount - 1) then   //si pas dernière colonne
        text := text + st.Cells[j,i] + #9   //ajoute contenu de la cellule + une tabulation (cellule suivante)
      else
        text := text + st.Cells[j,i];  //ajoute juste le contenu de la cellule
    end;
    text := text + lineending;  //Ajoute un saut de ligne
  end;
  Clipboard.AsText := Text;   //copie dans le presse papier les informations
  end;




Function MyGetAppConfigDirUTF8: String;
{il est necessaire de modifier GetAppConfigDir acr sur les systemes
windows renvoie local setting\application data au lieu de application data}
var
  I: Integer;
  EnvVars: TStringList;
begin
{$ifndef windows}
result:=systoutf8(SysUtils.GetAppConfigDir(false));
{$endif}
 {$ifdef windows}
  EnvVars := TStringList.Create;
try
       for I := 0 to GetEnvironmentVariableCount - 1 do
      EnvVars.Add(GetEnvironmentString(I));
        result:=systoutf8(AppendPathDelim(EnvVars.Values['APPDATA'])+'gum_mc\');

  finally
    EnvVars.Free;
  end;
  {$endif}
end;



Function ExpandEnvironmentString(s: String): String;
    Var i, k: Integer;
        sl: TStringList;
        s2: String;
        bP, bD: Boolean;
    Begin
      Result := s;
      bP := Pos('%', s) > 0;
      bD := Pos('$', s) > 0;
      If Not(bP Or bD) Then Exit; // Nichts zu konvertieren
      sl := TStringList.Create;
      sl.Sorted := bD;
      For i := GetEnvironmentVariableCount - 1 DownTo 0 Do // Alle Variablen in eine Liste merken
      Begin
        s2 := GetEnvironmentStringUTF8(i);
        If Length(s2) >= 2 Then
          If s2[1] <> '=' Then // Bei Windows kommt sowas auch vor, daher wegoptimieren
            sl.Add(s2);
      end;

      k := 0;
      Repeat // Durchlaufe so oft bis alle Env-Variablen aufgelöst sind
        s2 := Result;
        For i := sl.Count - 1 DownTo 0 Do
        Begin
          If bP Then
          Begin
            Result := StringReplace(Result, '%' + sl.Names[i] + '%', sl.ValueFromIndex[i], [rfReplaceAll, rfIgnoreCase]);
            If Pos('%', Result) = 0 Then bP := False;
          end;
          If bD Then
          Begin
            Result := StringReplace(Result, '$' + sl.Names[i], sl.ValueFromIndex[i], [rfReplaceAll]);
            If Pos('$', Result) = 0 Then bD := False;
          end;
          If Not(bP Or bD) Then Break;
        end;
        If Not(bP Or bD) Then Break;
        If SameText(s2, Result) Then Break; // % $ nicht konvertierbar, da im System nicht vorhanden
        Inc(k);
        If k > sl.Count - 2 Then Break; // Max Durchläufe
      Until True;
      sl.Free;
    end;




{$ifdef windows}
Function MyGetMesDocumentsUTF8: String;
var
    Reg: TRegistry;

begin

  Reg := TRegistry.Create;
  try
    Reg.RootKey := HKEY_CURRENT_USER;
    Reg.OpenKey('Software\Microsoft\Windows\CurrentVersion\'
      + 'Explorer\User Shell Folders\', False);
    result:=ExpandEnvironmentString(Reg.ReadString('Personal'));
  finally
    Reg.Free;

  end;
    end;
     {$endif}



function MyIsnan(x: float): boolean;
  {-Return true if x is a NaN}
begin
  with TExtRec(x) do begin
    MyIsnan := (xp and $7FFF=$7FFF) and ((hm<>longint($80000000)) or (lm<>0));
  end;
end;



function isnanorinfinite(x:float):boolean;
 begin
 result:=(myisnan(x) or isinfinite(x));
 end;




{ TForm1 }

procedure TForm1.FormResize(Sender: TObject);
begin













end;

procedure TForm1.FormShow(Sender: TObject);
begin
  // if encreation then begin scalefont(self); encreation:=false; end;
end;

procedure TForm1.Label1Click(Sender: TObject);
begin

end;

procedure TForm1.MenuItem13Click(Sender: TObject);
label 1111;
begin
  if not(tous_calculs_faits) then begin
  application.MessageBox(pchar(rsIlFautAvoirE), pchar(rsAttention), mb_ok);
    exit;
  end;

  1111:
  savedialog1.InitialDir:=dernier_repertoire_utilise_sauvegarde;
  savedialog1.Filter:='Gum_mc v2|*.gum2';
  savedialog1.FileName:='';
  if not(savedialog1.Execute) then exit else
    nom_fichier_sauvegarde:=savedialog1.FileName;

    if  fileexistsutf8(nom_fichier_sauvegarde) then

 if  application.MessageBox(pchar(Format(rsLeFichierExi, [nom_fichier_sauvegarde
   ])),
  pchar(rsAttention2), mb_yesno)=mrno then goto 1111;


  if (AppendPathDelim(extractfilepath(nom_fichier_sauvegarde))<>repertoire_exemples)
  and (AppendPathDelim(extractfilepath(nom_fichier_sauvegarde))<>repertoire_propagation_perso)
  then dernier_repertoire_utilise_sauvegarde:=AppendPathDelim(extractfilepath(nom_fichier_sauvegarde));
  Form1.Enregistrer(nom_fichier_sauvegarde,Sender);
end;

procedure TForm1.MenuItem3Click(Sender: TObject);
begin
  formgpl:=tformgpl.create(self);
 with formgpl
do begin
if screen.width>width then left:=(screen.width-width) div 2 else left:=0;
if screen.height>height then top:=(screen.height-height) div 2 else top:=0;
end;
//formgpl.Memogpl.Clear;
//formgpl.Memogpl.Lines.LoadFromFile(UTF8ToSys(repertoireexecutable+'gpl.txt'));
formgpl.ShowModal;
end;

procedure TForm1.MenuItem5Click(Sender: TObject);
begin
  with form4
do begin
if screen.width>width then left:=(screen.width-width) div 2 else left:=0;
if screen.height>height then top:=(screen.height-height) div 2 else top:=0;
end;
form4.showmodal;
end;

procedure TForm1.MenuItem8Click(Sender: TObject);
var
  v: THTMLBrowserHelpViewer;
  BrowserPath, BrowserParams: string;
  p: LongInt;
  URL: String;
  BrowserProcess: TProcessUTF8;
begin
  v:=THTMLBrowserHelpViewer.Create(nil);
  try
    v.FindDefaultBrowser(BrowserPath,BrowserParams);
    //debugln(['Path=',BrowserPath,' Params=',BrowserParams]);

   url:='http://jeanmarie.biansan.free.fr/logiciel.html';
    p:=System.Pos('%s', BrowserParams);
    System.Delete(BrowserParams,p,2);
    System.Insert(URL,BrowserParams,p);

    // start browser
    BrowserProcess:=TProcessUTF8.Create(nil);
    try
      BrowserProcess.CommandLine:=BrowserPath+' '+BrowserParams;
      BrowserProcess.Execute;
    finally
      BrowserProcess.Free;
    end;
  finally
    v.Free;
end; end;

procedure TForm1.MenuItem9Click(Sender: TObject);
var n:integer; f:textfile;
begin
n:=(Sender as TComponent).Tag;
if n<=1000 then exit;
if liste_langues[n-1000-1]=fallbacklang then exit;

application.MessageBox('Pour prendre en compte le changement de langue de l''interface, Dozzzaqueux doit maintenant être arrété. Puis relancez le.','Changement de langue',mb_ok);


               assignfile(f,UTF8ToSys(nom_ini_file));
        rewrite(f);
        writeln(f,liste_langues[n-1000-1]+'_'+uppercase(liste_langues[n-1000-1]));
               writeln(f,liste_langues[n-1000-1]);
        closefile(f);

 application.Terminate;
end;

procedure TForm1.MenuItem_arrondi_normal_incClick(Sender: TObject);
begin
  Form1.MenuItem_arrondi_sup_inc.Checked:=false;
  Form1.MenuItem_arrondi_normal_inc.Checked:=true;
  option_arrondi_superieur_incertitude:=false;
end;

procedure TForm1.MenuItem_arrondi_sup_incClick(Sender: TObject);
begin
  Form1.MenuItem_arrondi_sup_inc.Checked:=true;
  Form1.MenuItem_arrondi_normal_inc.Checked:=false;
  option_arrondi_superieur_incertitude:=true;
end;

procedure TForm1.Enregistrer(nom_fifichier:string;Sender: TObject);
var liste_lignes_a_sauver:tstringlist;
 i,j,iii:integer;
begin

   liste_lignes_a_sauver:=tstringlist.Create;
     liste_lignes_a_sauver.Add('VERSION 2');
   liste_lignes_a_sauver.Add('option_tronque_a_zero_quand_incertitude_trop_grande');
   if option_tronque_a_zero_quand_incertitude_trop_grande then
    liste_lignes_a_sauver.Add('true') else liste_lignes_a_sauver.Add('false');

 liste_lignes_a_sauver.Add('option_arrondi_superieur_incertitude');
   if option_arrondi_superieur_incertitude then
    liste_lignes_a_sauver.Add('true') else liste_lignes_a_sauver.Add('false');

  liste_lignes_a_sauver.Add('genre_affichage_incertitude');
  case mon_genre_affichage_incertitude of
    sans_point_decimal:   liste_lignes_a_sauver.Add('sans_point_decimal');
    sans_puissance_de_dix:   liste_lignes_a_sauver.Add('sans_puissance_de_dix');
     avec_un_chiffre_avant_virgule_pour_valeur:   liste_lignes_a_sauver.Add('avec_un_chiffre_avant_virgule_pour_valeur');
      avec_un_chiffre_avant_virgule_pour_incertitude:   liste_lignes_a_sauver.Add('avec_un_chiffre_avant_virgule_pour_incertitude');
      end;
    liste_lignes_a_sauver.Add('longueur_chaine_agreable_incertitude');
    liste_lignes_a_sauver.Add(inttostr(ma_longueur_chaine_agreable_incertitude));



   liste_lignes_a_sauver.Add('genre_affichage_valeur_individuelle');
  case mon_genre_affichage_valeur_individuelle of
    _sans_point_decimal:   liste_lignes_a_sauver.Add('_sans_point_decimal');
    _sans_puissance_de_dix:   liste_lignes_a_sauver.Add('_sans_puissance_de_dix');
     _avec_un_chiffre_avant_virgule:   liste_lignes_a_sauver.Add('_avec_un_chiffre_avant_virgule');
            end;
      liste_lignes_a_sauver.Add('longueur_chaine_agreable_valeur_individuelle');
     liste_lignes_a_sauver.Add(inttostr(ma_longueur_chaine_agreable_valeur_individuelle));

                liste_lignes_a_sauver.Add('nombre_par_echantillon');
                liste_lignes_a_sauver.Add(inttostr(nombre_par_echantillon));


                liste_lignes_a_sauver.Add('nombre_de_classes');
                liste_lignes_a_sauver.Add(inttostr(nombre_de_classes));

             liste_lignes_a_sauver.Add('symbole_grandeur_sortie');
             liste_lignes_a_sauver.Add(symbole_grandeur_sortie);

             liste_lignes_a_sauver.Add('symbole_unite');
             liste_lignes_a_sauver.Add(symbole_unite);

            liste_lignes_a_sauver.Add('expression');
            liste_lignes_a_sauver.Add(chaine_expr);

            liste_lignes_a_sauver.Add('nombre_mesurandes');
            liste_lignes_a_sauver.Add(inttostr(nombre_mesurandes));

            for i:=1 to nombre_mesurandes do begin
             liste_lignes_a_sauver.Add('mesurande');
           liste_lignes_a_sauver.Add('nom_mesurande');
            liste_lignes_a_sauver.Add(liste_mesurandes[i-1].nom_mesurande);
             liste_lignes_a_sauver.Add('descriptif');
            liste_lignes_a_sauver.Add(liste_mesurandes[i-1].descriptif_mesurande);
            liste_lignes_a_sauver.Add('estimation');
                liste_lignes_a_sauver.Add(myfloattostr(liste_mesurandes[i-1].estimateur));
               liste_lignes_a_sauver.Add('nombre_erreurs');
                liste_lignes_a_sauver.Add(inttostr(liste_mesurandes[i-1].nombre_erreurs));
                liste_lignes_a_sauver.Add('liste_indices_erreurs');
               if  liste_mesurandes[i-1].nombre_erreurs>0 then
               for iii:=1 to liste_mesurandes[i-1].nombre_erreurs do
               liste_lignes_a_sauver.Add(inttostr(liste_mesurandes[i-1].liste_des_indices_des_sources_derreur[iii-1]));

            end;

             liste_lignes_a_sauver.Add('nombre_distributions');
            liste_lignes_a_sauver.Add(inttostr(nombre_distributions));

           for i:=1 to nombre_distributions do begin
           liste_lignes_a_sauver.Add('distribution');
           liste_lignes_a_sauver.Add('nom_variable');
            liste_lignes_a_sauver.Add(liste_distributions[i-1].nom_variable);
            liste_lignes_a_sauver.Add('indice_de_la_variable_correspondante');
             liste_lignes_a_sauver.Add(inttostr(liste_distributions[i-1].indice_de_la_variable_correspondante));

            liste_lignes_a_sauver.Add('descriptif');
            liste_lignes_a_sauver.Add(liste_distributions[i-1].descriptif);
            liste_lignes_a_sauver.Add('type_AB');
            if liste_distributions[i-1].tyAB=type_A then
            liste_lignes_a_sauver.Add('type_A') else
              liste_lignes_a_sauver.Add('type_B');
            liste_lignes_a_sauver.Add('type_distribution');
            case  liste_distributions[i-1].tyty of
             d_normale: liste_lignes_a_sauver.Add('d_normale');
              d_student: liste_lignes_a_sauver.Add('d_student');
               d_rectangle: liste_lignes_a_sauver.Add('d_rectangle');
                d_triangle: liste_lignes_a_sauver.Add('d_triangle');
                 d_trapeze: liste_lignes_a_sauver.Add('d_trapeze');
                  d_arcsin: liste_lignes_a_sauver.Add('d_arcsin');
                    end;
                 liste_lignes_a_sauver.Add('defini_par');
                case  liste_distributions[i-1].defini_par of
                 par_incertitude_type: liste_lignes_a_sauver.Add('par_incertitude_type');
                 par_ecart_type_echantionnal: liste_lignes_a_sauver.Add('par_ecart_type_echantionnal');
                 par_incertitude_elargie: liste_lignes_a_sauver.Add('par_incertitude_elargie');
                 par_demi_etendue: liste_lignes_a_sauver.Add('par_demi_etendue');
                end;
                liste_lignes_a_sauver.Add('parametres');
                liste_lignes_a_sauver.Add('moyenne');
                liste_lignes_a_sauver.Add(myfloattostr(liste_distributions[i-1].moyenne));
                 liste_lignes_a_sauver.Add('incertitude_type');
                liste_lignes_a_sauver.Add(myfloattostr(liste_distributions[i-1].incertitude_type));
                liste_lignes_a_sauver.Add('demi_etendue');
                liste_lignes_a_sauver.Add(myfloattostr(liste_distributions[i-1].demi_etendue));
                liste_lignes_a_sauver.Add('incertitude_elargie');
                liste_lignes_a_sauver.Add(myfloattostr(liste_distributions[i-1].incertitude_elargie));
                liste_lignes_a_sauver.Add('pourcentage');
                liste_lignes_a_sauver.Add(myfloattostr(liste_distributions[i-1].pourcentage));
                liste_lignes_a_sauver.Add('ecart_type_echantionnal');
                liste_lignes_a_sauver.Add(myfloattostr(liste_distributions[i-1].ecart_type_echantionnal));
                liste_lignes_a_sauver.Add('demi_etendue_bas');
                liste_lignes_a_sauver.Add(myfloattostr(liste_distributions[i-1].demi_etendue_bas));
                liste_lignes_a_sauver.Add('demi_etendue_haut');
                liste_lignes_a_sauver.Add(myfloattostr(liste_distributions[i-1].demi_etendue_haut));
                 liste_lignes_a_sauver.Add('degres_de_liberte');
                liste_lignes_a_sauver.Add(inttostr(liste_distributions[i-1].degres_de_liberte));
                liste_lignes_a_sauver.Add('inc_rel_sur_inc');
                liste_lignes_a_sauver.Add(myfloattostr(liste_distributions[i-1].inc_rel_sur_inc));
                liste_lignes_a_sauver.Add('degres_de_liberte_effectif');
                liste_lignes_a_sauver.Add(myfloattostr(liste_distributions[i-1].degres_de_liberte_effectif));
                 liste_lignes_a_sauver.Add('student_nombre_mesures');
                liste_lignes_a_sauver.Add(myfloattostr(liste_distributions[i-1].student_nombre_mesures));
                if ((liste_distributions[i-1].tyty=d_student) and (liste_distributions[i-1].student_nombre_mesures>1)) then
                for iii:=1 to  liste_distributions[i-1].student_nombre_mesures do
                liste_lignes_a_sauver.Add(myfloattostr(liste_distributions[i-1].student_liste_mesures[iii-1]));


           end;
            liste_lignes_a_sauver.Add('commentaires');
                liste_lignes_a_sauver.Add('nombre_lignes_commentaires');
                liste_lignes_a_sauver.Add(inttostr(memo_commentaires.Lines.Count));
                 if memo_commentaires.Lines.Count>0 then
                for iii:=1 to memo_commentaires.Lines.Count do
                liste_lignes_a_sauver.Add(memo_commentaires.Lines[iii-1]);
             liste_lignes_a_sauver.Add('correlations');
             for i:=1 to nombre_distributions do
             for j:=1 to nombre_distributions do  begin
               if liste_descripteur_correlation[i-1,j-1].t_correlation=c_correlation then
              liste_lignes_a_sauver.Add('c_correlation') else liste_lignes_a_sauver.Add('c_covariance');
              liste_lignes_a_sauver.Add(floattostr(liste_descripteur_correlation[i-1,j-1].valeur));
             end;
             liste_lignes_a_sauver.Add(floattostr(liste_descripteur_correlation[i-1,j-1].valeur));


         try
        liste_lignes_a_sauver.SaveToFile(utf8tosys(nom_fifichier));
         except
       application.MessageBox(pchar('Impossible d''écrire le fichier '+nom_fichier_sauvegarde+' ! Vérifiez les droits sur le dossier.'),
       pchar('Attention !'),mb_ok);

         end;


   liste_lignes_a_sauver.Free;

end;

procedure TForm1.MenuItem_enregistrerClick(Sender: TObject);
begin
  if not(tous_calculs_faits) then begin
  application.MessageBox(pchar(rsIlFautAvoirE), pchar(rsAttention), mb_ok);
    exit;
  end;
  if nom_fichier_sauvegarde<>'' then Form1.Enregistrer(nom_fichier_sauvegarde,Sender) else
    begin
  savedialog1.InitialDir:=repertoire_exemples;
  savedialog1.Filter:='Gum_mc v2|*.gum2';
   savedialog1.FileName:='';
  if not(savedialog1.Execute) then exit else
    nom_fichier_sauvegarde:=savedialog1.FileName;
   if (AppendPathDelim(extractfilepath(nom_fichier_sauvegarde))<>repertoire_exemples)
  and (AppendPathDelim(extractfilepath(nom_fichier_sauvegarde))<>repertoire_propagation_perso)
  then dernier_repertoire_utilise_sauvegarde:=AppendPathDelim(extractfilepath(nom_fichier_sauvegarde));
 Form1.Enregistrer(nom_fichier_sauvegarde,Sender);


    end;

end;

procedure TForm1.MenuItem_enregistrer_exemplesClick(Sender: TObject);
label 1111;
begin
   if not(tous_calculs_faits) then begin
  application.MessageBox(pchar(rsIlFautAvoirE), pchar(rsAttention), mb_ok);
    exit;
  end;

  1111:
  savedialog1.InitialDir:=repertoire_exemples;
  savedialog1.Filter:='Gum_mc v2|*.gum2';
   savedialog1.FileName:='';
  if not(savedialog1.Execute) then exit else
    nom_fichier_sauvegarde:=savedialog1.FileName;

    if  fileexistsutf8(nom_fichier_sauvegarde) then

 if  application.MessageBox(pchar(Format(rsLeFichierExi3, [
   nom_fichier_sauvegarde])),
  pchar(rsAttention2), mb_yesno)=mrno then goto 1111;


   if (AppendPathDelim(extractfilepath(nom_fichier_sauvegarde))<>repertoire_exemples)
  and (AppendPathDelim(extractfilepath(nom_fichier_sauvegarde))<>repertoire_propagation_perso)
  then dernier_repertoire_utilise_sauvegarde:=AppendPathDelim(extractfilepath(nom_fichier_sauvegarde));
 Form1.Enregistrer(nom_fichier_sauvegarde,Sender);
end;

procedure TForm1.MenuItem_enregistrer_persoClick(Sender: TObject);
label 1111;
begin
 if not(tous_calculs_faits) then begin
  application.MessageBox(pchar(rsIlFautAvoirE), pchar(rsAttention), mb_ok);
    exit;
  end;

1111:
  savedialog1.InitialDir:=repertoire_propagation_perso;
  savedialog1.Filter:='Gum_mc v2|*.gum2';
   savedialog1.FileName:='';
  if not(savedialog1.Execute) then exit else
    nom_fichier_sauvegarde:=savedialog1.FileName;

  if  fileexistsutf8(nom_fichier_sauvegarde) then

 if  application.MessageBox(pchar(Format(rsLeFichierExi2, [
   nom_fichier_sauvegarde])),
  pchar(rsAttention2), mb_yesno)=mrno then goto 1111;


   if (AppendPathDelim(extractfilepath(nom_fichier_sauvegarde))<>repertoire_exemples)
  and (AppendPathDelim(extractfilepath(nom_fichier_sauvegarde))<>repertoire_propagation_perso)
  then dernier_repertoire_utilise_sauvegarde:=AppendPathDelim(extractfilepath(nom_fichier_sauvegarde));


  Form1.Enregistrer(nom_fichier_sauvegarde,Sender);
end;

procedure TForm1.MenuItem_incertitudeClick(Sender: TObject);
begin

   with FormIncertitudeTropGrande do begin
  if screen.width>width then left:=(screen.width-width) div 2 else left:=0;
if screen.height>height then top:=(screen.height-height) div 2 else top:=0;
  if option_tronque_a_zero_quand_incertitude_trop_grande then radiogroup1.itemindex:=0 else
 radiogroup1.itemindex:=1;
end;
   FormIncertitudeTropGrande.showmodal;
   option_tronque_a_zero_quand_incertitude_trop_grande:=(FormIncertitudeTropGrande.RadioGroup1.ItemIndex=0);
end;

procedure TForm1.MenuItem_montecarloClick(Sender: TObject);
begin
   with Form_montecarlo do begin
  if screen.width>width then left:=(screen.width-width) div 2 else left:=0;
if screen.height>height then top:=(screen.height-height) div 2 else top:=0;
spinedit_puissance_de_N.value:=puissance_de_nombre_par_echantillon;
spinedit1.value:=nombre_de_classes;


end;
Form_montecarlo.showmodal;
end;

procedure TForm1.MenuItem_nouveauClick(Sender: TObject);
begin
   Form1.RemetAZero(Sender);
end;

procedure TForm1.MenuItem_ouvrir_dernierClick(Sender: TObject);
begin
  opendialog2.InitialDir:=dernier_repertoire_utilise_chargement;
    opendialog2.Filter:='Gum_mc (*.gum,*.gum2)|*.gum;*.gum2';
      opendialog2.FileName:='';
if not(opendialog2.Execute) then exit;
 nom_fichier_chargement:=opendialog2.FileName;

  if (AppendPathDelim(extractfilepath(nom_fichier_chargement))<>repertoire_exemples)
  and (AppendPathDelim(extractfilepath(nom_fichier_chargement))<>repertoire_propagation_perso)
  then dernier_repertoire_utilise_chargement:=AppendPathDelim(extractfilepath(nom_fichier_sauvegarde));

 ChargerFichier(nom_fichier_chargement,sender);
end;


procedure TForm1.RemetAZero(Sender: TObject);
   var i,iii:integer;
begin
   if nombre_distributions>0 then
      for iii:=1 to nombre_distributions do if liste_images_integre[iii-1]<>nil then liste_images_integre[iii-1].Free;
       if nombre_distributions>0 then
      for iii:=1 to nombre_distributions do if liste_images_densite[iii-1]<>nil then liste_images_densite[iii-1].Free;

 nombre_mesurandes:=0;
 nombre_distributions:=0;
 setlength(liste_mesurandes,0);
 setlength(liste_distributions,0);
 setlength( liste_descripteur_correlation,0,0);
  setlength(liste_distribution_est_traitee,0);
  expression_validee:=false;
    chaine_expr:='';
       old_chaine_expr:='';
       Edit_saisie_expression.Text:='';
       tous_calculs_faits:=false;
    nom_fichier_sauvegarde:='';
     nom_fichier_chargement:='';
     memo_commentaires.Clear;
       pagecontrol1.ActivePage:=tabsheet_expression;





end;

procedure initialise_correlations;
var i,j:integer;
 begin
 setlength(liste_descripteur_correlation,nombre_distributions,nombre_distributions);
 for i:=1 to  nombre_distributions do
 for j:=1 to nombre_distributions do begin
 liste_descripteur_correlation[i-1,j-1].t_correlation:=c_correlation;
 liste_descripteur_correlation[i-1,j-1].valeur:=0;
  end;


 end;

procedure TForm1.ChargerFichier(nom_fifichier:string;Sender: TObject);
var  s3,s1,s2,s,s4:string;   version2:boolean;
iii,i,nono,kkk,boucle:integer; rere:float;  toto:TCharEncStream; liste_lignes_fichier_gum:tstringlist;
expression_essai:string;  nom_variable,descri:string; indice_variable_a_traiter:integer;

begin




 toto:=TCharEncStream.create;
     try
       toto.LoadFromFile(UTF8ToSys(nom_fifichier));
      except
    application.MessageBox(pchar(Format(rsImpossibleDe, [nom_fifichier])),
    pchar(rsHLas), mb_ok);
    exit;
  end;


      Form1.RemetAZero(Sender);

      liste_lignes_fichier_gum:=tstringlist.Create;
      liste_lignes_fichier_gum.Text:=toto.UTF8Text;
      toto.Free;
  i:=0;

 inc(i);

 version2:=liste_lignes_fichier_gum[i-1]='VERSION 2';
  if version2 then inc(i);

 if liste_lignes_fichier_gum[i-1]='option_tronque_a_zero_quand_incertitude_trop_grande' then begin
       inc(i);
   option_tronque_a_zero_quand_incertitude_trop_grande:=liste_lignes_fichier_gum[i-1]='true';

   inc(i);
 end;

 if liste_lignes_fichier_gum[i-1]='option_arrondi_superieur_incertitude' then begin
      inc(i);
   option_arrondi_superieur_incertitude:=liste_lignes_fichier_gum[i-1]='true';
   inc(i);
   if option_arrondi_superieur_incertitude then begin
   Form1.MenuItem_arrondi_sup_inc.Checked:=true;
  Form1.MenuItem_arrondi_normal_inc.Checked:=false;
 end else begin
  Form1.MenuItem_arrondi_sup_inc.Checked:=false;
  Form1.MenuItem_arrondi_normal_inc.Checked:=true;
   end;
       end;



  if liste_lignes_fichier_gum[i-1]='genre_affichage_incertitude' then begin
  inc(i);

  if liste_lignes_fichier_gum[i-1]='sans_point_decimal' then mon_genre_affichage_incertitude:=sans_point_decimal;
  if liste_lignes_fichier_gum[i-1]='sans_puissance_de_dix'then mon_genre_affichage_incertitude:=sans_puissance_de_dix;
  if liste_lignes_fichier_gum[i-1]='avec_un_chiffre_avant_virgule_pour_valeur'then mon_genre_affichage_incertitude:=avec_un_chiffre_avant_virgule_pour_valeur;
  if liste_lignes_fichier_gum[i-1]='avec_un_chiffre_avant_virgule_pour_incertitude'then mon_genre_affichage_incertitude:=avec_un_chiffre_avant_virgule_pour_incertitude;

  inc(i);
  end;
   if liste_lignes_fichier_gum[i-1]='longueur_chaine_agreable_incertitude' then begin
  inc(i);
   ma_longueur_chaine_agreable_incertitude:=strtoint(liste_lignes_fichier_gum[i-1]);
   inc(i);
   end;


 if liste_lignes_fichier_gum[i-1]='genre_affichage_valeur_individuelle' then begin
  inc(i);

if liste_lignes_fichier_gum[i-1]='_sans_point_decimal' then  mon_genre_affichage_valeur_individuelle:=_sans_point_decimal;
 if liste_lignes_fichier_gum[i-1]= '_sans_puissance_de_dix'then  mon_genre_affichage_valeur_individuelle:=_sans_puissance_de_dix;
  if liste_lignes_fichier_gum[i-1]='_avec_un_chiffre_avant_virgule'then  mon_genre_affichage_valeur_individuelle:=_avec_un_chiffre_avant_virgule;

  inc(i);
  end;
   if liste_lignes_fichier_gum[i-1]='longueur_chaine_agreable_valeur_individuelle' then begin
  inc(i);
   ma_longueur_chaine_agreable_valeur_individuelle:=strtoint(liste_lignes_fichier_gum[i-1]);
   inc(i);
   end;





 if liste_lignes_fichier_gum[i-1]='nombre_par_echantillon' then begin
   inc(i);
   nombre_par_echantillon:=strtoint(liste_lignes_fichier_gum[i-1]);

   inc(i);
   end;


 if liste_lignes_fichier_gum[i-1]='nombre_de_classes' then begin
   inc(i);
   nombre_de_classes:=strtoint(liste_lignes_fichier_gum[i-1]);

   inc(i);
   end;


   if liste_lignes_fichier_gum[i-1]='symbole_grandeur_sortie' then begin
   inc(i);
   symbole_grandeur_sortie:=liste_lignes_fichier_gum[i-1];
   edit_nom_grandeur_sortie.Text:=symbole_grandeur_sortie;

   inc(i);
   end;



   if liste_lignes_fichier_gum[i-1]='symbole_unite' then begin
   inc(i);
   symbole_unite:=liste_lignes_fichier_gum[i-1];
   edit_saisie_unite.Text:=symbole_unite;

   inc(i);
   end;




   if liste_lignes_fichier_gum[i-1]='expression' then begin
     inc(i);
     expression_essai:=liste_lignes_fichier_gum[i-1];
     try
         Expr_temp:=TExpression.Create(expression_essai);

        except
                    application.MessageBox(pchar(rsErreurDeSynt),pchar( rsAttention), mb_ok);
                    Form1.RemetAZero(Sender);
                       exit;
          end;
        inc(i);
        end;

    expression_validee:=true;
    chaine_expr:=expression_essai;
       old_chaine_expr:=chaine_expr;
       Edit_saisie_expression.Text:=expression_essai;
      Liste_Variables:=Expr_temp.SymbolicValueNames;






    if version2 then begin


  if liste_lignes_fichier_gum[i-1]='nombre_mesurandes' then begin
     inc(i);
     try
    nombre_mesurandes:=strtoint(liste_lignes_fichier_gum[i-1]);

     except
        application.MessageBox(pchar(rsNombreDeMesu2), pchar(rsAttention), mb_ok
          );
        Form1.RemetAZero(Sender);
        exit;
     end;
     inc(i);
    end;


   if Liste_Variables.Count<>nombre_mesurandes then begin
     application.MessageBox(pchar(rsNombreDeMesu3), pchar(rsAttention), mb_ok);
     Form1.RemetAZero(Sender);
        exit;
     end;

        setlength(liste_mesurandes,nombre_mesurandes);

        for boucle:=1 to nombre_mesurandes do begin
          inc(i);
    if liste_lignes_fichier_gum[i-1]='nom_mesurande'  then begin
                   inc(i);
      liste_mesurandes[boucle-1].nom_mesurande:=liste_lignes_fichier_gum[i-1];
      if  liste_mesurandes[boucle-1].nom_mesurande<>Liste_Variables[boucle-1] then begin
        application.MessageBox(pchar(rsNomDuMesuran), pchar(rsAttention), mb_ok
          );
        Form1.RemetAZero(Sender);
        exit;
     end;
            inc(i);
            end;
       if liste_lignes_fichier_gum[i-1]='descriptif'  then begin
                   inc(i);
      liste_mesurandes[boucle-1].descriptif_mesurande:=liste_lignes_fichier_gum[i-1];
            inc(i);
            end;
        if liste_lignes_fichier_gum[i-1]='estimation'  then begin
                   inc(i);
      liste_mesurandes[boucle-1].estimateur:=mystrtofloat(liste_lignes_fichier_gum[i-1]);
            inc(i);
            end;
         if liste_lignes_fichier_gum[i-1]='nombre_erreurs'  then begin
                   inc(i);
      liste_mesurandes[boucle-1].nombre_erreurs:=strtoint(liste_lignes_fichier_gum[i-1]);
            inc(i);
            end;
         inc(i);

         setlength(liste_mesurandes[boucle-1].liste_des_indices_des_sources_derreur,liste_mesurandes[boucle-1].nombre_erreurs);
         if  liste_mesurandes[boucle-1].nombre_erreurs>0 then
         for kkk:=1 to  liste_mesurandes[boucle-1].nombre_erreurs do
         begin
          liste_mesurandes[boucle-1].liste_des_indices_des_sources_derreur[kkk-1]:=strtoint(liste_lignes_fichier_gum[i-1]);
          inc(i);
          end;
         end;   {boucle de lecture des mesurandes}




         if liste_lignes_fichier_gum[i-1]='nombre_distributions' then begin
     inc(i);
     try
    nombre_distributions:=strtoint(liste_lignes_fichier_gum[i-1]);

     except
        application.MessageBox(pchar(rsErreurSurLeN), pchar(rsAttention), mb_ok
          );
        Form1.RemetAZero(Sender);
        exit;
     end;
     inc(i);
    end;

       end; {version2}





    if not(version2) then begin
    nombre_mesurandes:=Liste_Variables.Count;

    nombre_distributions:=nombre_mesurandes;

      setlength(liste_mesurandes,nombre_mesurandes);
            end;


    setlength(liste_distributions,nombre_distributions);
  initialise_correlations;


    setlength(liste_distribution_est_traitee,nombre_distributions);
     for iii:=1 to nombre_distributions do begin
    if not(version2) then    liste_distributions[iii-1].nom_variable:=liste_variables[iii-1]+'_S1';

 if not(version2) then     liste_mesurandes[iii-1].nom_mesurande:=liste_variables[iii-1];
      liste_distributions[iii-1].descriptif:='';
      liste_distribution_est_traitee[iii-1]:=false;
      liste_distributions[iii-1].moyenne:=0;
      liste_distributions[iii-1].defini_par:=par_incertitude_type;
      liste_distributions[iii-1].tyty:=d_normale;
      liste_distributions[iii-1].tyAB:=type_B;
      liste_distributions[iii-1].degres_de_liberte:=0;
      liste_distributions[iii-1].degres_de_liberte_effectif:=0;
      liste_distributions[iii-1].demi_etendue:=0;
      liste_distributions[iii-1].demi_etendue_bas:=0;
      liste_distributions[iii-1].demi_etendue_haut:=0;
      liste_distributions[iii-1].ecart_type_echantionnal:=0;
      liste_distributions[iii-1].incertitude_elargie:=0;
      liste_distributions[iii-1].incertitude_type:=0;
      liste_distributions[iii-1].inc_rel_sur_inc:=0;
      liste_distributions[iii-1].pourcentage:=0;
      liste_distributions[iii-1].student_nombre_mesures:=0;
       end;

    setlength(liste_echantillons_entree,nombre_distributions);
    setlength(copie_liste_echantillons_entree,nombre_distributions);



     hauteur_image_densite:=form_trace.Image1.Height;
      largeur_image_densite:=form_trace.Image1.width;
      hauteur_image_integre:=form_trace.Image1.Height;
      largeur_image_integre:=form_trace.Image1.width;



    setlength(liste_images_integre,nombre_distributions);
    setlength(liste_images_densite,nombre_distributions);
    for iii:=1 to nombre_distributions do begin
     liste_images_integre[iii-1]:=TImage.Create(Self);
      liste_images_densite[iii-1]:=TImage.Create(Self);
      With liste_images_integre[iii-1] Do
  begin
  Parent:=Form1;
  Top:=0;
  Left:=0;
  Width:=largeur_image_integre;
  Height:=hauteur_image_integre;
  visible:=false;
  end;
  With liste_images_densite[iii-1] Do
  begin
  Parent:=Form1;
  Top:=0;
  Left:=0;
  Width:=largeur_image_densite;
  Height:=hauteur_image_integre;
  visible:=false;
  end;
      end;
     Initialise_Generateur(0);






     for boucle:=1 to nombre_distributions do begin

       if liste_lignes_fichier_gum[i-1]='distribution' then begin
     inc(i);

     if liste_lignes_fichier_gum[i-1]<>'nom_variable' then begin
     application.MessageBox(pchar(rsNom_variable), pchar(rsAttention3), mb_ok
       );
      exit;
      end;


    inc(i);
    nom_variable:=liste_lignes_fichier_gum[i-1];

      if not(version2) then begin
    indice_variable_a_traiter:=liste_variables.IndexOf(nom_variable);
    if  indice_variable_a_traiter=-1 then begin
    application.MessageBox(pchar(Format(rsVariableTrou, [nom_variable])), pchar(
      rsAttention3), mb_ok);
      exit;
      end;
    end else indice_variable_a_traiter:=boucle-1;

    if not(version2) then begin
    liste_distributions[indice_variable_a_traiter].indice_de_la_variable_correspondante:=indice_variable_a_traiter;
    liste_mesurandes[indice_variable_a_traiter].nombre_erreurs:=1;
    setlength( liste_mesurandes[indice_variable_a_traiter].liste_des_indices_des_sources_derreur,1);
    liste_mesurandes[indice_variable_a_traiter].liste_des_indices_des_sources_derreur[0]:=indice_variable_a_traiter;
      end;

    if version2 then begin
    liste_distributions[indice_variable_a_traiter].nom_variable:=nom_variable;
    inc(i); inc(i);
    liste_distributions[indice_variable_a_traiter].indice_de_la_variable_correspondante:=strtoint(liste_lignes_fichier_gum[i-1]);
            end;


   inc(i);

   if liste_lignes_fichier_gum[i-1]='descriptif' then begin
   inc(i);
   descri:=liste_lignes_fichier_gum[i-1];
   inc(i);
   end else descri:='';
  liste_distributions[indice_variable_a_traiter].descriptif:=descri;

   if liste_lignes_fichier_gum[i-1]<>'type_AB' then begin
    application.MessageBox(pchar(rsType_ABAtten), pchar(
      rsAttention3), mb_ok);
      exit;
      end;


    inc(i);
    if liste_lignes_fichier_gum[i-1]='type_A' then
   liste_distributions[indice_variable_a_traiter].tyAB:=type_A else
    liste_distributions[indice_variable_a_traiter].tyAB:=type_B  ;

     inc(i);

    if liste_lignes_fichier_gum[i-1]<>'type_distribution' then begin
    application.MessageBox(pchar(rsType_distrib), pchar(
      rsAttention3), mb_ok);
      exit;
      end;

   inc(i);
   if  liste_lignes_fichier_gum[i-1]='d_normale' then  liste_distributions[indice_variable_a_traiter].tyty:=d_normale;
   if  liste_lignes_fichier_gum[i-1]='d_student' then  liste_distributions[indice_variable_a_traiter].tyty:=d_student;
   if  liste_lignes_fichier_gum[i-1]='d_rectangle' then  liste_distributions[indice_variable_a_traiter].tyty:=d_rectangle;
   if  liste_lignes_fichier_gum[i-1]='d_triangle' then  liste_distributions[indice_variable_a_traiter].tyty:=d_triangle;
   if  liste_lignes_fichier_gum[i-1]='d_trapeze' then  liste_distributions[indice_variable_a_traiter].tyty:=d_trapeze;
   if  liste_lignes_fichier_gum[i-1]='d_arcsin' then  liste_distributions[indice_variable_a_traiter].tyty:=d_arcsin;
   inc(i);


   if liste_lignes_fichier_gum[i-1]<>'defini_par' then begin
    application.MessageBox(pchar(rsDefini_parAt), pchar(
      rsAttention3), mb_ok);
      exit;
      end;

   inc(i);
  if  liste_lignes_fichier_gum[i-1]='par_incertitude_type' then  liste_distributions[indice_variable_a_traiter].defini_par:=par_incertitude_type;
   if  liste_lignes_fichier_gum[i-1]='par_ecart_type_echantionnal' then  liste_distributions[indice_variable_a_traiter].defini_par:=par_ecart_type_echantionnal;
    if  liste_lignes_fichier_gum[i-1]='par_incertitude_elargie' then  liste_distributions[indice_variable_a_traiter].defini_par:=par_incertitude_elargie;
     if  liste_lignes_fichier_gum[i-1]='par_demi_etendue' then  liste_distributions[indice_variable_a_traiter].defini_par:=par_demi_etendue;
    inc(i);

 if liste_lignes_fichier_gum[i-1]<>'parametres' then begin
    application.MessageBox(pchar(rsParametresAt), pchar(
      rsAttention3), mb_ok);
      exit;
      end;

 inc(i);
  if liste_lignes_fichier_gum[i-1]<>'moyenne' then begin
    application.MessageBox(pchar(rsMoyenneAtten), pchar(
      rsAttention3), mb_ok);
      exit;
      end;
 inc(i);
 liste_distributions[indice_variable_a_traiter].moyenne:=0;
 if not(version2) then  liste_mesurandes[indice_variable_a_traiter].estimateur:=mystrtofloat(liste_lignes_fichier_gum[i-1]);


 inc(i);
 if liste_lignes_fichier_gum[i-1]<>'incertitude_type' then begin
    application.MessageBox(pchar(rsIncertitude_), pchar(
      rsAttention3), mb_ok);
      exit;
      end;
 inc(i);
 liste_distributions[indice_variable_a_traiter].incertitude_type:=mystrtofloat(liste_lignes_fichier_gum[i-1]);

 inc(i);
 if liste_lignes_fichier_gum[i-1]<>'demi_etendue' then begin
    application.MessageBox(pchar(rsDemi_etendue), pchar(
      rsAttention3), mb_ok);
      exit;
      end;
 inc(i);
 liste_distributions[indice_variable_a_traiter].demi_etendue:=mystrtofloat(liste_lignes_fichier_gum[i-1]);


  inc(i);
 if liste_lignes_fichier_gum[i-1]<>'incertitude_elargie' then begin
    application.MessageBox(pchar(rsIncertitude_2), pchar(
      rsAttention3), mb_ok);
      exit;
      end;
 inc(i);
 liste_distributions[indice_variable_a_traiter].incertitude_elargie:=mystrtofloat(liste_lignes_fichier_gum[i-1]);


 inc(i);
 if liste_lignes_fichier_gum[i-1]<>'pourcentage' then begin
    application.MessageBox(pchar(rsPourcentageA), pchar(
      rsAttention3), mb_ok);
      exit;
      end;
 inc(i);
 liste_distributions[indice_variable_a_traiter].pourcentage:=mystrtofloat(liste_lignes_fichier_gum[i-1]);



 inc(i);
 if liste_lignes_fichier_gum[i-1]<>'ecart_type_echantionnal' then begin
    application.MessageBox(pchar(rsEcart_type_e), pchar(
      rsAttention3), mb_ok);
      exit;
      end;
 inc(i);
 liste_distributions[indice_variable_a_traiter].ecart_type_echantionnal:=mystrtofloat(liste_lignes_fichier_gum[i-1]);


 inc(i);
 if liste_lignes_fichier_gum[i-1]<>'demi_etendue_bas' then begin
    application.MessageBox(pchar(rsDemi_etendue2), pchar(
      rsAttention3), mb_ok);
      exit;
      end;
 inc(i);
 liste_distributions[indice_variable_a_traiter].demi_etendue_bas:=mystrtofloat(liste_lignes_fichier_gum[i-1]);


  inc(i);
  if liste_lignes_fichier_gum[i-1]<>'demi_etendue_haut' then begin
     application.MessageBox(pchar(rsDemi_etendue3), pchar(
       rsAttention3), mb_ok);
       exit;
       end;
  inc(i);
  liste_distributions[indice_variable_a_traiter].demi_etendue_haut:=mystrtofloat(liste_lignes_fichier_gum[i-1]);


  inc(i);
  if liste_lignes_fichier_gum[i-1]<>'degres_de_liberte' then begin
     application.MessageBox(pchar(rsDegres_de_li), pchar(
       rsAttention3), mb_ok);
       exit;
       end;
  inc(i);
  liste_distributions[indice_variable_a_traiter].degres_de_liberte:=strtoint(liste_lignes_fichier_gum[i-1]);

 inc(i);
  if liste_lignes_fichier_gum[i-1]<>'inc_rel_sur_inc' then begin
     application.MessageBox(pchar(rsInc_rel_sur_), pchar(
       rsAttention3), mb_ok);
       exit;
       end;
  inc(i);
  liste_distributions[indice_variable_a_traiter].inc_rel_sur_inc:=mystrtofloat(liste_lignes_fichier_gum[i-1]);

 inc(i);
  if liste_lignes_fichier_gum[i-1]<>'degres_de_liberte_effectif' then begin
     application.MessageBox(pchar(rsDegres_de_li2), pchar(
       rsAttention3), mb_ok);
       exit;
       end;
  inc(i);
  liste_distributions[indice_variable_a_traiter].degres_de_liberte_effectif:=mystrtofloat(liste_lignes_fichier_gum[i-1]);

  inc(i);
  if liste_lignes_fichier_gum[i-1]<>'student_nombre_mesures'   then begin
     application.MessageBox(pchar(rsStudent_nomb), pchar(
       rsAttention3), mb_ok);
       exit;
       end;
  inc(i);
  liste_distributions[indice_variable_a_traiter].student_nombre_mesures:=strtoint(liste_lignes_fichier_gum[i-1]);

  if (liste_distributions[indice_variable_a_traiter].tyty=d_student) and (liste_distributions[indice_variable_a_traiter].student_nombre_mesures>1) then
  begin
  setlength(liste_distributions[indice_variable_a_traiter].student_liste_mesures,liste_distributions[indice_variable_a_traiter].student_nombre_mesures);
  for iii:=1 to  liste_distributions[indice_variable_a_traiter].student_nombre_mesures do
  begin
  inc(i);
  liste_distributions[indice_variable_a_traiter].student_liste_mesures[iii-1]:=mystrtofloat(liste_lignes_fichier_gum[i-1]);
  end; end;
 inc(i);





     {test si commentaire ds le champ de la variable: c'était un bug de la version 1.2}
    if ((liste_lignes_fichier_gum[i-1]='commentaires') and (boucle<nombre_distributions))   then begin
        inc(i,2);
   nono:=strtoint(liste_lignes_fichier_gum[i-1]);

   //memo_commentaires.Clear;
   if nono>0 then  for iii:=1 to nono do begin
   inc(i);

   // memo_commentaires.Lines.Add(liste_lignes_fichier_gum[i-1]);
   end;
     inc(i);
     end;


     screen.Cursor:=crhourglass;

  if policetitre=nil then begin

   policetitre:=tfont.Create;
     policetitre.Assign(form1.Font);
      policetitre.Style:=[fsbold,fsunderline];
      policetitre.Size:=12;
      policetitre.Color:=clblue;
  end;

  if policegraduation=nil then begin
  policegraduation:=tfont.Create;
      policegraduation.Assign(form1.font);
      policegraduation.Size:=10;
       policegraduation.Color:=clblue;
        end;
 case liste_distributions[indice_variable_a_traiter].tyty    of
 d_normale:begin
  Genere_Normale(liste_echantillons_entree[indice_variable_a_traiter],nombre_par_echantillon,  liste_distributions[indice_variable_a_traiter].moyenne,
 liste_distributions[indice_variable_a_traiter].incertitude_type);
    Copie_Distribution(liste_echantillons_entree[indice_variable_a_traiter],copie_liste_echantillons_entree[indice_variable_a_traiter],nombre_par_echantillon);
 Tri_Rapide(liste_echantillons_entree[indice_variable_a_traiter],nombre_par_echantillon);
 Decale_Doublons(liste_echantillons_entree[indice_variable_a_traiter],nombre_par_echantillon);
  mc.LimitesEtAxes(@liste_images_integre[indice_variable_a_traiter],liste_echantillons_entree[indice_variable_a_traiter][0],liste_echantillons_entree[indice_variable_a_traiter][nombre_par_echantillon-1],0
         ,1,0,1,liste_images_integre[indice_variable_a_traiter].width,
liste_images_integre[indice_variable_a_traiter].Height, rsFonctionDeDi,
  policetitre, true, clwhite, true, 1, clblack,
true,1,4,clblue,policegraduation, true,false,1,clblue,
clblack,'x','f(x)','','','','',
false ,true,false);
  nb_points_traces:=200;
 for kkk:=0 to nb_points_traces do begin
 mc.croixx(liste_echantillons_entree[indice_variable_a_traiter][0]+(liste_echantillons_entree[indice_variable_a_traiter][nombre_par_echantillon-1]-liste_echantillons_entree[indice_variable_a_traiter][0])*kkk/nb_points_traces,
 Fonction_Distribution(liste_echantillons_entree[indice_variable_a_traiter],nombre_par_echantillon,liste_echantillons_entree[indice_variable_a_traiter][0]+
 (liste_echantillons_entree[indice_variable_a_traiter][nombre_par_echantillon-1]-liste_echantillons_entree[indice_variable_a_traiter][0])*kkk/nb_points_traces),
 2,1,clblue,pmcopy,true);
 mc.croixx(liste_echantillons_entree[indice_variable_a_traiter][0]+(liste_echantillons_entree[indice_variable_a_traiter][nombre_par_echantillon-1]-liste_echantillons_entree[indice_variable_a_traiter][0])*kkk/nb_points_traces,
 Normale_integree(liste_distributions[indice_variable_a_traiter].moyenne,liste_distributions[indice_variable_a_traiter].incertitude_type,
 liste_echantillons_entree[indice_variable_a_traiter][0]+
 (liste_echantillons_entree[indice_variable_a_traiter][nombre_par_echantillon-1]-liste_echantillons_entree[indice_variable_a_traiter][0])*kkk/nb_points_traces),
 2,1,clred,pmcopy,true);
    end;

 Statistiques_Par_Classe(liste_echantillons_entree[indice_variable_a_traiter],nombre_par_echantillon,nombre_de_classes,
 bornes,effectifs,densites,eff_max,densite_max);


 mc.LimitesEtAxes(@liste_images_densite[indice_variable_a_traiter],bornes[0],bornes[nombre_de_classes],0
         ,densite_max,0,densite_max,liste_images_densite[indice_variable_a_traiter].width,
liste_images_densite[indice_variable_a_traiter].Height, rsDensitDeProb,
  policetitre, true, clwhite, true, 1, clblack,
true,1,4,clblue,policegraduation, true,false,1,clblue,
clblack,'x','f(x)','','','','',
false ,true,false);
 for kkk:=1 to nombre_de_classes do
 mc.MonRectangle(bornes[kkk-1],0,bornes[kkk],densites[kkk-1],clblue,true);
 for kkk:=0 to nb_points_traces do
 mc.croixx(liste_echantillons_entree[indice_variable_a_traiter][0]+(liste_echantillons_entree[indice_variable_a_traiter][nombre_par_echantillon-1]-liste_echantillons_entree[indice_variable_a_traiter][0])*kkk/nb_points_traces,
 Normale_densite(liste_distributions[indice_variable_a_traiter].moyenne,liste_distributions[indice_variable_a_traiter].incertitude_type,
 liste_echantillons_entree[indice_variable_a_traiter][0]+
 (liste_echantillons_entree[indice_variable_a_traiter][nombre_par_echantillon-1]-liste_echantillons_entree[indice_variable_a_traiter][0])*kkk/nb_points_traces),
 2,1,clred,pmcopy,true);




 end;
  d_student:begin
  Genere_Student(liste_echantillons_entree[indice_variable_a_traiter],nombre_par_echantillon,  liste_distributions[indice_variable_a_traiter].moyenne,
 liste_distributions[indice_variable_a_traiter].ecart_type_echantionnal, liste_distributions[indice_variable_a_traiter].degres_de_liberte);
 Copie_Distribution(liste_echantillons_entree[indice_variable_a_traiter],copie_liste_echantillons_entree[indice_variable_a_traiter],nombre_par_echantillon);
 Tri_Rapide(liste_echantillons_entree[indice_variable_a_traiter],nombre_par_echantillon);
 Decale_Doublons(liste_echantillons_entree[indice_variable_a_traiter],nombre_par_echantillon);
  mc.LimitesEtAxes(@liste_images_integre[indice_variable_a_traiter],liste_echantillons_entree[indice_variable_a_traiter][0],liste_echantillons_entree[indice_variable_a_traiter][nombre_par_echantillon-1],0
         ,1,0,1,liste_images_integre[indice_variable_a_traiter].width,
liste_images_integre[indice_variable_a_traiter].Height, rsFonctionDeDi,
  policetitre, true, clwhite, true, 1, clblack,
true,1,4,clblue,policegraduation, true,false,1,clblue,
clblack,'x','f(x)','','','','',
false ,true,false);
  nb_points_traces:=200;
 for kkk:=0 to nb_points_traces do begin
 mc.croixx(liste_echantillons_entree[indice_variable_a_traiter][0]+(liste_echantillons_entree[indice_variable_a_traiter][nombre_par_echantillon-1]-liste_echantillons_entree[indice_variable_a_traiter][0])*kkk/nb_points_traces,
 Fonction_Distribution(liste_echantillons_entree[indice_variable_a_traiter],nombre_par_echantillon,liste_echantillons_entree[indice_variable_a_traiter][0]+
 (liste_echantillons_entree[indice_variable_a_traiter][nombre_par_echantillon-1]-liste_echantillons_entree[indice_variable_a_traiter][0])*kkk/nb_points_traces),
 2,1,clblue,pmcopy,true);
 mc.croixx(liste_echantillons_entree[indice_variable_a_traiter][0]+(liste_echantillons_entree[indice_variable_a_traiter][nombre_par_echantillon-1]-liste_echantillons_entree[indice_variable_a_traiter][0])*kkk/nb_points_traces,
 student_integree(liste_distributions[indice_variable_a_traiter].moyenne,liste_distributions[indice_variable_a_traiter].ecart_type_echantionnal,
 liste_distributions[indice_variable_a_traiter].degres_de_liberte,liste_echantillons_entree[indice_variable_a_traiter][0]+
 (liste_echantillons_entree[indice_variable_a_traiter][nombre_par_echantillon-1]-liste_echantillons_entree[indice_variable_a_traiter][0])*kkk/nb_points_traces),
 2,1,clred,pmcopy,true);
    end;

 Statistiques_Par_Classe(liste_echantillons_entree[indice_variable_a_traiter],nombre_par_echantillon,nombre_de_classes,
 bornes,effectifs,densites,eff_max,densite_max);


 mc.LimitesEtAxes(@liste_images_densite[indice_variable_a_traiter],bornes[0],bornes[nombre_de_classes],0
         ,densite_max,0,densite_max,liste_images_densite[indice_variable_a_traiter].width,
liste_images_densite[indice_variable_a_traiter].Height, rsDensitDeProb,
  policetitre, true, clwhite, true, 1, clblack,
true,1,4,clblue,policegraduation, true,false,1,clblue,
clblack,'x','f(x)','','','','',
false ,true,false);
 for kkk:=1 to nombre_de_classes do
 mc.MonRectangle(bornes[kkk-1],0,bornes[kkk],densites[kkk-1],clblue,true);
 for kkk:=0 to nb_points_traces do
 mc.croixx(liste_echantillons_entree[indice_variable_a_traiter][0]+(liste_echantillons_entree[indice_variable_a_traiter][nombre_par_echantillon-1]-liste_echantillons_entree[indice_variable_a_traiter][0])*kkk/nb_points_traces,
 student_densite(liste_distributions[indice_variable_a_traiter].moyenne,liste_distributions[indice_variable_a_traiter].ecart_type_echantionnal,
 liste_distributions[indice_variable_a_traiter].degres_de_liberte,liste_echantillons_entree[indice_variable_a_traiter][0]+
 (liste_echantillons_entree[indice_variable_a_traiter][nombre_par_echantillon-1]-liste_echantillons_entree[indice_variable_a_traiter][0])*kkk/nb_points_traces),
 2,1,clred,pmcopy,true);



  end;
  d_rectangle:begin
  Genere_Rectangulaire(liste_echantillons_entree[indice_variable_a_traiter],nombre_par_echantillon,  liste_distributions[indice_variable_a_traiter].moyenne,
 liste_distributions[indice_variable_a_traiter].demi_etendue);
  Copie_Distribution(liste_echantillons_entree[indice_variable_a_traiter],copie_liste_echantillons_entree[indice_variable_a_traiter],nombre_par_echantillon);
 Tri_Rapide(liste_echantillons_entree[indice_variable_a_traiter],nombre_par_echantillon);
 Decale_Doublons(liste_echantillons_entree[indice_variable_a_traiter],nombre_par_echantillon);
  mc.LimitesEtAxes(@liste_images_integre[indice_variable_a_traiter],liste_echantillons_entree[indice_variable_a_traiter][0],liste_echantillons_entree[indice_variable_a_traiter][nombre_par_echantillon-1],0
         ,1,0,1,liste_images_integre[indice_variable_a_traiter].width,
liste_images_integre[indice_variable_a_traiter].Height, rsFonctionDeDi,
  policetitre, true, clwhite, true, 1, clblack,
true,1,4,clblue,policegraduation, true,false,1,clblue,
clblack,'x','f(x)','','','','',
false ,true,false);
  nb_points_traces:=200;
 for kkk:=0 to nb_points_traces do begin
 mc.croixx(liste_echantillons_entree[indice_variable_a_traiter][0]+(liste_echantillons_entree[indice_variable_a_traiter][nombre_par_echantillon-1]-liste_echantillons_entree[indice_variable_a_traiter][0])*kkk/nb_points_traces,
 Fonction_Distribution(liste_echantillons_entree[indice_variable_a_traiter],nombre_par_echantillon,liste_echantillons_entree[indice_variable_a_traiter][0]+
 (liste_echantillons_entree[indice_variable_a_traiter][nombre_par_echantillon-1]-liste_echantillons_entree[indice_variable_a_traiter][0])*kkk/nb_points_traces),
 2,1,clblue,pmcopy,true);
 mc.croixx(liste_echantillons_entree[indice_variable_a_traiter][0]+(liste_echantillons_entree[indice_variable_a_traiter][nombre_par_echantillon-1]-liste_echantillons_entree[indice_variable_a_traiter][0])*kkk/nb_points_traces,
 Rectangulaire_integree(liste_distributions[indice_variable_a_traiter].moyenne,liste_distributions[indice_variable_a_traiter].demi_etendue,
 liste_echantillons_entree[indice_variable_a_traiter][0]+
 (liste_echantillons_entree[indice_variable_a_traiter][nombre_par_echantillon-1]-liste_echantillons_entree[indice_variable_a_traiter][0])*kkk/nb_points_traces),
 2,1,clred,pmcopy,true);
    end;

 Statistiques_Par_Classe(liste_echantillons_entree[indice_variable_a_traiter],nombre_par_echantillon,nombre_de_classes,
 bornes,effectifs,densites,eff_max,densite_max);


 mc.LimitesEtAxes(@liste_images_densite[indice_variable_a_traiter],bornes[0],bornes[nombre_de_classes],0
         ,densite_max,0,densite_max,liste_images_densite[indice_variable_a_traiter].width,
liste_images_densite[indice_variable_a_traiter].Height, rsDensitDeProb,
  policetitre, true, clwhite, true, 1, clblack,
true,1,4,clblue,policegraduation, true,false,1,clblue,
clblack,'x','f(x)','','','','',
false ,true,false);
 for kkk:=1 to nombre_de_classes do
 mc.MonRectangle(bornes[kkk-1],0,bornes[kkk],densites[kkk-1],clblue,true);
 for kkk:=0 to nb_points_traces do
 mc.croixx(liste_echantillons_entree[indice_variable_a_traiter][0]+(liste_echantillons_entree[indice_variable_a_traiter][nombre_par_echantillon-1]-liste_echantillons_entree[indice_variable_a_traiter][0])*kkk/nb_points_traces,
 Rectangulaire_densite(liste_distributions[indice_variable_a_traiter].moyenne,liste_distributions[indice_variable_a_traiter].demi_etendue,
 liste_echantillons_entree[indice_variable_a_traiter][0]+
 (liste_echantillons_entree[indice_variable_a_traiter][nombre_par_echantillon-1]-liste_echantillons_entree[indice_variable_a_traiter][0])*kkk/nb_points_traces),
 2,1,clred,pmcopy,true);



  end;
  d_triangle:begin
   Genere_Triangulaire(liste_echantillons_entree[indice_variable_a_traiter],nombre_par_echantillon,  liste_distributions[indice_variable_a_traiter].moyenne,
 liste_distributions[indice_variable_a_traiter].demi_etendue);
    Copie_Distribution(liste_echantillons_entree[indice_variable_a_traiter],copie_liste_echantillons_entree[indice_variable_a_traiter],nombre_par_echantillon);
 Tri_Rapide(liste_echantillons_entree[indice_variable_a_traiter],nombre_par_echantillon);
 Decale_Doublons(liste_echantillons_entree[indice_variable_a_traiter],nombre_par_echantillon);
  mc.LimitesEtAxes(@liste_images_integre[indice_variable_a_traiter],liste_echantillons_entree[indice_variable_a_traiter][0],liste_echantillons_entree[indice_variable_a_traiter][nombre_par_echantillon-1],0
         ,1,0,1,liste_images_integre[indice_variable_a_traiter].width,
liste_images_integre[indice_variable_a_traiter].Height, rsFonctionDeDi,
  policetitre, true, clwhite, true, 1, clblack,
true,1,4,clblue,policegraduation, true,false,1,clblue,
clblack,'x','f(x)','','','','',
false ,true,false);
  nb_points_traces:=200;
 for kkk:=0 to nb_points_traces do begin
 mc.croixx(liste_echantillons_entree[indice_variable_a_traiter][0]+(liste_echantillons_entree[indice_variable_a_traiter][nombre_par_echantillon-1]-liste_echantillons_entree[indice_variable_a_traiter][0])*kkk/nb_points_traces,
 Fonction_Distribution(liste_echantillons_entree[indice_variable_a_traiter],nombre_par_echantillon,liste_echantillons_entree[indice_variable_a_traiter][0]+
 (liste_echantillons_entree[indice_variable_a_traiter][nombre_par_echantillon-1]-liste_echantillons_entree[indice_variable_a_traiter][0])*kkk/nb_points_traces),
 2,1,clblue,pmcopy,true);
 mc.croixx(liste_echantillons_entree[indice_variable_a_traiter][0]+(liste_echantillons_entree[indice_variable_a_traiter][nombre_par_echantillon-1]-liste_echantillons_entree[indice_variable_a_traiter][0])*kkk/nb_points_traces,
 Triangulaire_integree(liste_distributions[indice_variable_a_traiter].moyenne,liste_distributions[indice_variable_a_traiter].demi_etendue,
 liste_echantillons_entree[indice_variable_a_traiter][0]+
 (liste_echantillons_entree[indice_variable_a_traiter][nombre_par_echantillon-1]-liste_echantillons_entree[indice_variable_a_traiter][0])*kkk/nb_points_traces),
 2,1,clred,pmcopy,true);
    end;

 Statistiques_Par_Classe(liste_echantillons_entree[indice_variable_a_traiter],nombre_par_echantillon,nombre_de_classes,
 bornes,effectifs,densites,eff_max,densite_max);


 mc.LimitesEtAxes(@liste_images_densite[indice_variable_a_traiter],bornes[0],bornes[nombre_de_classes],0
         ,densite_max,0,densite_max,liste_images_densite[indice_variable_a_traiter].width,
liste_images_densite[indice_variable_a_traiter].Height, rsDensitDeProb,
  policetitre, true, clwhite, true, 1, clblack,
true,1,4,clblue,policegraduation, true,false,1,clblue,
clblack,'x','f(x)','','','','',
false ,true,false);
 for kkk:=1 to nombre_de_classes do
 mc.MonRectangle(bornes[kkk-1],0,bornes[kkk],densites[kkk-1],clblue,true);
 for kkk:=0 to nb_points_traces do
 mc.croixx(liste_echantillons_entree[indice_variable_a_traiter][0]+(liste_echantillons_entree[indice_variable_a_traiter][nombre_par_echantillon-1]-liste_echantillons_entree[indice_variable_a_traiter][0])*kkk/nb_points_traces,
 Triangulaire_densite(liste_distributions[indice_variable_a_traiter].moyenne,liste_distributions[indice_variable_a_traiter].demi_etendue,
 liste_echantillons_entree[indice_variable_a_traiter][0]+
 (liste_echantillons_entree[indice_variable_a_traiter][nombre_par_echantillon-1]-liste_echantillons_entree[indice_variable_a_traiter][0])*kkk/nb_points_traces),
 2,1,clred,pmcopy,true);


  end;
  d_trapeze:begin
  Genere_Trapeze(liste_echantillons_entree[indice_variable_a_traiter],nombre_par_echantillon,  liste_distributions[indice_variable_a_traiter].moyenne,
 liste_distributions[indice_variable_a_traiter].demi_etendue_bas,liste_distributions[indice_variable_a_traiter].demi_etendue_haut);
   Copie_Distribution(liste_echantillons_entree[indice_variable_a_traiter],copie_liste_echantillons_entree[indice_variable_a_traiter],nombre_par_echantillon);

 Tri_Rapide(liste_echantillons_entree[indice_variable_a_traiter],nombre_par_echantillon);
 Decale_Doublons(liste_echantillons_entree[indice_variable_a_traiter],nombre_par_echantillon);
  mc.LimitesEtAxes(@liste_images_integre[indice_variable_a_traiter],liste_echantillons_entree[indice_variable_a_traiter][0],liste_echantillons_entree[indice_variable_a_traiter][nombre_par_echantillon-1],0
         ,1,0,1,liste_images_integre[indice_variable_a_traiter].width,
liste_images_integre[indice_variable_a_traiter].Height, rsFonctionDeDi,
  policetitre, true, clwhite, true, 1, clblack,
true,1,4,clblue,policegraduation, true,false,1,clblue,
clblack,'x','f(x)','','','','',
false ,true,false);
  nb_points_traces:=200;
 for kkk:=0 to nb_points_traces do begin
 mc.croixx(liste_echantillons_entree[indice_variable_a_traiter][0]+(liste_echantillons_entree[indice_variable_a_traiter][nombre_par_echantillon-1]-liste_echantillons_entree[indice_variable_a_traiter][0])*kkk/nb_points_traces,
 Fonction_Distribution(liste_echantillons_entree[indice_variable_a_traiter],nombre_par_echantillon,liste_echantillons_entree[indice_variable_a_traiter][0]+
 (liste_echantillons_entree[indice_variable_a_traiter][nombre_par_echantillon-1]-liste_echantillons_entree[indice_variable_a_traiter][0])*kkk/nb_points_traces),
 2,1,clblue,pmcopy,true);
 mc.croixx(liste_echantillons_entree[indice_variable_a_traiter][0]+(liste_echantillons_entree[indice_variable_a_traiter][nombre_par_echantillon-1]-liste_echantillons_entree[indice_variable_a_traiter][0])*kkk/nb_points_traces,
 Trapeze_integree(liste_distributions[indice_variable_a_traiter].moyenne,liste_distributions[indice_variable_a_traiter].demi_etendue_bas,liste_distributions[indice_variable_a_traiter].demi_etendue_haut,
 liste_echantillons_entree[indice_variable_a_traiter][0]+
 (liste_echantillons_entree[indice_variable_a_traiter][nombre_par_echantillon-1]-liste_echantillons_entree[indice_variable_a_traiter][0])*kkk/nb_points_traces),
 2,1,clred,pmcopy,true);
    end;

 Statistiques_Par_Classe(liste_echantillons_entree[indice_variable_a_traiter],nombre_par_echantillon,nombre_de_classes,
 bornes,effectifs,densites,eff_max,densite_max);


 mc.LimitesEtAxes(@liste_images_densite[indice_variable_a_traiter],bornes[0],bornes[nombre_de_classes],0
         ,densite_max,0,densite_max,liste_images_densite[indice_variable_a_traiter].width,
liste_images_densite[indice_variable_a_traiter].Height, rsDensitDeProb,
  policetitre, true, clwhite, true, 1, clblack,
true,1,4,clblue,policegraduation, true,false,1,clblue,
clblack,'x','f(x)','','','','',
false ,true,false);
 for kkk:=1 to nombre_de_classes do
 mc.MonRectangle(bornes[kkk-1],0,bornes[kkk],densites[kkk-1],clblue,true);
 for kkk:=0 to nb_points_traces do
 mc.croixx(liste_echantillons_entree[indice_variable_a_traiter][0]+(liste_echantillons_entree[indice_variable_a_traiter][nombre_par_echantillon-1]-liste_echantillons_entree[indice_variable_a_traiter][0])*kkk/nb_points_traces,
 Trapeze_densite(liste_distributions[indice_variable_a_traiter].moyenne,liste_distributions[indice_variable_a_traiter].demi_etendue_bas,liste_distributions[indice_variable_a_traiter].demi_etendue_haut,
 liste_echantillons_entree[indice_variable_a_traiter][0]+
 (liste_echantillons_entree[indice_variable_a_traiter][nombre_par_echantillon-1]-liste_echantillons_entree[indice_variable_a_traiter][0])*kkk/nb_points_traces),
 2,1,clred,pmcopy,true);


  end;
  d_arcsin: begin
  Genere_Derivee_D_Arcsinus(liste_echantillons_entree[indice_variable_a_traiter],nombre_par_echantillon,  liste_distributions[indice_variable_a_traiter].moyenne,
 liste_distributions[indice_variable_a_traiter].demi_etendue);
    Copie_Distribution(liste_echantillons_entree[indice_variable_a_traiter],copie_liste_echantillons_entree[indice_variable_a_traiter],nombre_par_echantillon);
 Tri_Rapide(liste_echantillons_entree[indice_variable_a_traiter],nombre_par_echantillon);
 Decale_Doublons(liste_echantillons_entree[indice_variable_a_traiter],nombre_par_echantillon);
  mc.LimitesEtAxes(@liste_images_integre[indice_variable_a_traiter],liste_echantillons_entree[indice_variable_a_traiter][0],liste_echantillons_entree[indice_variable_a_traiter][nombre_par_echantillon-1],0
         ,1,0,1,liste_images_integre[indice_variable_a_traiter].width,
liste_images_integre[indice_variable_a_traiter].Height, rsFonctionDeDi,
  policetitre, true, clwhite, true, 1, clblack,
true,1,4,clblue,policegraduation, true,false,1,clblue,
clblack,'x','f(x)','','','','',
false ,true,false);
  nb_points_traces:=200;
 for kkk:=0 to nb_points_traces do begin
 mc.croixx(liste_echantillons_entree[indice_variable_a_traiter][0]+(liste_echantillons_entree[indice_variable_a_traiter][nombre_par_echantillon-1]-liste_echantillons_entree[indice_variable_a_traiter][0])*kkk/nb_points_traces,
 Fonction_Distribution(liste_echantillons_entree[indice_variable_a_traiter],nombre_par_echantillon,liste_echantillons_entree[indice_variable_a_traiter][0]+
 (liste_echantillons_entree[indice_variable_a_traiter][nombre_par_echantillon-1]-liste_echantillons_entree[indice_variable_a_traiter][0])*kkk/nb_points_traces),
 2,1,clblue,pmcopy,true);
 mc.croixx(liste_echantillons_entree[indice_variable_a_traiter][0]+(liste_echantillons_entree[indice_variable_a_traiter][nombre_par_echantillon-1]-liste_echantillons_entree[indice_variable_a_traiter][0])*kkk/nb_points_traces,
 Derivee_D_Arcsinus_integree(liste_distributions[indice_variable_a_traiter].moyenne,liste_distributions[indice_variable_a_traiter].demi_etendue,
 liste_echantillons_entree[indice_variable_a_traiter][0]+
 (liste_echantillons_entree[indice_variable_a_traiter][nombre_par_echantillon-1]-liste_echantillons_entree[indice_variable_a_traiter][0])*kkk/nb_points_traces),
 2,1,clred,pmcopy,true);
    end;

 Statistiques_Par_Classe(liste_echantillons_entree[indice_variable_a_traiter],nombre_par_echantillon,nombre_de_classes,
 bornes,effectifs,densites,eff_max,densite_max);


 mc.LimitesEtAxes(@liste_images_densite[indice_variable_a_traiter],bornes[0],bornes[nombre_de_classes],0
         ,densite_max,0,densite_max,liste_images_densite[indice_variable_a_traiter].width,
liste_images_densite[indice_variable_a_traiter].Height, rsDensitDeProb,
  policetitre, true, clwhite, true, 1, clblack,
true,1,4,clblue,policegraduation, true,false,1,clblue,
clblack,'x','f(x)','','','','',
false ,true,false);
 for kkk:=1 to nombre_de_classes do
 mc.MonRectangle(bornes[kkk-1],0,bornes[kkk],densites[kkk-1],clblue,true);
 for kkk:=0 to nb_points_traces do
 mc.croixx(liste_echantillons_entree[indice_variable_a_traiter][0]+(liste_echantillons_entree[indice_variable_a_traiter][nombre_par_echantillon-1]-liste_echantillons_entree[indice_variable_a_traiter][0])*kkk/nb_points_traces,
 Derivee_D_Arcsinus_densite(liste_distributions[indice_variable_a_traiter].moyenne,liste_distributions[indice_variable_a_traiter].demi_etendue,
 liste_echantillons_entree[indice_variable_a_traiter][0]+
 (liste_echantillons_entree[indice_variable_a_traiter][nombre_par_echantillon-1]-liste_echantillons_entree[indice_variable_a_traiter][0])*kkk/nb_points_traces),
 2,1,clred,pmcopy,true);

  end;
  end;
 liste_distribution_est_traitee[indice_variable_a_traiter]:=true;




 end;

   end; {de la boucle sur les variables}



 form1.rafraichitstringgridentree(sender);


  if liste_lignes_fichier_gum[i-1]<>'commentaires'   then begin
     application.MessageBox(pchar(rsCommentaires), pchar(
       rsAttention3), mb_ok);
       exit;
       end;
  inc(i);
   if liste_lignes_fichier_gum[i-1]<>'nombre_lignes_commentaires'   then begin
     application.MessageBox(pchar(rsNombre_ligne), pchar(
       rsAttention3), mb_ok);
       exit;
       end;
   inc(i);
   nono:=strtoint(liste_lignes_fichier_gum[i-1]);
   memo_commentaires.Clear;
   if nono>0 then  for iii:=1 to nono do begin
   inc(i);
    memo_commentaires.Lines.Add(liste_lignes_fichier_gum[i-1]);
   end;

if (version2 and (liste_lignes_fichier_gum.Count>i)) then begin
inc(i);
if liste_lignes_fichier_gum[i-1]='correlations' then begin
for iii:=1 to nombre_distributions do
for kkk:=1 to nombre_distributions do
begin
inc(i);
if  liste_lignes_fichier_gum[i-1]='c_correlation'
then liste_descripteur_correlation[iii-1,kkk-1].t_correlation:=c_correlation else
 liste_descripteur_correlation[iii-1,kkk-1].t_correlation:=c_covariance;
inc(i);
liste_descripteur_correlation[iii-1,kkk-1].valeur:=strtofloat(liste_lignes_fichier_gum[i-1]);
end;

end;

end;

 liste_lignes_fichier_gum.Free;

 nom_fichier_sauvegarde:=nom_fichier_chargement;

 pagecontrol1.ActivePage:=TabSheet_entree;
 Form1.BitBtn1Click(Sender);
  screen.Cursor:=crdefault;










end;

procedure TForm1.StringGrid1PrepareCanvas(sender: TObject; aCol, aRow: Integer;
  aState: TGridDrawState);
begin
  if existe_correlation  and (arow=1+nombre_distributions+2-1) then begin
   StringGrid1.Canvas.Brush.Color :=clBtnFace;

  end;
end;

procedure TForm1.MenuItem_ouvrir_exemplesClick(Sender: TObject);
begin
  opendialog2.InitialDir:=repertoire_exemples;
    opendialog2.Filter:='Gum_mc (*.gum,*.gum2)|*.gum;*.gum2';
        opendialog2.FileName:='';
if not(opendialog2.Execute) then exit;
 nom_fichier_chargement:=opendialog2.FileName;

  if (AppendPathDelim(extractfilepath(nom_fichier_chargement))<>repertoire_exemples)
  and (AppendPathDelim(extractfilepath(nom_fichier_chargement))<>repertoire_propagation_perso)
  then dernier_repertoire_utilise_chargement:=AppendPathDelim(extractfilepath(nom_fichier_sauvegarde));

 ChargerFichier(nom_fichier_chargement,sender);
end;

procedure TForm1.MenuItem_ouvrir_personnelClick(Sender: TObject);
begin
  opendialog2.InitialDir:=repertoire_propagation_perso;
    opendialog2.Filter:='Gum_mc (*.gum,*.gum2)|*.gum;*.gum2';
               opendialog2.FileName:='';
if not(opendialog2.Execute) then exit;
 nom_fichier_chargement:=opendialog2.FileName;

  if (AppendPathDelim(extractfilepath(nom_fichier_chargement))<>repertoire_exemples)
  and (AppendPathDelim(extractfilepath(nom_fichier_chargement))<>repertoire_propagation_perso)
  then dernier_repertoire_utilise_chargement:=AppendPathDelim(extractfilepath(nom_fichier_sauvegarde));

 ChargerFichier(nom_fichier_chargement,sender);

end;

procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
  if radiogroup1.ItemIndex=0 then begin
  chart1.Visible:=true;
  chart2.Visible:=false;
  end;
  if radiogroup1.ItemIndex=1 then begin
  chart2.Visible:=true;
  chart1.Visible:=false;
  end;
end;

procedure TForm1.SpeedButton10Click(Sender: TObject);
begin
  CopyStringGridToClipboard(stringgrid6);
end;

procedure TForm1.SpeedButton11Click(Sender: TObject);
begin
  CopyStringGridToClipboard(stringgrid7);
end;

procedure TForm1.SpeedButton12Click(Sender: TObject);
begin
  clipboard.Assign(image_sortie_integre.Picture.Bitmap);
end;

procedure TForm1.SpeedButton13Click(Sender: TObject);
begin
 clipboard.Assign(image_sortie_densite.Picture.Bitmap);
end;

procedure TForm1.SpeedButton14Click(Sender: TObject);
begin
 if radiogroup1.ItemIndex=0 then
    chart1.CopyToClipboardBitmap;
 if radiogroup1.ItemIndex=1 then
    chart2.CopyToClipboardBitmap;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  CopyStringGridToClipboard(StringGrid1);
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin


  CopyStringGridToClipboard(stringgrid8);
end;




procedure TForm1.SpeedButton3Click(Sender: TObject);
begin
  CopyStringGridToClipboard(stringgrid9);
end;

procedure TForm1.SpeedButton4Click(Sender: TObject);
begin
  CopyStringGridToClipboard(StringGrid2);
end;

procedure TForm1.SpeedButton15Click(Sender: TObject);
begin
  CopyStringGridToClipboard(StringGrid_incertitudes_mesurandes);
end;

procedure TForm1.SpeedButton5Click(Sender: TObject);
begin
  CopyStringGridToClipboard(stringgrid3);

end;


procedure TForm1.SpeedButton6Click(Sender: TObject);
begin
  CopyStringGridToClipboard(stringgrid_autre_taux_normale);
end;

procedure TForm1.SpeedButton7Click(Sender: TObject);
begin
  CopyStringGridToClipboard(stringgrid4);
end;

procedure TForm1.SpeedButton8Click(Sender: TObject);
begin
  CopyStringGridToClipboard(stringgrid_autre_taux_student);
end;

procedure TForm1.SpeedButton9Click(Sender: TObject);
begin
  CopyStringGridToClipboard(stringgrid5);
end;

procedure TForm1.SpeedButton_paslegitime1Click(Sender: TObject);
begin
   if     une_seule_rectangulaire
  then begin
   FormAvertissement1.ShowModal;
   exit;
  end;

  if     ecart_normale_avec_mc
  then begin
   FormAvertissement2.label2.Caption:=rsEtCelleObten+inttostr(ecart_max_tolere)+rsEtCelleObten1;
   FormAvertissement2.ShowModal;
  end;
end;

procedure TForm1.SpeedButton_paslegitime2Click(Sender: TObject);
begin
    if     une_seule_rectangulaire
  then begin
   FormAvertissement1.ShowModal;
   exit;
  end;

  if     ecart_student_avec_mc
  then begin
   FormAvertissement2.label2.Caption:=rsEtCelleObten+inttostr(ecart_max_tolere)+rsEtCelleObten1;
   FormAvertissement2.ShowModal;
  end;

end;

procedure TForm1.StaticText11Click(Sender: TObject);

  var
  v: THTMLBrowserHelpViewer;
  BrowserPath, BrowserParams: string;
  p: LongInt;
  URL: String;
  BrowserProcess: TProcessUTF8;
begin
  v:=THTMLBrowserHelpViewer.Create(nil);
  try
    v.FindDefaultBrowser(BrowserPath,BrowserParams);
    //debugln(['Path=',BrowserPath,' Params=',BrowserParams]);

   url:=Form1.StaticText11.Caption;
    p:=System.Pos('%s', BrowserParams);
    System.Delete(BrowserParams,p,2);
    System.Insert(URL,BrowserParams,p);

    // start browser
    BrowserProcess:=TProcessUTF8.Create(nil);
    try
      BrowserProcess.CommandLine:=BrowserPath+' '+BrowserParams;
      BrowserProcess.Execute;
    finally
      BrowserProcess.Free;
    end;
  finally
    v.Free;
end;
end;

procedure TForm1.StaticText13Click(Sender: TObject);

  var
  v: THTMLBrowserHelpViewer;
  BrowserPath, BrowserParams: string;
  p: LongInt;
  URL: String;
  BrowserProcess: TProcessUTF8;
begin
  v:=THTMLBrowserHelpViewer.Create(nil);
  try
    v.FindDefaultBrowser(BrowserPath,BrowserParams);
    //debugln(['Path=',BrowserPath,' Params=',BrowserParams]);

   url:='http://www.bipm.org/utils/common/documents/jcgm/JCGM_101_2008_E.pdf';
    p:=System.Pos('%s', BrowserParams);
    System.Delete(BrowserParams,p,2);
    System.Insert(URL,BrowserParams,p);

    // start browser
    BrowserProcess:=TProcessUTF8.Create(nil);
    try
      BrowserProcess.CommandLine:=BrowserPath+' '+BrowserParams;
      BrowserProcess.Execute;
    finally
      BrowserProcess.Free;
    end;
  finally
    v.Free;
end
end;


function isligne_mesurande(row:integer; var indice_variable_pour_ajout_source_erreur_a_debut_zero:integer):boolean;
var i,li:integer;
begin

 if (row=0) or (nombre_mesurandes=0) then begin
  isligne_mesurande:=false;
  exit;
  end;


 if row=1 then begin
  indice_variable_pour_ajout_source_erreur_a_debut_zero:=0;
   isligne_mesurande:=true;
   exit;
   end;

    li:=1;
 for i:=1 to nombre_mesurandes do
 begin
li:=li+2+liste_mesurandes[i-1].nombre_erreurs;
    if row=li then  begin
    indice_variable_pour_ajout_source_erreur_a_debut_zero:=i;
   isligne_mesurande:=true;
   exit;
    end;

 end;
  isligne_mesurande:=false;

end;

function isligne_intercalaire(row:integer):boolean;
var i,li:integer;
begin

 if (row<=1) or (nombre_mesurandes=0)  then begin
  isligne_intercalaire:=false;
  exit;
  end;



    li:=0;
 for i:=1 to nombre_mesurandes do
 begin
li:=li+2+liste_mesurandes[i-1].nombre_erreurs;
    if row=li then  begin
       isligne_intercalaire:=true;
   exit;
    end;

 end;
  isligne_intercalaire:=false;

end;




function isligne_distribution(row:integer; var indice_variable_pour_modif_source_erreur_a_debut_zero,
  indice_distribution_a_debut_zero:integer):boolean;
var i,li:integer;
begin
 if (row<=1) or (nombre_mesurandes=0) or (nombre_distributions=0) then begin
  isligne_distribution:=false;
   exit;
 end;

 if  (isligne_mesurande(row,indice_variable_pour_modif_source_erreur_a_debut_zero)
 or
 isligne_intercalaire(row) ) then begin
 isligne_distribution:=false;
 exit;
 end;

 i:=row;
 repeat
   dec(i);
 until isligne_mesurande(i,indice_variable_pour_modif_source_erreur_a_debut_zero);

 indice_distribution_a_debut_zero:=liste_mesurandes[indice_variable_pour_modif_source_erreur_a_debut_zero].liste_des_indices_des_sources_derreur[row-i-1];


  isligne_distribution:=true;

end;


procedure TForm1.rafraichitstringgridentree(sender:tobject);
  var i,j,liligne:integer;
 begin
  if nombre_mesurandes=0 then exit;
  StringGrid_entree.Clear;
  StringGrid_entree.ColCount:=11;
  StringGrid_entree.RowCount:=nombre_mesurandes*2+nombre_distributions+1;
  liligne:=0;
  form1.StringGrid_entree.Cells[0, 0]:=rsMesurande2;
      form1.StringGrid_entree.Cells[5, 0]:=rsTypeEstimati;
      form1.StringGrid_entree.Cells[1, 0]:=rsEstimateur;
       form1.StringGrid_entree.Cells[2, 0]:=rsAjouterSourc;
       form1.StringGrid_entree.Cells[3, 0]:=rsSupprimerSou;
       form1.StringGrid_entree.Cells[4, 0]:=rsSymboleErreu;
      form1.StringGrid_entree.Cells[6, 0]:=rsIncertitudeT2;
      form1.StringGrid_entree.Cells[7, 0]:=rsTypeDeDistri;
      form1.StringGrid_entree.Cells[8, 0]:=rsTracDistribu;
      form1.StringGrid_entree.Cells[9, 0]:=rsTracDensit;
      form1.StringGrid_entree.Cells[10, 0]:=rsDescriptif;

for i:=1 to nombre_mesurandes do begin
 inc(liligne);
 StringGrid_entree.Cells[0,liligne]:=liste_mesurandes[i-1].nom_mesurande;
 if not myisnan(liste_mesurandes[i-1].estimateur) then
 StringGrid_entree.Cells[1,liligne]:=floattostr(liste_mesurandes[i-1].estimateur)
 else
  StringGrid_entree.Cells[1,liligne]:='';
  StringGrid_entree.Cells[2,liligne]:='+';
  StringGrid_entree.Cells[10,liligne]:=liste_mesurandes[i-1].descriptif_mesurande;
  if liste_mesurandes[i-1].nombre_erreurs>0 then
  for j:=1 to liste_mesurandes[i-1].nombre_erreurs do begin
  inc(liligne);
   StringGrid_entree.Cells[3,liligne]:='-';
   StringGrid_entree.Cells[4,liligne]:=liste_distributions[liste_mesurandes[i-1].liste_des_indices_des_sources_derreur[j-1]].nom_variable;
       case liste_distributions[liste_mesurandes[i-1].liste_des_indices_des_sources_derreur[j-1]].tyAB of
      type_A: form1.StringGrid_entree.Cells[5,liligne]:='A';
      type_B: form1.StringGrid_entree.Cells[5,liligne]:='B';
       end;
  StringGrid_entree.Cells[6,liligne]:=floattostr(liste_distributions[liste_mesurandes[i-1].liste_des_indices_des_sources_derreur[j-1]].incertitude_type);
  case liste_distributions[liste_mesurandes[i-1].liste_des_indices_des_sources_derreur[j-1]].tyty of
    d_student: form1.StringGrid_entree.Cells[7, liligne]:=rsStudent;
    d_normale: form1.StringGrid_entree.Cells[7, liligne]:=rsNormaleGauss;
    d_rectangle: form1.StringGrid_entree.Cells[7, liligne]:=rsRectangulair;
    d_triangle: form1.StringGrid_entree.Cells[7, liligne]:=rsTriangulaire;
    d_trapeze:  form1.StringGrid_entree.Cells[7, liligne]:=rsTrapZoDale;
    d_arcsin:   form1.StringGrid_entree.Cells[7, liligne]:=rsDRivEDArcsin;
           end;
 form1.StringGrid_entree.Cells[8, liligne]:=rsClicIci;
       form1.StringGrid_entree.Cells[9,liligne]:=rsClicIci;
       form1.StringGrid_entree.Cells[10,liligne]:=liste_distributions[liste_mesurandes[i-1].liste_des_indices_des_sources_derreur[j-1]].descriptif;
  end;
  inc(liligne);

end;

form1.StringGrid_entree.AutoSizeColumns;
form1.StringGrid_entree.ColWidths[0]:=trunc(form1.StringGrid_entree.ColWidths[0]*1.2);
 form1.StringGrid_entree.ColWidths[1]:=trunc(form1.StringGrid_entree.ColWidths[1]*1.2);
 form1.StringGrid_entree.ColWidths[4]:=trunc(form1.StringGrid_entree.ColWidths[4]*1.2);
 //car police bold
 end;




procedure TForm1.StringGrid_entreeMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
 var repmode,i,j,indice_variable_pour_ajout_source_erreur_a_debut_zero,indice_distribution_a_debut_zero:integer;
 colonne,ligne:integer;
   begin
    saisie_mesures_effectuee:=false;
     if (nombre_mesurandes=0) then exit;
     StringGrid_entree.MouseToCell(x,y,colonne,ligne);
     if ligne=0 then exit;

         {clic sur un + pour ajouter source d'erreur}
if    (isligne_mesurande(ligne,indice_variable_pour_ajout_source_erreur_a_debut_zero) and (colonne=2))  then begin

  inc(nombre_distributions);
  setlength(liste_distributions,nombre_distributions);
   setlength( liste_descripteur_correlation,nombre_distributions,nombre_distributions);
   for i:=1 to  nombre_distributions do begin
   liste_descripteur_correlation[nombre_distributions-1,i-1].t_correlation:=c_correlation;
   liste_descripteur_correlation[nombre_distributions-1,i-1].valeur:=0;
   liste_descripteur_correlation[i-1,nombre_distributions-1].t_correlation:=c_correlation;
   liste_descripteur_correlation[i-1,nombre_distributions-1].valeur:=0;
   end;



  liste_distributions[nombre_distributions-1].moyenne:=0;
      liste_distributions[nombre_distributions-1].defini_par:=par_incertitude_type;
      liste_distributions[nombre_distributions-1].tyty:=d_rectangle;
      liste_distributions[nombre_distributions-1].tyAB:=type_B;
      liste_distributions[nombre_distributions-1].degres_de_liberte:=0;
      liste_distributions[nombre_distributions-1].degres_de_liberte_effectif:=0;
      liste_distributions[nombre_distributions-1].demi_etendue:=0;
      liste_distributions[nombre_distributions-1].demi_etendue_bas:=0;
      liste_distributions[nombre_distributions-1].demi_etendue_haut:=0;
      liste_distributions[nombre_distributions-1].ecart_type_echantionnal:=0;
      liste_distributions[nombre_distributions-1].incertitude_elargie:=0;
      liste_distributions[nombre_distributions-1].incertitude_type:=0;
      liste_distributions[nombre_distributions-1].inc_rel_sur_inc:=0;
      liste_distributions[nombre_distributions-1].pourcentage:=0;
      liste_distributions[nombre_distributions-1].student_nombre_mesures:=0;
  setlength(liste_distribution_est_traitee,nombre_distributions);
   liste_distribution_est_traitee[nombre_distributions-1]:=false;
  liste_distributions[nombre_distributions-1].indice_de_la_variable_correspondante:=indice_variable_pour_ajout_source_erreur_a_debut_zero;
   with Form_type_evaluation do begin
     if screen.width>width then left:=(screen.width-width) div 2 else left:=0;
   if screen.height>height then top:=(screen.height-height) div 2 else top:=0;
         radiobutton_type_A.Checked:=false;
      radiobutton_type_B.Checked:=true;
      if showmodal=mrcancel then begin
      dec(nombre_distributions);
  setlength(liste_distributions,nombre_distributions);
  setlength( liste_descripteur_correlation,nombre_distributions,nombre_distributions);
   setlength(liste_distribution_est_traitee,nombre_distributions);
      exit;
      end;
          if radiobutton_type_A.Checked then liste_distributions[nombre_distributions-1].tyAB:=type_A else
             liste_distributions[nombre_distributions-1].tyAB:=type_B;
        end;

     if liste_distributions[nombre_distributions-1].tyAB=type_A then begin
      with Form_dois_je_calculer do begin
     if screen.width>width then left:=(screen.width-width) div 2 else left:=0;
   if screen.height>height then top:=(screen.height-height) div 2 else top:=0;
        RadioButton_jaidejacalcule.Checked:=true;
      RadioButton_jenaipascalcule.Checked:=false;
        if showmodal=mrcancel then begin
        dec(nombre_distributions);
  setlength(liste_distributions,nombre_distributions);
  setlength( liste_descripteur_correlation,nombre_distributions,nombre_distributions);
   setlength(liste_distribution_est_traitee,nombre_distributions);
      exit;
        end;
      if RadioButton_jenaipascalcule.Checked=true then begin
      with Form_aidecalcul do begin
 if screen.width>width then left:=(screen.width-width) div 2 else left:=0;
if screen.height>height then top:=(screen.height-height) div 2 else top:=0;
StringGrid1.RowCount:=2;
StringGrid1.Cells[0,1]:='1';
StringGrid1.Cells[1,1]:='';
ReCalcule(sender);
end;
  repmode:=Form_aidecalcul.ShowModal;
  if repmode=mrcancel then begin
  dec(nombre_distributions);
  setlength(liste_distributions,nombre_distributions);
  setlength( liste_descripteur_correlation,nombre_distributions,nombre_distributions);
   setlength(liste_distribution_est_traitee,nombre_distributions);
      exit;
  end;
  if ((repmode=mrok) and (_nombre_mesures<=2)) then exit;
  if ((repmode=mrok) and (_nombre_mesures>2)) then with saisie_dune_grandeur do
     begin
    Edit_student_nombre_degre_de_liberte.Text:=inttostr(_nombre_mesures-1);
    Edit_student_ecart_type_echantionnal.Text:=floattostr(_ecart_type);
    Edit_student_moyenne.Text:=floattostr(_moyenne);
    liste_distributions[nombre_distributions-1].moyenne:=_moyenne;
     RadioButton_student_ecart_type_echantionnal.Checked:=true;
     RadioButton_student_ecart_type_moyenne.Checked:=false;
     RadioButton_student_incertitude_elargie.Checked:=false;
     end;
    if repmode=mrcancel then
    begin
    dec(nombre_distributions);
  setlength(liste_distributions,nombre_distributions);
  setlength( liste_descripteur_correlation,nombre_distributions,nombre_distributions);
   setlength(liste_distribution_est_traitee,nombre_distributions);
      exit;
      end;

      end;
      end;
        end;


   with saisie_dune_grandeur do begin
     if screen.width>width then left:=(screen.width-width) div 2 else left:=0;
   if screen.height>height then top:=(screen.height-height) div 2 else top:=0;
   end;

      saisie_dune_grandeur.Caption:='Caractéristique de cette nouvelle source d''erreur:';

      if (liste_distributions[nombre_distributions-1].tyAB=type_A) and
      not(liste_distribution_est_traitee[nombre_distributions-1]) then begin
      saisie_dune_grandeur.ComboBox1.ItemIndex:=0;
      saisie_dune_grandeur.ComboBox1Change(sender);
      //saisie_dune_grandeur.ComboBox1.Enabled:=false;
      saisie_dune_grandeur.RadioButton_type_A.Checked:=true;
      //saisie_dune_grandeur.RadioButton_type_B.Enabled:=false;
      end else
      begin
      saisie_dune_grandeur.ComboBox1.Enabled:=true;
      //saisie_dune_grandeur.RadioButton_type_B.Enabled:=true;
      saisie_dune_grandeur.RadioButton_type_B.Checked:=true;
      end;


       if  not(saisie_mesures_effectuee) then
      with Form_aidecalcul do begin
 StringGrid1.RowCount:=2;
StringGrid1.Cells[0,1]:='1';
StringGrid1.Cells[1,1]:='';
ReCalcule(sender);
end;



     saisie_dune_grandeur.imageListexplication.GetBitmap(0, saisie_dune_grandeur.Image_explication.Picture.Bitmap);
     saisie_dune_grandeur.RadioButton_inc_inc.Checked:=true;
     saisie_dune_grandeur.Edit_inc_inc.Text:='0';
     saisie_dune_grandeur.combobox1.ItemIndex:=0;
     saisie_dune_grandeur.ComboBox1Change(sender);
     saisie_dune_grandeur.RadioButton_type_B.Checked:=(liste_distributions[nombre_distributions-1].tyAB=type_B);
      if liste_distributions[nombre_distributions-1].tyAB=type_A then begin
      saisie_dune_grandeur.RadioButton_degre.Checked:=true;
      saisie_dune_grandeur.Edit_degre.text:='';
            end;
            if liste_distributions[nombre_distributions-1].tyAB=type_B then begin
     saisie_dune_grandeur.combobox1.ItemIndex:=2;
     saisie_dune_grandeur.ComboBox1Change(sender);

    end;

    indice_distribution:=nombre_distributions;


    setlength(liste_echantillons_entree,nombre_distributions);
    setlength(copie_liste_echantillons_entree,nombre_distributions);
         liste_distributions[nombre_distributions-1].nom_variable:=liste_variables[indice_variable_pour_ajout_source_erreur_a_debut_zero]+'_S'+inttostr(nombre_distributions);
      liste_distribution_est_traitee[nombre_distributions-1]:=false;




     hauteur_image_densite:=form_trace.Image1.Height;
      largeur_image_densite:=form_trace.Image1.width;
      hauteur_image_integre:=form_trace.Image1.Height;
      largeur_image_integre:=form_trace.Image1.width;



    setlength(liste_images_integre,nombre_distributions);
    setlength(liste_images_densite,nombre_distributions);
         liste_images_integre[nombre_distributions-1]:=TImage.Create(Self);
      liste_images_densite[nombre_distributions-1]:=TImage.Create(Self);
      With liste_images_integre[nombre_distributions-1] Do
  begin
  Parent:=Form1;
  Top:=0;
  Left:=0;
  Width:=largeur_image_integre;
  Height:=hauteur_image_integre;
  visible:=false;
  end;
  With liste_images_densite[nombre_distributions-1] Do
  begin
  Parent:=Form1;
  Top:=0;
  Left:=0;
  Width:=largeur_image_densite;
  Height:=hauteur_image_integre;
  visible:=false;
  end;

   saisie_dune_grandeur.Edit_normale_moyenne.Text:= liste_distributions[nombre_distributions-1].nom_variable;
    saisie_dune_grandeur.Edit_arcsin_moyenne.Text:= liste_distributions[nombre_distributions-1].nom_variable;
     saisie_dune_grandeur.Edit_student_moyenne.Text:= liste_distributions[nombre_distributions-1].nom_variable;
       saisie_dune_grandeur.Edit_rectangulaire_moyenne.Text:= liste_distributions[nombre_distributions-1].nom_variable;
         saisie_dune_grandeur.Edit_triangulaire_moyenne.Text:= liste_distributions[nombre_distributions-1].nom_variable;
          saisie_dune_grandeur.Edit_trapeze_moyenne.Text:= liste_distributions[nombre_distributions-1].nom_variable;
    saisie_dune_grandeur.ShowModal;

    if not(liste_distribution_est_traitee[nombre_distributions-1]) then begin
     liste_images_integre[nombre_distributions-1].Free;
      liste_images_densite[nombre_distributions-1].free;
      dec(nombre_distributions);
       setlength(liste_images_integre,nombre_distributions);
    setlength(liste_images_densite,nombre_distributions);
       setlength(liste_echantillons_entree,nombre_distributions);
    setlength(copie_liste_echantillons_entree,nombre_distributions);
       setlength(liste_distributions,nombre_distributions);
       setlength( liste_descripteur_correlation,nombre_distributions,nombre_distributions);
       setlength(liste_distribution_est_traitee,nombre_distributions);
    exit;

    end;


   inc(liste_mesurandes[indice_variable_pour_ajout_source_erreur_a_debut_zero].nombre_erreurs);
   setlength(liste_mesurandes[indice_variable_pour_ajout_source_erreur_a_debut_zero].liste_des_indices_des_sources_derreur,
   liste_mesurandes[indice_variable_pour_ajout_source_erreur_a_debut_zero].nombre_erreurs);
   liste_mesurandes[indice_variable_pour_ajout_source_erreur_a_debut_zero].liste_des_indices_des_sources_derreur
   [liste_mesurandes[indice_variable_pour_ajout_source_erreur_a_debut_zero].nombre_erreurs-1]:=nombre_distributions-1;

   if (liste_distributions[nombre_distributions-1].tyty=d_student) then begin
    liste_mesurandes[indice_variable_pour_ajout_source_erreur_a_debut_zero].estimateur:=liste_distributions[nombre_distributions-1].moyenne;

   end;

  Form1.rafraichitstringgridentree(sender);



   tous_calculs_faits:=false;

 exit;

end;
   {de ajout source erreur}


   {modif valeur mesurande}
   if    (isligne_mesurande(ligne,indice_variable_pour_ajout_source_erreur_a_debut_zero) and (colonne=1))  then begin

    with saisie_estimateur do begin
       if screen.width>width then left:=(screen.width-width) div 2 else left:=0;
   if screen.height>height then top:=(screen.height-height) div 2 else top:=0;
  if not myisnan(liste_mesurandes[indice_variable_pour_ajout_source_erreur_a_debut_zero].estimateur) then
     edit_saisie_estimateur.text:=floattostr(liste_mesurandes[indice_variable_pour_ajout_source_erreur_a_debut_zero].estimateur)
     else edit_saisie_estimateur.text:='';   end;
    repmode:=saisie_estimateur.ShowModal;
  if repmode=mrok then begin
  liste_mesurandes[indice_variable_pour_ajout_source_erreur_a_debut_zero].estimateur:=strtofloat(saisie_estimateur.edit_saisie_estimateur.text);
   Form1.rafraichitstringgridentree(sender);
    end;
  tous_calculs_faits:=false;
  exit;
   end;
    {fin modif valeur mesurande}

    {modif descriptif mesurnde}
   if    (isligne_mesurande(ligne,indice_variable_pour_ajout_source_erreur_a_debut_zero) and (colonne=10))  then begin
    with form_descriptif do begin
if screen.width>width then left:=(screen.width-width) div 2 else left:=0;
  if screen.height>height then top:=(screen.height-height) div 2 else top:=0;
  caption:=Format(rsMesurande, [liste_mesurandes[indice_variable_pour_ajout_source_erreur_a_debut_zero].nom_mesurande]);
  statictext1.Caption:=rsVousPouvezSa3;
  edit_descriptif.Text:=liste_mesurandes[indice_variable_pour_ajout_source_erreur_a_debut_zero].descriptif_mesurande;
  showmodal;
 liste_mesurandes[indice_variable_pour_ajout_source_erreur_a_debut_zero].descriptif_mesurande:=edit_descriptif.Text;
  Form1.rafraichitstringgridentree(sender);

end;
  exit;
   end;
     {modif descriptif mesurnde}


      {modif descriptif erreur}
   if    (isligne_distribution(ligne,indice_variable_pour_ajout_source_erreur_a_debut_zero,indice_distribution_a_debut_zero) and (colonne=10))  then begin
    with form_descriptif do begin
if screen.width>width then left:=(screen.width-width) div 2 else left:=0;
  if screen.height>height then top:=(screen.height-height) div 2 else top:=0;
  caption:= liste_distributions[indice_distribution_a_debut_zero].nom_variable;
  statictext1.caption:=rsVousPouvezSa2;
  edit_descriptif.Text:=liste_distributions[indice_distribution_a_debut_zero].descriptif;
  showmodal;
 liste_distributions[indice_distribution_a_debut_zero].descriptif:=edit_descriptif.Text;
  Form1.rafraichitstringgridentree(sender);

end;
  exit;
   end;
     {modif descriptif ereur}


       {suppression erreur}
   if    (isligne_distribution(ligne,indice_variable_pour_ajout_source_erreur_a_debut_zero,indice_distribution_a_debut_zero) and (colonne=3))  then begin
   if application.MessageBox(pchar(rsEtesVousSRDe), pchar(rsVraiment), mb_yesno)=mrno
   then exit;
   Effacer_Element_Tableau_Tableau_Correlation(indice_distribution_a_debut_zero);
  Effacer_Element_Tableau_Distributions(liste_distributions,indice_distribution_a_debut_zero);
              Effacer_Element_Tableau_Tableau_Reel_Dapres_Premier_Indice(copie_liste_echantillons_entree,indice_distribution_a_debut_zero);
          Effacer_Element_Tableau_Tableau_Reel_Dapres_Premier_Indice(liste_echantillons_entree,indice_distribution_a_debut_zero);
      Effacer_Element_Tableau_Image(liste_images_densite,indice_distribution_a_debut_zero);
      Effacer_Element_Tableau_Image(liste_images_integre,indice_distribution_a_debut_zero);
     i:=0;
     repeat
       inc(i);
       until liste_mesurandes[indice_variable_pour_ajout_source_erreur_a_debut_zero].liste_des_indices_des_sources_derreur[i-1]=indice_distribution_a_debut_zero;
       Effacer_Element_Tableau_Entier( liste_mesurandes[indice_variable_pour_ajout_source_erreur_a_debut_zero].liste_des_indices_des_sources_derreur,i);
       dec(liste_mesurandes[indice_variable_pour_ajout_source_erreur_a_debut_zero].nombre_erreurs);
        dec(nombre_distributions);
        for i:=1 to nombre_mesurandes do
        if liste_mesurandes[i-1].nombre_erreurs>0 then
        for j:=1 to liste_mesurandes[i-1].nombre_erreurs do
        if liste_mesurandes[i-1].liste_des_indices_des_sources_derreur[j-1]>indice_distribution_a_debut_zero then
        dec(liste_mesurandes[i-1].liste_des_indices_des_sources_derreur[j-1]);

           Form1.rafraichitstringgridentree(sender);
         tous_calculs_faits:=false;
  exit;
   end;
     {suppression ereur}



      {affichage densite integree}
    if ((colonne=8) and isligne_distribution(ligne,indice_variable_pour_ajout_source_erreur_a_debut_zero,indice_distribution_a_debut_zero)  ) then begin
   form_trace.Image1.Picture.Bitmap:=liste_images_integre[indice_distribution_a_debut_zero].Picture.Bitmap;
   with form_trace do begin
   if screen.width>width then left:=(screen.width-width) div 2 else left:=0;
   if screen.height>height then top:=(screen.height-height) div 2 else top:=0;
   showmodal;
  end;exit; end;

     {affichage densite }
 if ((colonne=9) and isligne_distribution(ligne,indice_variable_pour_ajout_source_erreur_a_debut_zero,indice_distribution_a_debut_zero) ) then begin
   form_trace.Image1.Picture.Bitmap:=liste_images_densite[indice_distribution_a_debut_zero].Picture.Bitmap;
   with form_trace do begin
   if screen.width>width then left:=(screen.width-width) div 2 else left:=0;
   if screen.height>height then top:=(screen.height-height) div 2 else top:=0;
   showmodal;
  end; exit;    end;




       {modif erreur}
      if ((colonne>=5) and (colonne<=7) and    isligne_distribution(ligne,indice_variable_pour_ajout_source_erreur_a_debut_zero,indice_distribution_a_debut_zero) )
      then begin
      indice_distribution:=indice_distribution_a_debut_zero+1;
       indice_mesurande:=indice_variable_pour_ajout_source_erreur_a_debut_zero;
       Unit_saisie_proprietes_dune_grandeur.liste_student_a_ete_modifiee:=false;
     with saisie_dune_grandeur do begin
     if screen.width>width then left:=(screen.width-width) div 2 else left:=0;
   if screen.height>height then top:=(screen.height-height) div 2 else top:=0;
   end;

      saisie_dune_grandeur.Caption:=Format(rsPropriTSDeLa, [liste_distributions[

        indice_distribution_a_debut_zero].nom_variable]);

      if (liste_distributions[indice_distribution_a_debut_zero].tyAB=type_A) then begin
      saisie_dune_grandeur.ComboBox1.ItemIndex:=0;
      saisie_dune_grandeur.ComboBox1Change(sender);
      //saisie_dune_grandeur.ComboBox1.Enabled:=false;
      saisie_dune_grandeur.RadioButton_type_A.Checked:=true;
     // saisie_dune_grandeur.RadioButton_type_B.Enabled:=false;
      end else
      begin
      //saisie_dune_grandeur.ComboBox1.Enabled:=true;
      saisie_dune_grandeur.RadioButton_type_B.checked:=true;

      end;


       if  not(saisie_mesures_effectuee) then
      with Form_aidecalcul do begin
 StringGrid1.RowCount:=2;
StringGrid1.Cells[0,1]:='1';
StringGrid1.Cells[1,1]:='';
ReCalcule(sender);
end;




     if liste_distributions[indice_distribution_a_debut_zero].tyty=d_student then begin
      saisie_dune_grandeur.RadioButton_degre.Checked:=true;
      saisie_dune_grandeur.Edit_degre.Text:=floattostr(liste_distributions[indice_distribution_a_debut_zero].degres_de_liberte_effectif);
      saisie_dune_grandeur.Edit_inc_inc.Text:='';
      end else begin
       if myisnan(liste_distributions[indice_distribution_a_debut_zero].degres_de_liberte_effectif) then begin
              saisie_dune_grandeur.RadioButton_inc_inc.Checked:=true;
     saisie_dune_grandeur.Edit_inc_inc.Text:='0';
         saisie_dune_grandeur.Edit_degre.Text:='';

         end else begin
        saisie_dune_grandeur.RadioButton_degre.Checked:=true;
        saisie_dune_grandeur.Edit_degre.Text:=floattostr(liste_distributions[indice_distribution_a_debut_zero].degres_de_liberte_effectif);
         saisie_dune_grandeur.Edit_inc_inc.Text:=floattostr(liste_distributions[indice_distribution_a_debut_zero].inc_rel_sur_inc*100);
         end;
          end;


      case  liste_distributions[indice_distribution_a_debut_zero].tyty of
       {distribution du type student}
       d_student: begin
        saisie_dune_grandeur.imageListexplication.GetBitmap(0, saisie_dune_grandeur.Image_explication.Picture.Bitmap);
       saisie_dune_grandeur.combobox1.ItemIndex:=0;
       saisie_dune_grandeur.ComboBox1Change(sender);
       saisie_dune_grandeur.panel_student.Left:=10;
      saisie_dune_grandeur.panel_student.Top:=saisie_dune_grandeur.label2.top+saisie_dune_grandeur.label2.height+20;
       saisie_dune_grandeur.Panel_student.Enabled:=true;
       saisie_dune_grandeur.Panel_student.Visible:=true;
       saisie_dune_grandeur.Panel_normale.Enabled:=false;
       saisie_dune_grandeur.Panel_normale.Visible:=false;
       saisie_dune_grandeur.Panel_rectangulaire.Enabled:=false;
       saisie_dune_grandeur.Panel_rectangulaire.Visible:=false;
       saisie_dune_grandeur.Panel_triangulaire.Enabled:=false;
       saisie_dune_grandeur.Panel_triangulaire.Visible:=false;
       saisie_dune_grandeur.Panel_trapeze.Enabled:=false;
       saisie_dune_grandeur.Panel_trapeze.Visible:=false;
       saisie_dune_grandeur.Panel_arcsinus.Enabled:=false;
       saisie_dune_grandeur.Panel_arcsinus.Visible:=false;
       saisie_dune_grandeur.Edit_student_moyenne.text:=liste_distributions[indice_distribution_a_debut_zero].nom_variable;
       saisie_dune_grandeur.Edit_student_ecart_type_echantionnal.text:=floattostr(liste_distributions[indice_distribution_a_debut_zero].ecart_type_echantionnal);
       saisie_dune_grandeur.Edit_student_ecart_type_moyenne.text:=floattostr(liste_distributions[indice_distribution_a_debut_zero].incertitude_type);
       saisie_dune_grandeur.Edit_student_incertitude_elargie.text:=floattostr(liste_distributions[indice_distribution_a_debut_zero].incertitude_elargie);
       saisie_dune_grandeur.Edit_student_pourcentage.text:=floattostr(liste_distributions[indice_distribution_a_debut_zero].pourcentage);
       saisie_dune_grandeur.Edit_student_nombre_degre_de_liberte.text:=floattostr(liste_distributions[indice_distribution_a_debut_zero].degres_de_liberte);
       case liste_distributions[indice_distribution_a_debut_zero].defini_par of
        par_incertitude_type: begin


        saisie_dune_grandeur.RadioButton_student_ecart_type_moyenne.Checked:=true;
        saisie_dune_grandeur.Edit_student_ecart_type_echantionnal.Enabled:=false;
        saisie_dune_grandeur.Edit_student_ecart_type_moyenne.Enabled:=true;
        saisie_dune_grandeur.Edit_student_incertitude_elargie.Enabled:=false;
        saisie_dune_grandeur.Edit_student_pourcentage.Enabled:=false;
        end;
         par_ecart_type_echantionnal: begin
         saisie_dune_grandeur.RadioButton_student_ecart_type_echantionnal.Checked:=true;
        saisie_dune_grandeur.Edit_student_ecart_type_echantionnal.Enabled:=true;
        saisie_dune_grandeur.Edit_student_ecart_type_moyenne.Enabled:=false;
        saisie_dune_grandeur.Edit_student_incertitude_elargie.Enabled:=false;
        saisie_dune_grandeur.Edit_student_pourcentage.Enabled:=false;
         end;
          par_incertitude_elargie: begin



        saisie_dune_grandeur.RadioButton_student_incertitude_elargie.Checked:=true;
        saisie_dune_grandeur.Edit_student_ecart_type_echantionnal.Enabled:=false;
        saisie_dune_grandeur.Edit_student_ecart_type_moyenne.Enabled:=false;
        saisie_dune_grandeur.Edit_student_incertitude_elargie.Enabled:=true;
        saisie_dune_grandeur.Edit_student_pourcentage.Enabled:=true;
          end;



         end;





        form_aidecalcul.StringGrid1.RowCount:=2+liste_distributions[indice_distribution_a_debut_zero].student_nombre_mesures;
        if liste_distributions[indice_distribution_a_debut_zero].student_nombre_mesures>1 then
        for i:=1 to liste_distributions[indice_distribution_a_debut_zero].student_nombre_mesures do begin
        form_aidecalcul.StringGrid1.Cells[1,i]:=myfloattostr(liste_distributions[indice_distribution_a_debut_zero].student_liste_mesures[i-1]);




        form_aidecalcul.StringGrid1.Cells[0,i]:=inttostr(i);
        end;
         form_aidecalcul.StringGrid1.Cells[0,liste_distributions[indice_distribution_a_debut_zero].student_nombre_mesures+1]:=inttostr(liste_distributions[indice_distribution_a_debut_zero].student_nombre_mesures+1);
         form_aidecalcul.StringGrid1.Cells[1,liste_distributions[indice_distribution_a_debut_zero].student_nombre_mesures+1]:='';
         form_aidecalcul.ReCalcule(sender);
        end;
          {distribution du type student}

    {distribution du type normale}
       d_normale: begin
        saisie_dune_grandeur.imageListexplication.GetBitmap(1, saisie_dune_grandeur.Image_explication.Picture.Bitmap);
       saisie_dune_grandeur.combobox1.ItemIndex:=1;
       saisie_dune_grandeur.ComboBox1Change(sender);
       saisie_dune_grandeur.panel_normale.Left:=10;
      saisie_dune_grandeur.panel_normale.Top:=saisie_dune_grandeur.label2.top+saisie_dune_grandeur.label2.height+20;
       saisie_dune_grandeur.Panel_student.Enabled:=false;
       saisie_dune_grandeur.Panel_student.Visible:=false;
       saisie_dune_grandeur.Panel_normale.Enabled:=true;
       saisie_dune_grandeur.Panel_normale.Visible:=true;
       saisie_dune_grandeur.Panel_rectangulaire.Enabled:=false;
       saisie_dune_grandeur.Panel_rectangulaire.Visible:=false;
       saisie_dune_grandeur.Panel_triangulaire.Enabled:=false;
       saisie_dune_grandeur.Panel_triangulaire.Visible:=false;
       saisie_dune_grandeur.Panel_trapeze.Enabled:=false;
       saisie_dune_grandeur.Panel_trapeze.Visible:=false;
       saisie_dune_grandeur.Panel_arcsinus.Enabled:=false;
       saisie_dune_grandeur.Panel_arcsinus.Visible:=false;
       saisie_dune_grandeur.Edit_normale_moyenne.text:=liste_distributions[indice_distribution_a_debut_zero].nom_variable;
       saisie_dune_grandeur.Edit_normale_incertitude_type.text:=floattostr(liste_distributions[indice_distribution_a_debut_zero].incertitude_type);
       saisie_dune_grandeur.Edit_normale_incertitude_elargie.text:=floattostr(liste_distributions[indice_distribution_a_debut_zero].incertitude_elargie);
       saisie_dune_grandeur.Edit_normale_pourcentage.text:=floattostr(liste_distributions[indice_distribution_a_debut_zero].pourcentage);
       saisie_dune_grandeur.Edit_inc_inc.Text:=myfloattostr(liste_distributions[indice_distribution_a_debut_zero].inc_rel_sur_inc*100);
        saisie_dune_grandeur.Edit_degre.Text:=myfloattostr(liste_distributions[indice_distribution_a_debut_zero].degres_de_liberte_effectif);
       case liste_distributions[indice_distribution_a_debut_zero].defini_par of
        par_incertitude_type: begin
        saisie_dune_grandeur.RadioButton_normale_incertitude_type.Checked:=true;
        saisie_dune_grandeur.Edit_normale_incertitude_type.Enabled:=true;
        saisie_dune_grandeur.Edit_normale_incertitude_elargie.Enabled:=false;
        saisie_dune_grandeur.Edit_normale_pourcentage.Enabled:=false;
        end;

          par_incertitude_elargie: begin
        saisie_dune_grandeur.RadioButton_normale_incertitude_elargie.Checked:=true;
        saisie_dune_grandeur.Edit_normale_incertitude_type.Enabled:=false;
        saisie_dune_grandeur.Edit_normale_incertitude_elargie.Enabled:=true;
        saisie_dune_grandeur.Edit_normale_pourcentage.Enabled:=true;
          end;
         end;








        end;
          {distribution du type normale}

    {distribution du type rectangulaire}
       d_rectangle: begin
        saisie_dune_grandeur.imageListexplication.GetBitmap(2, saisie_dune_grandeur.Image_explication.Picture.Bitmap);
        saisie_dune_grandeur.combobox1.ItemIndex:=2;
        saisie_dune_grandeur.ComboBox1Change(sender);
       saisie_dune_grandeur.panel_rectangulaire.Left:=10;
      saisie_dune_grandeur.panel_rectangulaire.Top:=saisie_dune_grandeur.label2.top+saisie_dune_grandeur.label2.height+20;
       saisie_dune_grandeur.Panel_student.Enabled:=false;
       saisie_dune_grandeur.Panel_student.Visible:=false;
       saisie_dune_grandeur.Panel_normale.Enabled:=false;
       saisie_dune_grandeur.Panel_normale.Visible:=false;
       saisie_dune_grandeur.Panel_rectangulaire.Enabled:=true;
       saisie_dune_grandeur.Panel_rectangulaire.Visible:=true;
       saisie_dune_grandeur.Panel_triangulaire.Enabled:=false;
       saisie_dune_grandeur.Panel_triangulaire.Visible:=false;
       saisie_dune_grandeur.Panel_trapeze.Enabled:=false;
       saisie_dune_grandeur.Panel_trapeze.Visible:=false;
       saisie_dune_grandeur.Panel_arcsinus.Enabled:=false;
       saisie_dune_grandeur.Panel_arcsinus.Visible:=false;
       saisie_dune_grandeur.Edit_rectangulaire_incertitude_type.text:=floattostr(liste_distributions[indice_distribution_a_debut_zero].incertitude_type);
       saisie_dune_grandeur.Edit_rectangulaire_demi_etendue.text:=floattostr(liste_distributions[indice_distribution_a_debut_zero].demi_etendue);
       saisie_dune_grandeur.Edit_rectangulaire_moyenne.text:=liste_distributions[indice_distribution_a_debut_zero].nom_variable;
       saisie_dune_grandeur.Edit_inc_inc.Text:=myfloattostr(liste_distributions[indice_distribution_a_debut_zero].inc_rel_sur_inc*100);
        saisie_dune_grandeur.Edit_degre.Text:=myfloattostr(liste_distributions[indice_distribution_a_debut_zero].degres_de_liberte_effectif);
       case liste_distributions[indice_distribution_a_debut_zero].defini_par of
        par_incertitude_type: begin
        saisie_dune_grandeur.RadioButton_rectangulaire_incertitude_type.Checked:=true;
        saisie_dune_grandeur.Edit_rectangulaire_incertitude_type.Enabled:=true;
        saisie_dune_grandeur.Edit_rectangulaire_demi_etendue.Enabled:=false;
        end;
          par_demi_etendue: begin
        saisie_dune_grandeur.RadioButton_rectangulaire_demi_etendue.Checked:=true;
        saisie_dune_grandeur.Edit_rectangulaire_incertitude_type.Enabled:=false;
        saisie_dune_grandeur.Edit_rectangulaire_demi_etendue.Enabled:=true;
          end;
         end;


        end;
          {distribution du type rectangulaire}




          {distribution du type triangulaire}
       d_triangle: begin
        saisie_dune_grandeur.imageListexplication.GetBitmap(3, saisie_dune_grandeur.Image_explication.Picture.Bitmap);
        saisie_dune_grandeur.combobox1.ItemIndex:=3;
        saisie_dune_grandeur.ComboBox1Change(sender);
       saisie_dune_grandeur.panel_triangulaire.Left:=10;
      saisie_dune_grandeur.panel_triangulaire.Top:=saisie_dune_grandeur.label2.top+saisie_dune_grandeur.label2.height+20;
       saisie_dune_grandeur.Panel_student.Enabled:=false;
       saisie_dune_grandeur.Panel_student.Visible:=false;
       saisie_dune_grandeur.Panel_normale.Enabled:=false;
       saisie_dune_grandeur.Panel_normale.Visible:=false;
       saisie_dune_grandeur.Panel_rectangulaire.Enabled:=false;
       saisie_dune_grandeur.Panel_rectangulaire.Visible:=false;
       saisie_dune_grandeur.Panel_triangulaire.Enabled:=true;
       saisie_dune_grandeur.Panel_triangulaire.Visible:=true;
       saisie_dune_grandeur.Panel_trapeze.Enabled:=false;
       saisie_dune_grandeur.Panel_trapeze.Visible:=false;
       saisie_dune_grandeur.Panel_arcsinus.Enabled:=false;
       saisie_dune_grandeur.Panel_arcsinus.Visible:=false;
       saisie_dune_grandeur.Edit_triangulaire_incertitude_type.text:=floattostr(liste_distributions[indice_distribution_a_debut_zero].incertitude_type);
       saisie_dune_grandeur.Edit_inc_inc.Text:=myfloattostr(liste_distributions[indice_distribution_a_debut_zero].inc_rel_sur_inc*100);
        saisie_dune_grandeur.Edit_degre.Text:=myfloattostr(liste_distributions[indice_distribution_a_debut_zero].degres_de_liberte_effectif);

       saisie_dune_grandeur.Edit_triangulaire_demi_etendue.text:=floattostr(liste_distributions[indice_distribution_a_debut_zero].demi_etendue);
       saisie_dune_grandeur.Edit_triangulaire_moyenne.text:=liste_distributions[indice_distribution_a_debut_zero].nom_variable;
       case liste_distributions[indice_distribution_a_debut_zero].defini_par of
        par_incertitude_type: begin

        saisie_dune_grandeur.RadioButton_triangulaire_incertitude_type.Checked:=true;
        saisie_dune_grandeur.Edit_triangulaire_incertitude_type.Enabled:=true;


        saisie_dune_grandeur.Edit_triangulaire_demi_etendue.Enabled:=false;

        end;

          par_demi_etendue: begin
        saisie_dune_grandeur.RadioButton_triangulaire_demi_etendue.Checked:=true;
        saisie_dune_grandeur.Edit_triangulaire_incertitude_type.Enabled:=false;
        saisie_dune_grandeur.Edit_triangulaire_demi_etendue.Enabled:=true;
          end;
         end;










        end;

          {distribution du type triangulaire}









           {distribution du type trapeze}
       d_trapeze: begin
        saisie_dune_grandeur.imageListexplication.GetBitmap(4, saisie_dune_grandeur.Image_explication.Picture.Bitmap);
        saisie_dune_grandeur.combobox1.ItemIndex:=4;
        saisie_dune_grandeur.ComboBox1Change(sender);
       saisie_dune_grandeur.panel_trapeze.Left:=10;
      saisie_dune_grandeur.panel_trapeze.Top:=saisie_dune_grandeur.label2.top+saisie_dune_grandeur.label2.height+20;
       saisie_dune_grandeur.Panel_student.Enabled:=false;
       saisie_dune_grandeur.Panel_student.Visible:=false;
       saisie_dune_grandeur.Panel_normale.Enabled:=false;
       saisie_dune_grandeur.Panel_normale.Visible:=false;
       saisie_dune_grandeur.Panel_rectangulaire.Enabled:=false;
       saisie_dune_grandeur.Panel_rectangulaire.Visible:=false;
       saisie_dune_grandeur.Panel_triangulaire.Enabled:=false;
       saisie_dune_grandeur.Panel_triangulaire.Visible:=false;
       saisie_dune_grandeur.Panel_trapeze.Enabled:=true;
       saisie_dune_grandeur.Panel_trapeze.Visible:=true;
       saisie_dune_grandeur.Panel_arcsinus.Enabled:=false;
       saisie_dune_grandeur.Panel_arcsinus.Visible:=false;
       saisie_dune_grandeur.Edit_trapeze_incertitude_type.text:=floattostr(liste_distributions[indice_distribution_a_debut_zero].incertitude_type);
       saisie_dune_grandeur.Edit_trapeze_demi_etendue_bas.text:=floattostr(liste_distributions[indice_distribution_a_debut_zero].demi_etendue_bas);
       saisie_dune_grandeur.Edit_trapeze_demi_etendue_haut.text:=floattostr(liste_distributions[indice_distribution_a_debut_zero].demi_etendue_haut);
       saisie_dune_grandeur.Edit_trapeze_moyenne.text:=liste_distributions[indice_distribution_a_debut_zero].nom_variable;
       saisie_dune_grandeur.Edit_trapeze_incertitude_type.Enabled:=false;
       saisie_dune_grandeur.Edit_inc_inc.Text:=myfloattostr(liste_distributions[indice_distribution_a_debut_zero].inc_rel_sur_inc*100);
        saisie_dune_grandeur.Edit_degre.Text:=myfloattostr(liste_distributions[indice_distribution_a_debut_zero].degres_de_liberte_effectif);

        end;
          {distribution du type trapeze}

          {distribution du type arcsinus}
       d_arcsin: begin
        saisie_dune_grandeur.imageListexplication.GetBitmap(5, saisie_dune_grandeur.Image_explication.Picture.Bitmap);
        saisie_dune_grandeur.combobox1.ItemIndex:=5;
        saisie_dune_grandeur.ComboBox1Change(sender);
       saisie_dune_grandeur.panel_arcsinus.Left:=10;
      saisie_dune_grandeur.panel_arcsinus.Top:=saisie_dune_grandeur.label2.top+saisie_dune_grandeur.label2.height+20;
       saisie_dune_grandeur.Panel_student.Enabled:=false;
       saisie_dune_grandeur.Panel_student.Visible:=false;
       saisie_dune_grandeur.Panel_normale.Enabled:=false;
       saisie_dune_grandeur.Panel_normale.Visible:=false;
       saisie_dune_grandeur.Panel_rectangulaire.Enabled:=false;
       saisie_dune_grandeur.Panel_rectangulaire.Visible:=false;
       saisie_dune_grandeur.Panel_triangulaire.Enabled:=false;
       saisie_dune_grandeur.Panel_triangulaire.Visible:=false;
       saisie_dune_grandeur.Panel_trapeze.Enabled:=false;
       saisie_dune_grandeur.Panel_trapeze.Visible:=false;
       saisie_dune_grandeur.Panel_arcsinus.Enabled:=true;
       saisie_dune_grandeur.Panel_arcsinus.Visible:=true;
       saisie_dune_grandeur.Edit_arcsin_incertitude_type.text:=floattostr(liste_distributions[indice_distribution_a_debut_zero].incertitude_type);
       saisie_dune_grandeur.Edit_arcsin_demi_etendue.text:=floattostr(liste_distributions[indice_distribution_a_debut_zero].demi_etendue);
       saisie_dune_grandeur.Edit_arcsin_moyenne.text:=liste_distributions[indice_distribution_a_debut_zero].nom_variable;
       saisie_dune_grandeur.Edit_inc_inc.Text:=myfloattostr(liste_distributions[indice_distribution_a_debut_zero].inc_rel_sur_inc*100);
        saisie_dune_grandeur.Edit_degre.Text:=myfloattostr(liste_distributions[indice_distribution_a_debut_zero].degres_de_liberte_effectif);


        end;
          {distribution du type arcsinus}


         end; {du case}







    saisie_dune_grandeur.ShowModal;
    tous_calculs_faits:=false;
     Form1.rafraichitstringgridentree(sender);



   end;


end;

procedure TForm1.StringGrid_entreeMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
  var coco,roro:integer;  chaine:string;
  indice_variable_pour_modif_source_erreur_a_debut_zero,
  indice_distribution_a_debut_zero:integer;
  begin
    if (StringGrid_entree.cursor=crvsplit) or
     (StringGrid_entree.cursor=crhsplit ) then exit;

  StringGrid_entree.MouseToCell(x,y,coco,roro);

 if roro=0 then begin
  chaine:='';
   StringGrid_entree.Hint:=chaine;
  Application.ActivateHint(Mouse.CursorPos);
  exit;
  end;


   chaine:='';

   if (coco=1) and isligne_mesurande(roro,
     indice_variable_pour_modif_source_erreur_a_debut_zero) then chaine:=
     rsClicIciPourM2;
   if (coco=2) and isligne_mesurande(roro,
     indice_variable_pour_modif_source_erreur_a_debut_zero) then chaine:=
     rsClicIciPourA2;
    if (coco=3) and isligne_distribution(roro,indice_variable_pour_modif_source_erreur_a_debut_zero,
  indice_distribution_a_debut_zero) then chaine:=rsClicIciPourS;
     if (coco>=5) and (coco<=7) and isligne_distribution(roro,indice_variable_pour_modif_source_erreur_a_debut_zero,
  indice_distribution_a_debut_zero) then chaine:=rsClicIciPourM3;
    if (coco=8) and isligne_distribution(roro,indice_variable_pour_modif_source_erreur_a_debut_zero,
  indice_distribution_a_debut_zero) then chaine:=rsClicIciPourV;
     if (coco=9) and isligne_distribution(roro,indice_variable_pour_modif_source_erreur_a_debut_zero,
  indice_distribution_a_debut_zero) then chaine:=rsClicIciPourV2;
     if (coco=10) and isligne_distribution(roro,indice_variable_pour_modif_source_erreur_a_debut_zero,
  indice_distribution_a_debut_zero)  then chaine:=rsClicIciPourM4;
       if (coco=10) and isligne_mesurande(roro,
         indice_variable_pour_modif_source_erreur_a_debut_zero)  then chaine:=
         rsClicIciPourM5;



  if chaine<>StringGrid_entree.Hint then begin
  StringGrid_entree.Hint:=chaine;
  Application.ActivateHint(Mouse.CursorPos);
    End;
  end;

procedure TForm1.StringGrid_entreePrepareCanvas(sender: TObject; aCol,
  aRow: Integer; aState: TGridDrawState);
var i,j:integer;    MyTextStyle: TTextStyle;
begin

 StringGrid_entree.Canvas.Brush.Style:= bssolid;
 MyTextStyle:=  StringGrid_entree.Canvas.TextStyle;
 MyTextStyle.Alignment:=tacenter;
 StringGrid_entree.Canvas.TextStyle := MyTextStyle;
 if isligne_intercalaire(arow) then
 begin
 StringGrid_entree.Canvas.Brush.Color :=clblue;
 exit; end;


 if isligne_mesurande(arow,i) then begin
 if ( (acol=2) or (acol=0)) then  StringGrid_entree.Canvas.Brush.Color :=cl3dlight else
 if ((acol=1) or (acol=10)) then StringGrid_entree.Canvas.Brush.Color :=clmoneygreen;
 if (acol=0) then begin
 StringGrid_entree.Canvas.font.Color:=clblue;
 StringGrid_entree.Canvas.font.Style:= StringGrid_entree.Canvas.font.Style+[fsbold];

 end;
 if (acol=2) then begin
 StringGrid_entree.Canvas.font.Color:=clgreen;
 StringGrid_entree.Canvas.font.Style:= StringGrid_entree.Canvas.font.Style+[fsbold];
 end;
 if ((acol>2) and (acol<10)) then begin
  StringGrid_entree.Canvas.Brush.Style:= bsFDiagonal;
  StringGrid_entree.Canvas.Brush.Color :=clblack;
  end;
  exit;
       end;

 if isligne_distribution(arow,i,j) then begin
 if ((acol=3) or (acol=4))  then  StringGrid_entree.Canvas.Brush.Color :=cl3dlight else
  if acol=10 then StringGrid_entree.Canvas.Brush.Color :=clmoneygreen;
 if (acol=4) then begin
 StringGrid_entree.Canvas.font.Color:=clred;
 StringGrid_entree.Canvas.font.Style:= StringGrid_entree.Canvas.font.Style+[fsbold];
 end;
 if (acol=3) then begin
 StringGrid_entree.Canvas.font.Color:=clgreen;
 StringGrid_entree.Canvas.font.Style:= StringGrid_entree.Canvas.font.Style+[fsbold];
 end;
  if (acol<=2) then begin
  StringGrid_entree.Canvas.Brush.Style:= bsFDiagonal;
  StringGrid_entree.Canvas.Brush.Color :=clblack;
  end;
 exit;
 end;




end;










procedure TForm1.TabSheet_entreeShow(Sender: TObject);
begin





  if not (expression_validee) then pagecontrol1.ActivePage:=tabsheet_expression;
end;

procedure TForm1.TabSheet_expressionShow(Sender: TObject);
begin





  edit_saisie_expression.SetFocus;
  edit_saisie_expression.SelStart := Length(edit_saisie_expression.Text);

end;

procedure TForm1.TabSheet_gum2Show(Sender: TObject);
begin
  if existe_correlation then begin


 PageControl_resultats_propagation.ActivePage:=TabSheet_intervalles_normale;
  application.MessageBox(pchar(rsOrdre2NonImp), pchar(rsAttention2), mb_ok);

  end;
end;

procedure TForm1.TabSheet_mcShow(Sender: TObject);
begin

 if existe_correlation then begin

 pagecontrol1.ActivePage:=tabsheet_resultats;
 PageControl_resultats_propagation.ActivePage:=TabSheet_gum1;
  application.MessageBox(pchar(rsProcDureDeMo), pchar(rsAttention2), mb_ok);
  end;




   if not(expression_validee) then begin
  pagecontrol1.ActivePage:=tabsheet_expression;
  exit
  end;
   if not(tous_calculs_faits) then begin
  pagecontrol1.ActivePage:=tabsheet_entree;
  exit
  end;
end;

procedure TForm1.TabSheet_resultatsShow(Sender: TObject);
begin






  if not(expression_validee) then begin
  pagecontrol1.ActivePage:=tabsheet_expression;
  exit
  end;
   if not(tous_calculs_faits) then begin
  pagecontrol1.ActivePage:=tabsheet_entree;
  exit
  end;
end;



procedure TForm1.BitBtn1Click(Sender: TObject);
var i,j,kkk,k:longint;   Vars    : Array OF ArbFloat;  toutes_variables_traitees:boolean;

 incertitude_relative,contribution_correlations_a_la_variance,m3,m4:extended;
  sissi:string;

begin
      if nombre_mesurandes=0
    then begin
  application.MessageBox(pchar(rsIlNYAAucuneV), pchar(rsAttention), mb_ok);
  exit;
  end;

    if nombre_distributions=0
    then begin
  application.MessageBox(pchar(rsAucuneIncert), pchar(rsAttention), mb_ok);
  exit;
  end;

   for i:=1 to   nombre_mesurandes do
if   myisnan(liste_mesurandes[i-1].estimateur) then  begin
 application.MessageBox(pchar(Format(rsPasDeValeurS, [liste_mesurandes[i-1
   ].nom_mesurande])),
 pchar(rsAttention), mb_ok);
 exit;
 end;

       toutes_variables_traitees:=true;
  {for i:=1 to nombre_mesurandes do begin

  end;




  toutes_variables_traitees:=true;
 for i:=1 to nombre_distributions do
 toutes_variables_traitees:=toutes_variables_traitees and liste_distribution_est_traitee[i-1];
  if not(toutes_variables_traitees) then begin
  application.MessageBox(pchar(rsIlYADesVaria), pchar(rsAttention), mb_ok);
  exit;
  end;  }

  setlength(vars,nombre_mesurandes);
  Eval_f:=TEvaluator.Create(Liste_Variables,expr_temp);
   for j:=1 to nombre_mesurandes do
   vars[j-1]:=liste_mesurandes[j-1].estimateur;
   try
   estimateur_sortie:=Eval_f.Evaluate(Vars);
   except
   estimateur_sortie:=NAN;
   application.MessageBox(pchar(rsValeurDeSort), pchar(rsAttention2), mb_ok);
   exit;
   end;
    screen.Cursor:=crhourglass;
   setlength(eval_derivees,nombre_mesurandes);
          setlength(expr_derivees,nombre_mesurandes);
         setlength(valeur_derivees,nombre_mesurandes);

      for j:=1 to nombre_mesurandes do  begin
      expr_derivees[j-1]:=expr_temp.derive(Liste_Variables[j-1]);
     { sissi:=expr_derivees[j-1].InfixExpr;
      application.MessageBox(pchar(sissi),'',mb_ok);    }
      eval_derivees[j-1]:=TEvaluator.Create(Liste_Variables,expr_derivees[j-1]);
      try
            valeur_derivees[j-1]:=eval_derivees[j-1].Evaluate(Vars);
            except
              valeur_derivees[j-1]:=NAN;
              end;

            end;

    setlength(eval_derivees_secondes,nombre_mesurandes,nombre_mesurandes);
          setlength(expr_derivees_secondes,nombre_mesurandes,nombre_mesurandes);
         setlength(valeur_derivees_secondes,nombre_mesurandes,nombre_mesurandes);

     setlength(eval_derivees_troisiemes,nombre_mesurandes,nombre_mesurandes);
          setlength(expr_derivees_troisiemes,nombre_mesurandes,nombre_mesurandes);
         setlength(valeur_derivees_troisiemes,nombre_mesurandes,nombre_mesurandes);

         setlength(contributions_croisees,nombre_distributions,nombre_distributions);


         for i:=1 to nombre_mesurandes do
         for j:=1 to nombre_mesurandes do begin
         expr_derivees_secondes[i-1,j-1]:=expr_derivees[i-1].Derive(Liste_Variables[j-1]);
        { sissi:=expr_derivees_secondes[i-1,j-1].InfixExpr;
      application.MessageBox(pchar(sissi),'',mb_ok); }
         eval_derivees_secondes[i-1,j-1]:=TEvaluator.Create(Liste_Variables,expr_derivees_secondes[i-1,j-1]);
      try
            valeur_derivees_secondes[i-1,j-1]:=eval_derivees_secondes[i-1,j-1].Evaluate(Vars);
            except
              valeur_derivees_secondes[i-1,j-1]:=NAN;
              end;

            end;

       for i:=1 to nombre_mesurandes do
         for j:=1 to nombre_mesurandes do begin
         expr_derivees_troisiemes[i-1,j-1]:=expr_derivees_secondes[j-1,j-1].Derive(Liste_Variables[i-1]);
         eval_derivees_troisiemes[i-1,j-1]:=TEvaluator.Create(Liste_Variables,expr_derivees_troisiemes[i-1,j-1]);
      try
            valeur_derivees_troisiemes[i-1,j-1]:=eval_derivees_troisiemes[i-1,j-1].Evaluate(Vars);
            except
              valeur_derivees_troisiemes[i-1,j-1]:=NAN;
              end;

            end;
       for i:=1 to nombre_distributions do
       for j:=1 to nombre_distributions do

       begin
       try
      contributions_croisees[i-1,j-1]:=(  sqr(valeur_derivees_secondes[liste_distributions[i-1].indice_de_la_variable_correspondante,
      liste_distributions[j-1].indice_de_la_variable_correspondante])/2+
       valeur_derivees[liste_distributions[i-1].indice_de_la_variable_correspondante]*valeur_derivees_troisiemes[liste_distributions[i-1].indice_de_la_variable_correspondante
       ,liste_distributions[j-1].indice_de_la_variable_correspondante])*sqr(liste_distributions[i-1].incertitude_type*
       liste_distributions[j-1].incertitude_type);
          except
       contributions_croisees[i-1,j-1]:=nan;
          end;

       end;
      stringgrid1.RowCount:=1+nombre_distributions;
      stringgrid1.Cells[0,0]:='xij';
      stringgrid1.Cells[1,0]:='ci';

      stringgrid1.Cells[2,0]:='u(xij)';
      stringgrid1.Cells[3, 0]:=rsContribution;


     for j:=1 to nombre_mesurandes do begin
     liste_mesurandes[j-1].incertitude_type:=0;
     if  liste_mesurandes[j-1].nombre_erreurs>0 then
     for i:=1 to liste_mesurandes[j-1].nombre_erreurs do
     liste_mesurandes[j-1].incertitude_type:=liste_mesurandes[j-1].incertitude_type+sqr(liste_distributions[liste_mesurandes[j-1].liste_des_indices_des_sources_derreur[i-1]].incertitude_type);
     liste_mesurandes[j-1].incertitude_type:=sqrt(liste_mesurandes[j-1].incertitude_type);
     end;

     StringGrid_incertitudes_mesurandes.RowCount:=1+nombre_mesurandes;
      StringGrid_incertitudes_mesurandes.ColCount:=2;
       StringGrid_incertitudes_mesurandes.Cells[0, 0]:=rsMesurandeXi;
      StringGrid_incertitudes_mesurandes.Cells[1,0]:='u(xi)';
        for j:=1 to nombre_mesurandes do begin
        StringGrid_incertitudes_mesurandes.Cells[0,j]:=liste_mesurandes[j-1].nom_mesurande;
      StringGrid_incertitudes_mesurandes.Cells[1,j]:=Donne_Avec_Chiffres_Significatifs(liste_mesurandes[j-1].incertitude_type,3,
      mon_genre_affichage_valeur_individuelle,ma_longueur_chaine_agreable_valeur_individuelle);
              end;
        StringGrid_incertitudes_mesurandes.AutoAdjustColumns;

  incertitude_type_sortie:=0;
  try
  for j:=1 to nombre_mesurandes do
  if liste_mesurandes[j-1].nombre_erreurs>0 then
  for i:=1 to liste_mesurandes[j-1].nombre_erreurs do
  incertitude_type_sortie:=incertitude_type_sortie+sqr(valeur_derivees[j-1]*
  liste_distributions[liste_mesurandes[j-1].liste_des_indices_des_sources_derreur[i-1]].incertitude_type);
   incertitude_type_sortie:=sqrt(incertitude_type_sortie);
     except
      incertitude_type_sortie:=nan;
     end;


  contribution_correlations_a_la_variance:=0;
  if nombre_distributions>1 then
  for i:=1 to nombre_distributions-1 do
  for j:=i+1 to nombre_distributions do
  if  (liste_descripteur_correlation[i-1,j-1].valeur<>0) and
  (not(isnan(valeur_derivees[liste_distributions[i-1].indice_de_la_variable_correspondante])))
  and
  (not(isnan(valeur_derivees[liste_distributions[j-1].indice_de_la_variable_correspondante])))
 then
 if liste_descripteur_correlation[i-1,j-1].t_correlation=c_correlation then
 contribution_correlations_a_la_variance:=contribution_correlations_a_la_variance+
 valeur_derivees[liste_distributions[i-1].indice_de_la_variable_correspondante]*
  valeur_derivees[liste_distributions[j-1].indice_de_la_variable_correspondante]*
   liste_descripteur_correlation[i-1,j-1].valeur*
    liste_distributions[i-1].incertitude_type*
    liste_distributions[j-1].incertitude_type
    else
    contribution_correlations_a_la_variance:=contribution_correlations_a_la_variance+
 valeur_derivees[liste_distributions[i-1].indice_de_la_variable_correspondante]*
  valeur_derivees[liste_distributions[j-1].indice_de_la_variable_correspondante]*
   liste_descripteur_correlation[i-1,j-1].valeur;

   contribution_correlations_a_la_variance:=2*contribution_correlations_a_la_variance;
   if not(isnan(incertitude_type_sortie)) and not(isnan(contribution_correlations_a_la_variance)) then
   if  (contribution_correlations_a_la_variance<=-sqr(incertitude_type_sortie)) and
   not((incertitude_type_sortie=0) and (contribution_correlations_a_la_variance=0)) then begin
   application.MessageBox(pchar(rsLaPriseEnCom),
   pchar(rsAttention2), mb_ok);
   incertitude_type_sortie:=nan;
   pagecontrol1.ActivePage:=tabsheet_entree;
    screen.Cursor:=crdefault;
   exit;
   end else
 incertitude_type_sortie:=sqrt(sqr(incertitude_type_sortie)+contribution_correlations_a_la_variance);

 incertitude_type_sortie_ordre1:=incertitude_type_sortie;

 existe_correlation:=false;
 for i:=1 to nombre_distributions do
 for j:=1 to nombre_distributions do
 if i<>j then
  existe_correlation:= existe_correlation or (liste_descripteur_correlation[i-1,j-1].valeur<>0);







      With Chart1 Do
Begin
Title.text.Clear;
if (not(existe_correlation)) or (existe_correlation and (contribution_correlations_a_la_variance>0)) then
Title.Text.Add(rsContribution3)
else
 Title.Text.Add(rsContribution4) ;
Title.visible := True;
Legend.Visible:= True;
end;

        With Chart2 Do
Begin
Title.text.Clear;
if (not(existe_correlation)) or (existe_correlation and (contribution_correlations_a_la_variance>0)) then
Title.Text.Add(rsContribution3)
else
 Title.Text.Add(rsContribution4) ;
Title.visible := True;
Legend.Visible:= True;
end;

     ListChartSource1.clear;
    if (not(existe_correlation)) or (existe_correlation and (contribution_correlations_a_la_variance>0)) then        stringgrid1.Cells[4, 0]:=rsContribution2;

      kkk:=0;
   for j:=1 to nombre_mesurandes do  begin
    if liste_mesurandes[j-1].nombre_erreurs>0 then
  for i:=1 to liste_mesurandes[j-1].nombre_erreurs do  begin
  inc(kkk);
  stringgrid1.Cells[0,kkk]:=liste_distributions[liste_mesurandes[j-1].liste_des_indices_des_sources_derreur[i-1]].nom_variable;
             stringgrid1.Cells[1,kkk]:=( Donne_Avec_Chiffres_Significatifs(valeur_derivees[j-1],3,mon_genre_affichage_valeur_individuelle,ma_longueur_chaine_agreable_valeur_individuelle));

          stringgrid1.Cells[2,kkk]:=(Donne_Avec_Chiffres_Significatifs(liste_distributions[liste_mesurandes[j-1].liste_des_indices_des_sources_derreur[i-1]].incertitude_type,3,
          mon_genre_affichage_valeur_individuelle,ma_longueur_chaine_agreable_valeur_individuelle));
  stringgrid1.Cells[3,kkk]:=Donne_Avec_Chiffres_Significatifs(sqr(valeur_derivees[j-1]*
  liste_distributions[liste_mesurandes[j-1].liste_des_indices_des_sources_derreur[i-1]].incertitude_type),3,mon_genre_affichage_valeur_individuelle,ma_longueur_chaine_agreable_valeur_individuelle);
 if (not(existe_correlation)) or (existe_correlation and (contribution_correlations_a_la_variance>0)) then
 if incertitude_type_sortie<>0 then
 stringgrid1.Cells[4,kkk]:=
 Donne_Avec_Chiffres_Significatifs(sqr(valeur_derivees[j-1]*
  liste_distributions[liste_mesurandes[j-1].liste_des_indices_des_sources_derreur[i-1]].incertitude_type)/
  sqr(incertitude_type_sortie)*100,3,mon_genre_affichage_valeur_individuelle,ma_longueur_chaine_agreable_valeur_individuelle)+' %'
 else
  stringgrid1.Cells[4,kkk]:='NAN %';
   if ((not(existe_correlation)) or (existe_correlation and (contribution_correlations_a_la_variance>0)))
   and (incertitude_type_sortie<>0) then
  ListChartSource1.Add({liste_mesurandes[j-1].liste_des_indices_des_sources_derreur[i-1]+1}kkk,
  sqr(valeur_derivees[j-1]*liste_distributions[liste_mesurandes[j-1].liste_des_indices_des_sources_derreur[i-1]].incertitude_type)/
  sqr(incertitude_type_sortie)*100,liste_distributions[liste_mesurandes[j-1].liste_des_indices_des_sources_derreur[i-1]].nom_variable,rgb(random(255),random(255),random(255)))
  else
   ListChartSource1.Add({liste_mesurandes[j-1].liste_des_indices_des_sources_derreur[i-1]+1}kkk,
  sqr(valeur_derivees[j-1]*liste_distributions[liste_mesurandes[j-1].liste_des_indices_des_sources_derreur[i-1]].incertitude_type),
  liste_distributions[liste_mesurandes[j-1].liste_des_indices_des_sources_derreur[i-1]].nom_variable,rgb(random(255),random(255),random(255)))  ;


  end;

   end;
    radiogroup1.Enabled:=true;
    if(existe_correlation) then
    if contribution_correlations_a_la_variance<0 then  begin
     ListChartSource1.Add(kkk+1,
  contribution_correlations_a_la_variance, rsCorrLations, rgb(random(255),
    random(255), random(255))) ;

     radiogroup1.ItemIndex:=0;
     radiogroup1.Enabled:=false;
      chart1.Visible:=true;
  chart2.Visible:=false;
    end
    else   begin
   ListChartSource1.Add(kkk+1,
  contribution_correlations_a_la_variance/
  sqr(incertitude_type_sortie)*100, rsCorrLations, rgb(random(255), random(255
    ), random(255)));
    end;
     if(existe_correlation) then   begin
     stringgrid1.RowCount:=1+nombre_distributions+3;
     stringgrid1.Cells[3, 1+nombre_distributions+2-1]:=rsContribution5;
     stringgrid1.Cells[3,1+nombre_distributions+3-1]:=Donne_Avec_Chiffres_Significatifs(contribution_correlations_a_la_variance,3,mon_genre_affichage_valeur_individuelle,ma_longueur_chaine_agreable_valeur_individuelle); ;
     if contribution_correlations_a_la_variance>0 then begin
     stringgrid1.Cells[4, 1+nombre_distributions+2-1]:=rsContribution6;
     stringgrid1.Cells[4,1+nombre_distributions+3-1]:=Donne_Avec_Chiffres_Significatifs(contribution_correlations_a_la_variance/
  sqr(incertitude_type_sortie)*100,3,mon_genre_affichage_valeur_individuelle,ma_longueur_chaine_agreable_valeur_individuelle);
     end;
     end;

   stringgrid1.AutoSizeColumns;







    stringgrid2.Cells[0, 0]:=Format(rsEstimateurDe, [symbole_grandeur_sortie]);
    stringgrid2.Cells[0,1]:=(Donne_Selon_Incertitude_Sans_Incertitude(estimateur_sortie,
    incertitude_type_sortie,3,option_tronque_a_zero_quand_incertitude_trop_grande,option_arrondi_superieur_incertitude,
    mon_genre_affichage_incertitude,ma_longueur_chaine_agreable_incertitude))+' '+symbole_unite;
    stringgrid2.Cells[1, 0]:=Format(rsIncertitudeT, [symbole_grandeur_sortie]);

    stringgrid2.Cells[1,1]:=Donne_Avec_Chiffres_Significatifs(incertitude_type_sortie,3,mon_genre_affichage_valeur_individuelle,ma_longueur_chaine_agreable_valeur_individuelle)+' '+symbole_unite;
      stringgrid2.AutoSizeColumns;
    stringgrid2.Cells[2, 0]:=Format(rsIncertitudeT4, [symbole_grandeur_sortie,
      symbole_grandeur_sortie]);
    if estimateur_sortie<>0 then incertitude_relative:=incertitude_type_sortie/estimateur_sortie else
      incertitude_relative:=NAN;

    stringgrid2.Cells[2,1]:=Donne_Avec_Chiffres_Significatifs(incertitude_relative,3,mon_genre_affichage_valeur_individuelle,ma_longueur_chaine_agreable_valeur_individuelle)
    +' = '+Donne_Avec_Chiffres_Significatifs(incertitude_relative*100,3,mon_genre_affichage_valeur_individuelle,ma_longueur_chaine_agreable_valeur_individuelle)+'%';
      stringgrid2.AutoSizeColumns;



      {gum ordre 2}


      incertitude_type_sortie:=sqr(incertitude_type_sortie);
   stringgrid8.RowCount:=1+nombre_distributions;
    stringgrid8.colCount:=1+nombre_distributions;
    for j:=1 to nombre_distributions do
    stringgrid8.Cells[0,j]:=liste_distributions[j-1].nom_variable;
     for j:=1 to nombre_distributions do
    stringgrid8.Cells[j,0]:=liste_distributions[j-1].nom_variable;
     for i:=1 to nombre_distributions do
      for j:=1 to nombre_distributions do begin
     stringgrid8.Cells[i,j]:=(Donne_Avec_Chiffres_Significatifs(contributions_croisees[i-1,j-1],3,mon_genre_affichage_valeur_individuelle,ma_longueur_chaine_agreable_valeur_individuelle));
    incertitude_type_sortie:=incertitude_type_sortie+contributions_croisees[i-1,j-1];
    end;


   stringgrid8.AutoSizeColumns;

      incertitude_type_sortie:=sqrt(incertitude_type_sortie);


    stringgrid9.Cells[0, 0]:=Format(rsEstimateurDe, [symbole_grandeur_sortie]);
    stringgrid9.Cells[0,1]:=(Donne_Selon_Incertitude_Sans_Incertitude(estimateur_sortie,
    incertitude_type_sortie,3,option_tronque_a_zero_quand_incertitude_trop_grande,option_arrondi_superieur_incertitude,
    mon_genre_affichage_incertitude,ma_longueur_chaine_agreable_incertitude))+' '+symbole_unite;
    stringgrid9.Cells[1, 0]:=Format(rsIncertitudeT, [symbole_grandeur_sortie]);
    stringgrid9.Cells[1,1]:=(Donne_Avec_Chiffres_Significatifs(incertitude_type_sortie,3,mon_genre_affichage_valeur_individuelle,ma_longueur_chaine_agreable_valeur_individuelle)+' '+symbole_unite);
      stringgrid9.AutoSizeColumns;
     stringgrid9.Cells[2, 0]:=Format(rsIncertitudeT4, [symbole_grandeur_sortie,
      symbole_grandeur_sortie]);
    if estimateur_sortie<>0 then incertitude_relative:=incertitude_type_sortie/estimateur_sortie else
      incertitude_relative:=NAN;
    stringgrid9.Cells[2,1]:=Donne_Avec_Chiffres_Significatifs(incertitude_relative,3,mon_genre_affichage_valeur_individuelle,ma_longueur_chaine_agreable_valeur_individuelle)
    +' = '+Donne_Avec_Chiffres_Significatifs(incertitude_relative*100,3,mon_genre_affichage_valeur_individuelle,ma_longueur_chaine_agreable_valeur_individuelle)+'%';
      stringgrid9.AutoSizeColumns;

  {fin gum ordre 2}




  {calcul degre liberte effectif global}
  degre_effectif_global:=0;
  for j:=1 to nombre_mesurandes do
  if liste_mesurandes[j-1].nombre_erreurs>0 then
  for i:=1 to liste_mesurandes[j-1].nombre_erreurs do
  if (
  not(myisnan(liste_distributions[liste_mesurandes[j-1].liste_des_indices_des_sources_derreur[i-1]].degres_de_liberte_effectif))
  and
    not(myisnan(liste_distributions[liste_mesurandes[j-1].liste_des_indices_des_sources_derreur[i-1]].incertitude_type))
    and
   not(myisnan(valeur_derivees[j-1]) )
  and
  (liste_distributions[liste_mesurandes[j-1].liste_des_indices_des_sources_derreur[i-1]].degres_de_liberte_effectif<>0)
  )

  then
  degre_effectif_global:=degre_effectif_global+sqr(sqr(liste_distributions[liste_mesurandes[j-1].liste_des_indices_des_sources_derreur[i-1]].incertitude_type*
  valeur_derivees[j-1]))/
  liste_distributions[liste_mesurandes[j-1].liste_des_indices_des_sources_derreur[i-1]].degres_de_liberte_effectif;
 if degre_effectif_global<>0 then  degre_effectif_global:=sqr(sqr(incertitude_type_sortie))/degre_effectif_global;
 if degre_effectif_global<>0 then
 edit_degre_global.Text:=floattostr(degre_effectif_global)
 else  edit_degre_global.Text:='Infini';


 une_seule_rectangulaire:= ((nombre_distributions=1) and (liste_distributions[0].tyty=d_rectangle));

  SpeedButton_paslegitime1.Visible:=une_seule_rectangulaire;
   SpeedButton_paslegitime2.Visible:=une_seule_rectangulaire;



   coef_elarg_95_normale:=1.959963985;
   coef_elarg_99_normale:=2.575829304;
   coef_elarg_75_normale:=1.150349380;

   if myisnan(incertitude_type_sortie) then incertitude_type_sortie:=incertitude_type_sortie_ordre1;


    stringgrid3.ColCount:=6;
  stringgrid3.RowCount:=4;

    stringgrid3.Cells[0, 0]:=rsTauxDeConfia;
     stringgrid3.Cells[1, 0]:=rsFacteurDLarg;
     stringgrid3.Cells[2, 0]:=rsIncertitudeL;
    stringgrid3.Cells[3, 0]:=rsIntervalleYU;


     stringgrid3.Cells[4, 0]:=rsEcritureFina;
      stringgrid3.Cells[5, 0]:=rsEcritureFina2;
    stringgrid3.Cells[0,1]:='75%';
    stringgrid3.Cells[1,1]:=Donne_Avec_Chiffres_Significatifs(coef_elarg_75_normale,3,mon_genre_affichage_valeur_individuelle,ma_longueur_chaine_agreable_valeur_individuelle);
    stringgrid3.Cells[3,1]:='['+
    (Donne_Selon_Incertitude_Sans_Incertitude(estimateur_sortie-incertitude_type_sortie*coef_elarg_75_normale,
     incertitude_type_sortie*coef_elarg_75_normale,3,option_tronque_a_zero_quand_incertitude_trop_grande,option_arrondi_superieur_incertitude,
    mon_genre_affichage_incertitude,ma_longueur_chaine_agreable_incertitude))
    +' ; '+(Donne_Selon_Incertitude_Sans_Incertitude( estimateur_sortie+incertitude_type_sortie*coef_elarg_75_normale,
     incertitude_type_sortie*coef_elarg_75_normale,3,option_tronque_a_zero_quand_incertitude_trop_grande,option_arrondi_superieur_incertitude,
    mon_genre_affichage_incertitude,ma_longueur_chaine_agreable_incertitude))+']';
    stringgrid3.Cells[2,1]:=Donne_Avec_Chiffres_Significatifs(incertitude_type_sortie*coef_elarg_75_normale,3,mon_genre_affichage_valeur_individuelle,ma_longueur_chaine_agreable_valeur_individuelle)+' '+symbole_unite;
    stringgrid3.Cells[4,1]:=(Donne_Selon_Incertitude(estimateur_sortie,incertitude_type_sortie*coef_elarg_75_normale,1,option_tronque_a_zero_quand_incertitude_trop_grande,option_arrondi_superieur_incertitude,mon_genre_affichage_incertitude,ma_longueur_chaine_agreable_incertitude))+symbole_unite;
    stringgrid3.Cells[5,1]:=(Donne_Selon_Incertitude(estimateur_sortie,incertitude_type_sortie*coef_elarg_75_normale,2,option_tronque_a_zero_quand_incertitude_trop_grande,option_arrondi_superieur_incertitude,mon_genre_affichage_incertitude,ma_longueur_chaine_agreable_incertitude))+symbole_unite;
      stringgrid3.Cells[0,2]:='95%';
      stringgrid3.Cells[1,2]:=Donne_Avec_Chiffres_Significatifs(coef_elarg_95_normale,3,mon_genre_affichage_valeur_individuelle,ma_longueur_chaine_agreable_valeur_individuelle);
    stringgrid3.Cells[3,2]:='['+(Donne_Selon_Incertitude_Sans_Incertitude(estimateur_sortie-incertitude_type_sortie*coef_elarg_95_normale,
    incertitude_type_sortie*coef_elarg_95_normale,3,option_tronque_a_zero_quand_incertitude_trop_grande,option_arrondi_superieur_incertitude,
    mon_genre_affichage_incertitude,ma_longueur_chaine_agreable_incertitude))+' ; '+(Donne_Selon_Incertitude_Sans_Incertitude(estimateur_sortie+incertitude_type_sortie*coef_elarg_95_normale,
    incertitude_type_sortie*coef_elarg_95_normale,3,option_tronque_a_zero_quand_incertitude_trop_grande,option_arrondi_superieur_incertitude,
    mon_genre_affichage_incertitude,ma_longueur_chaine_agreable_incertitude))+']';
    stringgrid3.Cells[2,2]:=Donne_Avec_Chiffres_Significatifs(incertitude_type_sortie*coef_elarg_95_normale,3,mon_genre_affichage_valeur_individuelle,ma_longueur_chaine_agreable_valeur_individuelle)+' '+symbole_unite;
    stringgrid3.Cells[4,2]:=(Donne_Selon_Incertitude(estimateur_sortie,incertitude_type_sortie*coef_elarg_95_normale,1,option_tronque_a_zero_quand_incertitude_trop_grande,option_arrondi_superieur_incertitude,mon_genre_affichage_incertitude,ma_longueur_chaine_agreable_incertitude))+symbole_unite;
    stringgrid3.Cells[5,2]:=(Donne_Selon_Incertitude(estimateur_sortie,incertitude_type_sortie*coef_elarg_95_normale,2,option_tronque_a_zero_quand_incertitude_trop_grande,option_arrondi_superieur_incertitude,mon_genre_affichage_incertitude,ma_longueur_chaine_agreable_incertitude))+symbole_unite;
     stringgrid3.Cells[0,3]:='99%';
     stringgrid3.Cells[1,3]:=(Donne_Avec_Chiffres_Significatifs(coef_elarg_99_normale,3,mon_genre_affichage_valeur_individuelle,ma_longueur_chaine_agreable_valeur_individuelle));
    stringgrid3.Cells[3,3]:='['+(Donne_Selon_Incertitude_Sans_Incertitude(estimateur_sortie-incertitude_type_sortie*coef_elarg_99_normale,
     incertitude_type_sortie*coef_elarg_99_normale,3,option_tronque_a_zero_quand_incertitude_trop_grande,option_arrondi_superieur_incertitude,
    mon_genre_affichage_incertitude,ma_longueur_chaine_agreable_incertitude))+' ; '+(Donne_Selon_Incertitude_Sans_Incertitude(estimateur_sortie+incertitude_type_sortie*coef_elarg_99_normale,
     incertitude_type_sortie*coef_elarg_99_normale,3,option_tronque_a_zero_quand_incertitude_trop_grande,option_arrondi_superieur_incertitude,
    mon_genre_affichage_incertitude,ma_longueur_chaine_agreable_incertitude))+']';
    stringgrid3.Cells[2,3]:=(Donne_Avec_Chiffres_Significatifs(incertitude_type_sortie*coef_elarg_99_normale,3,mon_genre_affichage_valeur_individuelle,ma_longueur_chaine_agreable_valeur_individuelle)+' '+symbole_unite);
    stringgrid3.Cells[4,3]:=(Donne_Selon_Incertitude(estimateur_sortie,incertitude_type_sortie*coef_elarg_99_normale,1,option_tronque_a_zero_quand_incertitude_trop_grande,option_arrondi_superieur_incertitude,mon_genre_affichage_incertitude,ma_longueur_chaine_agreable_incertitude))+symbole_unite;
    stringgrid3.Cells[5,3]:=(Donne_Selon_Incertitude(estimateur_sortie,incertitude_type_sortie*coef_elarg_99_normale,2,option_tronque_a_zero_quand_incertitude_trop_grande,option_arrondi_superieur_incertitude,mon_genre_affichage_incertitude,ma_longueur_chaine_agreable_incertitude))+symbole_unite;
       stringgrid3.AutoSizeColumns;

        if ((degre_effectif_global>0) and (degre_effectif_global<1000)) then begin
        try
       coef_elarg_95_student:=abs(t_invx(floor(degre_effectif_global),(1-0.95)/2))+
       frac(degre_effectif_global)*(
       abs(t_invx(floor(degre_effectif_global)+1,(1-0.95)/2))
       -
       abs(t_invx(floor(degre_effectif_global),(1-0.95)/2))
       );
       except
        coef_elarg_95_student:=NAN;

       end;

       try
       coef_elarg_99_student:=
       abs(t_invx(floor(degre_effectif_global),(1-0.99)/2))+
       frac(degre_effectif_global)*(
       abs(t_invx(floor(degre_effectif_global)+1,(1-0.99)/2))
       -
       abs(t_invx(floor(degre_effectif_global),(1-0.99)/2))
       );
       except
        coef_elarg_99_student:=NAN;
         end;
        try
        coef_elarg_75_student:= abs(t_invx(floor(degre_effectif_global),(1-0.75)/2))+
       frac(degre_effectif_global)*(
       abs(t_invx(floor(degre_effectif_global)+1,(1-0.75)/2))
       -
       abs(t_invx(floor(degre_effectif_global),(1-0.75)/2))
       );
        except
         coef_elarg_75_student:=NAN;
        end;
        end else begin
        coef_elarg_95_student:=1.959963985;
   coef_elarg_99_student:=2.575829304;
   coef_elarg_75_student:=1.150349380;

        end;



       stringgrid4.ColCount:=6;
  stringgrid4.RowCount:=4;
    stringgrid4.Cells[0, 0]:=rsTauxDeConfia;
     stringgrid4.Cells[1, 0]:=rsFacteurDLarg2;
      stringgrid4.Cells[2, 0]:=rsIncertitudeL;
    stringgrid4.Cells[3, 0]:=rsIntervalleYU;
       stringgrid4.Cells[4, 0]:=rsEcritureFina;
      stringgrid4.Cells[5, 0]:=rsEcritureFina2;
    stringgrid4.Cells[0,1]:='75%';
    stringgrid4.Cells[1,1]:=(Donne_Avec_Chiffres_Significatifs(coef_elarg_75_student,3,mon_genre_affichage_valeur_individuelle,ma_longueur_chaine_agreable_valeur_individuelle));
    stringgrid4.Cells[3,1]:='['+(Donne_Selon_Incertitude_Sans_Incertitude(estimateur_sortie-incertitude_type_sortie*coef_elarg_75_student,
    incertitude_type_sortie*coef_elarg_75_student,3,option_tronque_a_zero_quand_incertitude_trop_grande,option_arrondi_superieur_incertitude,
    mon_genre_affichage_incertitude,ma_longueur_chaine_agreable_incertitude))+' ; '+(Donne_Selon_Incertitude_Sans_Incertitude(estimateur_sortie+incertitude_type_sortie*coef_elarg_75_student,
    incertitude_type_sortie*coef_elarg_75_student,3,option_tronque_a_zero_quand_incertitude_trop_grande,option_arrondi_superieur_incertitude,
    mon_genre_affichage_incertitude,ma_longueur_chaine_agreable_incertitude))+']';
    stringgrid4.Cells[2,1]:=(Donne_Avec_Chiffres_Significatifs(incertitude_type_sortie*coef_elarg_75_student,3,mon_genre_affichage_valeur_individuelle,ma_longueur_chaine_agreable_valeur_individuelle)+' '+symbole_unite);
    stringgrid4.Cells[4,1]:=(Donne_Selon_Incertitude(estimateur_sortie,incertitude_type_sortie*coef_elarg_75_student,1,option_tronque_a_zero_quand_incertitude_trop_grande,option_arrondi_superieur_incertitude,mon_genre_affichage_incertitude,ma_longueur_chaine_agreable_incertitude))+symbole_unite;
    stringgrid4.Cells[5,1]:=(Donne_Selon_Incertitude(estimateur_sortie,incertitude_type_sortie*coef_elarg_75_student,2,option_tronque_a_zero_quand_incertitude_trop_grande,option_arrondi_superieur_incertitude,mon_genre_affichage_incertitude,ma_longueur_chaine_agreable_incertitude))+symbole_unite;
      stringgrid4.Cells[0,2]:='95%';
      stringgrid4.Cells[1,2]:=(Donne_Avec_Chiffres_Significatifs(coef_elarg_95_student,3,mon_genre_affichage_valeur_individuelle,ma_longueur_chaine_agreable_valeur_individuelle));
    stringgrid4.Cells[3,2]:='['+(Donne_Selon_Incertitude_Sans_Incertitude(estimateur_sortie-incertitude_type_sortie*coef_elarg_95_student,
     incertitude_type_sortie*coef_elarg_95_student, 3,option_tronque_a_zero_quand_incertitude_trop_grande,option_arrondi_superieur_incertitude,
    mon_genre_affichage_incertitude,ma_longueur_chaine_agreable_incertitude))+' ; '+(Donne_Selon_Incertitude_Sans_Incertitude(estimateur_sortie+incertitude_type_sortie*coef_elarg_95_student,
      incertitude_type_sortie*coef_elarg_95_student,3,option_tronque_a_zero_quand_incertitude_trop_grande,option_arrondi_superieur_incertitude,
    mon_genre_affichage_incertitude,ma_longueur_chaine_agreable_incertitude))+']';
    stringgrid4.Cells[2,2]:=(Donne_Avec_Chiffres_Significatifs(incertitude_type_sortie*coef_elarg_95_student,3,mon_genre_affichage_valeur_individuelle,ma_longueur_chaine_agreable_valeur_individuelle)+' '+symbole_unite);
    stringgrid4.Cells[4,2]:=(Donne_Selon_Incertitude(estimateur_sortie,incertitude_type_sortie*coef_elarg_95_student,1,option_tronque_a_zero_quand_incertitude_trop_grande,option_arrondi_superieur_incertitude,mon_genre_affichage_incertitude,ma_longueur_chaine_agreable_incertitude))+symbole_unite;
    stringgrid4.Cells[5,2]:=(Donne_Selon_Incertitude(estimateur_sortie,incertitude_type_sortie*coef_elarg_95_student,2,option_tronque_a_zero_quand_incertitude_trop_grande,option_arrondi_superieur_incertitude,mon_genre_affichage_incertitude,ma_longueur_chaine_agreable_incertitude))+symbole_unite;
     stringgrid4.Cells[0,3]:='99%';
     stringgrid4.Cells[1,3]:=(Donne_Avec_Chiffres_Significatifs(coef_elarg_99_student,3,mon_genre_affichage_valeur_individuelle,ma_longueur_chaine_agreable_valeur_individuelle));
    stringgrid4.Cells[3,3]:='['+(Donne_Selon_Incertitude_Sans_Incertitude(estimateur_sortie-incertitude_type_sortie*coef_elarg_99_student,
       incertitude_type_sortie*coef_elarg_99_student,3,option_tronque_a_zero_quand_incertitude_trop_grande,option_arrondi_superieur_incertitude,
    mon_genre_affichage_incertitude,ma_longueur_chaine_agreable_incertitude))+' ; '+(Donne_Selon_Incertitude_Sans_Incertitude(estimateur_sortie+incertitude_type_sortie*coef_elarg_99_student,
     incertitude_type_sortie*coef_elarg_99_student,3,option_tronque_a_zero_quand_incertitude_trop_grande,option_arrondi_superieur_incertitude,
    mon_genre_affichage_incertitude,ma_longueur_chaine_agreable_incertitude))+']';
    stringgrid4.Cells[2,3]:=Donne_Avec_Chiffres_Significatifs(incertitude_type_sortie*coef_elarg_99_student,3,mon_genre_affichage_valeur_individuelle,ma_longueur_chaine_agreable_valeur_individuelle)+' '+symbole_unite;
    stringgrid4.Cells[4,3]:=(Donne_Selon_Incertitude(estimateur_sortie,incertitude_type_sortie*coef_elarg_99_student,1,option_tronque_a_zero_quand_incertitude_trop_grande,option_arrondi_superieur_incertitude,mon_genre_affichage_incertitude,ma_longueur_chaine_agreable_incertitude))+symbole_unite;
    stringgrid4.Cells[5,3]:=(Donne_Selon_Incertitude(estimateur_sortie,incertitude_type_sortie*coef_elarg_99_student,2,option_tronque_a_zero_quand_incertitude_trop_grande,option_arrondi_superieur_incertitude,mon_genre_affichage_incertitude,ma_longueur_chaine_agreable_incertitude))+symbole_unite;
       stringgrid4.AutoSizeColumns;





    echantillon_inexploitable:=false;
  setlength(liste_echantillon_sortie,nombre_par_echantillon);
   for i:=1 to nombre_par_echantillon do begin
   for j:=1 to nombre_mesurandes do  begin
   vars[j-1]:=liste_mesurandes[j-1].estimateur;
   if  liste_mesurandes[j-1].nombre_erreurs>0 then
   for k:=1 to  liste_mesurandes[j-1].nombre_erreurs do
  vars[j-1]:=vars[j-1]+copie_liste_echantillons_entree[liste_mesurandes[j-1].liste_des_indices_des_sources_derreur[k-1]][i-1];

   end;
   try
     liste_echantillon_sortie[i-1]:=Eval_f.Evaluate(Vars);
     except
    liste_echantillon_sortie[i-1]:=NAN;
    echantillon_inexploitable:=true;
    end;

   end;

   if not(echantillon_inexploitable) then begin


  Tri_Rapide(liste_echantillon_sortie,nombre_par_echantillon);
 Decale_Doublons(liste_echantillon_sortie,nombre_par_echantillon);

   mc.LimitesEtAxes(@image_sortie_integre,liste_echantillon_sortie[0],liste_echantillon_sortie[nombre_par_echantillon-1],0
         ,1,0,1,image_sortie_integre.width,
image_sortie_integre.Height, rsFonctionDeDi, policetitre, true, clwhite, true,
  1, clblack,
true,1,4,clblue,policegraduation, true,false,1,clblue,
clblack,'x','f(x)','','','','',
false ,true,false);
  nb_points_traces:=200;
 for kkk:=0 to nb_points_traces do begin
 mc.croixx(liste_echantillon_sortie[0]+(liste_echantillon_sortie[nombre_par_echantillon-1]-liste_echantillon_sortie[0])*kkk/nb_points_traces,
 Fonction_Distribution(liste_echantillon_sortie,nombre_par_echantillon,liste_echantillon_sortie[0]+
 (liste_echantillon_sortie[nombre_par_echantillon-1]-liste_echantillon_sortie[0])*kkk/nb_points_traces),
 2,1,clblue,pmcopy,true);


   end;

Statistiques_Par_Classe(liste_echantillon_sortie,nombre_par_echantillon,nombre_de_classes,
 bornes,effectifs,densites,eff_max,densite_max);
  mc.LimitesEtAxes(@image_sortie_densite,bornes[0],bornes[nombre_de_classes],0
         ,densite_max,0,densite_max,image_sortie_densite.width,
image_sortie_densite.Height, rsDensitDeProb, policetitre, true, clwhite, true,
  1, clblack,
true,1,4,clblue,policegraduation, true,false,1,clblue,
clblack,'x','f(x)','','','','',
false ,true,false);
 for kkk:=1 to nombre_de_classes do
 mc.MonRectangle(bornes[kkk-1],0,bornes[kkk],densites[kkk-1],clblue,true);


Calcule_Moyenne_Et_Ecart_Type(liste_echantillon_sortie,nombre_par_echantillon,moyenne_sortie,ecart_type_sortie,skewness_sortie,kurtosis_sortie);
//AMath. momentx(liste_echantillon_sortie,nombre_par_echantillon,moyenne_sortie,ecart_type_sortie,m3,m4,skewness_sortie,kurtosis_sortie);
 Intervalle_Recouvrement_Le_Plus_Court(0.95,liste_echantillon_sortie,nombre_par_echantillon,borne_inf_court_95,borne_sup_court_95);
Intervalle_Recouvrement_Symetrique(0.95,liste_echantillon_sortie,nombre_par_echantillon,borne_inf_sym_95,borne_sup_sym_95);
Intervalle_Recouvrement_Le_Plus_Court(0.99,liste_echantillon_sortie,nombre_par_echantillon,borne_inf_court_99,borne_sup_court_99);
Intervalle_Recouvrement_Symetrique(0.99,liste_echantillon_sortie,nombre_par_echantillon,borne_inf_sym_99,borne_sup_sym_99);
Intervalle_Recouvrement_Le_Plus_Court(0.75,liste_echantillon_sortie,nombre_par_echantillon,borne_inf_court_75,borne_sup_court_75);
Intervalle_Recouvrement_Symetrique(0.75,liste_echantillon_sortie,nombre_par_echantillon,borne_inf_sym_75,borne_sup_sym_75);
stringgrid5.Cells[0, 0]:=rsEstimateur;
    stringgrid5.Cells[1,0]:={(Donne_Selon_Incertitude_Sans_Incertitude(moyenne_sortie,
    ecart_type_sortie,3,option_tronque_a_zero_quand_incertitude_trop_grande); }
    Donne_Avec_Chiffres_Significatifs(moyenne_sortie,3,mon_genre_affichage_valeur_individuelle,ma_longueur_chaine_agreable_valeur_individuelle)+' '+symbole_unite;
    stringgrid5.Cells[0, 1]:=rsEcartTypeCha;
    stringgrid5.Cells[1,1]:=Donne_Avec_Chiffres_Significatifs(ecart_type_sortie,3,mon_genre_affichage_valeur_individuelle,ma_longueur_chaine_agreable_valeur_individuelle)+' '+symbole_unite;
      stringgrid5.AutoSizeColumns;
      stringgrid5.Cells[0, 2]:=rsCoefficientD2;
      stringgrid5.Cells[0, 3]:=rsExcSDAplatis;
      stringgrid5.Cells[1, 2]:=Donne_Avec_Chiffres_Significatifs(skewness_sortie,3,mon_genre_affichage_valeur_individuelle,ma_longueur_chaine_agreable_valeur_individuelle);
      stringgrid5.Cells[1, 3]:=Donne_Avec_Chiffres_Significatifs(kurtosis_sortie,3,mon_genre_affichage_valeur_individuelle,ma_longueur_chaine_agreable_valeur_individuelle);
       stringgrid5.AutoAdjustColumns;
      stringgrid6.RowCount:=4;
    stringgrid6.Cells[0, 0]:=rsTauxDeConfia;
    stringgrid6.Cells[1, 0]:=rsIntervalle;
       stringgrid6.Cells[2, 0]:=rsDemiLargeur;
     stringgrid6.Cells[3, 0]:=rsEcritureFina;
      stringgrid6.Cells[4, 0]:=rsEcritureFina2;
    stringgrid6.Cells[0,1]:='75%';
    stringgrid6.Cells[1,1]:='['+(Donne_Selon_Incertitude_Sans_Incertitude(borne_inf_sym_75,
    ecart_type_sortie,3,option_tronque_a_zero_quand_incertitude_trop_grande,option_arrondi_superieur_incertitude,
    mon_genre_affichage_incertitude,ma_longueur_chaine_agreable_incertitude))+' ; '+(Donne_Selon_Incertitude_Sans_Incertitude(borne_sup_sym_75,
    ecart_type_sortie,3,option_tronque_a_zero_quand_incertitude_trop_grande,option_arrondi_superieur_incertitude,
    mon_genre_affichage_incertitude,ma_longueur_chaine_agreable_incertitude))+']';
    stringgrid6.Cells[2,1]:=Donne_Avec_Chiffres_Significatifs((borne_sup_sym_75-borne_inf_sym_75)/2,3,mon_genre_affichage_valeur_individuelle,ma_longueur_chaine_agreable_valeur_individuelle)+' '+symbole_unite;
    stringgrid6.Cells[3,1]:=(Donne_Selon_Incertitude(moyenne_sortie,(borne_sup_sym_75-borne_inf_sym_75)/2,1,option_tronque_a_zero_quand_incertitude_trop_grande,option_arrondi_superieur_incertitude,mon_genre_affichage_incertitude,ma_longueur_chaine_agreable_incertitude))+symbole_unite;
    stringgrid6.Cells[4,1]:=(Donne_Selon_Incertitude(moyenne_sortie,(borne_sup_sym_75-borne_inf_sym_75)/2,2,option_tronque_a_zero_quand_incertitude_trop_grande,option_arrondi_superieur_incertitude,mon_genre_affichage_incertitude,ma_longueur_chaine_agreable_incertitude))+symbole_unite;
       stringgrid6.Cells[0,2]:='95%';
    stringgrid6.Cells[1,2]:='['+(Donne_Selon_Incertitude_Sans_Incertitude(borne_inf_sym_95,
    ecart_type_sortie,3,option_tronque_a_zero_quand_incertitude_trop_grande,option_arrondi_superieur_incertitude,
    mon_genre_affichage_incertitude,ma_longueur_chaine_agreable_incertitude))+' ; '+(Donne_Selon_Incertitude_Sans_Incertitude(borne_sup_sym_95,
    ecart_type_sortie,3,option_tronque_a_zero_quand_incertitude_trop_grande,option_arrondi_superieur_incertitude,
    mon_genre_affichage_incertitude,ma_longueur_chaine_agreable_incertitude))+']';
    stringgrid6.Cells[2,2]:=Donne_Avec_Chiffres_Significatifs((borne_sup_sym_95-borne_inf_sym_95)/2,3,mon_genre_affichage_valeur_individuelle,ma_longueur_chaine_agreable_valeur_individuelle)+' '+symbole_unite;
    stringgrid6.Cells[3,2]:=(Donne_Selon_Incertitude(moyenne_sortie,(borne_sup_sym_95-borne_inf_sym_95)/2,1,option_tronque_a_zero_quand_incertitude_trop_grande,option_arrondi_superieur_incertitude,mon_genre_affichage_incertitude,ma_longueur_chaine_agreable_incertitude))+symbole_unite;
    stringgrid6.Cells[4,2]:=(Donne_Selon_Incertitude(moyenne_sortie,(borne_sup_sym_95-borne_inf_sym_95)/2,2,option_tronque_a_zero_quand_incertitude_trop_grande,option_arrondi_superieur_incertitude,mon_genre_affichage_incertitude,ma_longueur_chaine_agreable_incertitude))+symbole_unite;
      stringgrid6.Cells[0,3]:='99%';
    stringgrid6.Cells[1,3]:='['+(Donne_Selon_Incertitude_Sans_Incertitude(borne_inf_sym_99,
    ecart_type_sortie,3,option_tronque_a_zero_quand_incertitude_trop_grande,option_arrondi_superieur_incertitude,
    mon_genre_affichage_incertitude,ma_longueur_chaine_agreable_incertitude))+' ; '+(Donne_Selon_Incertitude_Sans_Incertitude(borne_sup_sym_99,
    ecart_type_sortie,3,option_tronque_a_zero_quand_incertitude_trop_grande,option_arrondi_superieur_incertitude,
    mon_genre_affichage_incertitude,ma_longueur_chaine_agreable_incertitude))+']';
    stringgrid6.Cells[2,3]:=Donne_Avec_Chiffres_Significatifs((borne_sup_sym_99-borne_inf_sym_99)/2,3,mon_genre_affichage_valeur_individuelle,ma_longueur_chaine_agreable_valeur_individuelle)+' '+symbole_unite;
    stringgrid6.Cells[3,3]:=(Donne_Selon_Incertitude(moyenne_sortie,(borne_sup_sym_99-borne_inf_sym_99)/2,1,option_tronque_a_zero_quand_incertitude_trop_grande,option_arrondi_superieur_incertitude,mon_genre_affichage_incertitude,ma_longueur_chaine_agreable_incertitude))+symbole_unite;
    stringgrid6.Cells[4,3]:=(Donne_Selon_Incertitude(moyenne_sortie,(borne_sup_sym_99-borne_inf_sym_99)/2,2,option_tronque_a_zero_quand_incertitude_trop_grande,option_arrondi_superieur_incertitude,mon_genre_affichage_incertitude,ma_longueur_chaine_agreable_incertitude))+symbole_unite;
       stringgrid6.AutoSizeColumns;


         stringgrid7.RowCount:=4;
    stringgrid7.Cells[0, 0]:=rsTauxDeConfia;
    stringgrid7.Cells[1, 0]:=rsIntervalle;
       stringgrid7.Cells[2, 0]:=rsDemiLargeur;

    stringgrid7.Cells[0,1]:='75%';
    stringgrid7.Cells[1,1]:='['+
    (Donne_Selon_Incertitude_Sans_Incertitude(borne_inf_court_75,(borne_sup_court_75-borne_inf_court_75)/2,3,option_tronque_a_zero_quand_incertitude_trop_grande,option_arrondi_superieur_incertitude,
    mon_genre_affichage_incertitude,ma_longueur_chaine_agreable_incertitude))
    +' ; '+(Donne_Selon_Incertitude_Sans_Incertitude(borne_sup_court_75,(borne_sup_court_75-borne_inf_court_75)/2,3,option_tronque_a_zero_quand_incertitude_trop_grande,option_arrondi_superieur_incertitude,
    mon_genre_affichage_incertitude,ma_longueur_chaine_agreable_incertitude) )
    +']';
    stringgrid7.Cells[2,1]:=Donne_Avec_Chiffres_Significatifs((borne_sup_court_75-borne_inf_court_75)/2,3,mon_genre_affichage_valeur_individuelle,ma_longueur_chaine_agreable_valeur_individuelle)+' '+symbole_unite;

      stringgrid7.Cells[0,2]:='95%';
    stringgrid7.Cells[1,2]:='['+
    (Donne_Selon_Incertitude_Sans_Incertitude(borne_inf_court_95,(borne_sup_court_95-borne_inf_court_95)/2,3,option_tronque_a_zero_quand_incertitude_trop_grande,option_arrondi_superieur_incertitude,
    mon_genre_affichage_incertitude,ma_longueur_chaine_agreable_incertitude))
    +' ; '+(Donne_Selon_Incertitude_Sans_Incertitude(borne_sup_court_95,(borne_sup_court_95-borne_inf_court_95)/2,3,option_tronque_a_zero_quand_incertitude_trop_grande,option_arrondi_superieur_incertitude,
    mon_genre_affichage_incertitude,ma_longueur_chaine_agreable_incertitude))
    +']';
    stringgrid7.Cells[2,2]:=Donne_Avec_Chiffres_Significatifs((borne_sup_court_95-borne_inf_court_95)/2,3,mon_genre_affichage_valeur_individuelle,ma_longueur_chaine_agreable_valeur_individuelle)+' '+symbole_unite;


     stringgrid7.Cells[0,3]:='99%';
    stringgrid7.Cells[1,3]:='['+
    (Donne_Selon_Incertitude_Sans_Incertitude(borne_inf_court_99,(borne_sup_court_99-borne_inf_court_99)/2,3,option_tronque_a_zero_quand_incertitude_trop_grande,option_arrondi_superieur_incertitude,
    mon_genre_affichage_incertitude,ma_longueur_chaine_agreable_incertitude))
    +' ; '+(Donne_Selon_Incertitude_Sans_Incertitude(borne_sup_court_99,(borne_sup_court_99-borne_inf_court_99)/2,3,option_tronque_a_zero_quand_incertitude_trop_grande,option_arrondi_superieur_incertitude,
    mon_genre_affichage_incertitude,ma_longueur_chaine_agreable_incertitude))
    +']';
    stringgrid7.Cells[2,3]:=Donne_Avec_Chiffres_Significatifs((borne_sup_court_99-borne_inf_court_99)/2,3,mon_genre_affichage_valeur_individuelle,ma_longueur_chaine_agreable_valeur_individuelle)+' '+symbole_unite;
       stringgrid7.AutoSizeColumns;

    ecart_normale_avec_mc:= abs((incertitude_type_sortie*coef_elarg_95_normale-(borne_sup_sym_95-borne_inf_sym_95)/2)/
    (incertitude_type_sortie*coef_elarg_95_normale))>ecart_max_tolere/100 ;
   ecart_student_avec_mc:= abs((incertitude_type_sortie*coef_elarg_95_student-(borne_sup_sym_95-borne_inf_sym_95)/2)/
    (incertitude_type_sortie*coef_elarg_95_student))>ecart_max_tolere/100 ;
   SpeedButton_paslegitime1.Visible:=ecart_normale_avec_mc or ecart_student_avec_mc or une_seule_rectangulaire;
   SpeedButton_paslegitime2.Visible:=ecart_normale_avec_mc or ecart_student_avec_mc or une_seule_rectangulaire;
  end
  else
  begin
  stringgrid5.Cells[0, 0]:=rsEstimateur;
    stringgrid5.Cells[1, 0]:=rsValeursHorsL;
    stringgrid5.Cells[0, 1]:=rsEcartTypeCha;
    stringgrid5.Cells[1, 1]:=rsValeursHorsL2;
      stringgrid5.AutoSizeColumns;



   end;
   tous_calculs_faits:=true;
    pagecontrol1.ActivePage:=TabSheet_resultats;
    pagecontrol_resultats_propagation.ActivePage:=tabsheet_gum1;

     pagecontrol2.ActivePage:=tabsheet_estimation_mc;

    screen.Cursor:=crdefault;
end;

procedure TForm1.BitBtn_correlationsClick(Sender: TObject);
var i,j:integer;
begin
 with Form_affiche_correlations  do begin
 if screen.width>width then left:=(screen.width-width) div 2 else left:=0;
if screen.height>height then top:=(screen.height-height) div 2 else top:=0;
StringGrid_correlations.Clear;
 StringGrid_correlations.RowCount:=1+nombre_distributions;
 StringGrid_correlations.ColCount:=1+nombre_distributions;
for i:=1 to  nombre_distributions do
for j:=1 to  nombre_distributions do
if i<>j  then  StringGrid_correlations.Cells[i,j]:=myfloattostr(liste_descripteur_correlation[i-1,j-1].valeur);
for i:=1 to  nombre_distributions do StringGrid_correlations.Cells[i,0]:=liste_distributions[i-1].nom_variable;
for i:=1 to  nombre_distributions do StringGrid_correlations.Cells[0,i]:=liste_distributions[i-1].nom_variable;
StringGrid_correlations.AutoSizeColumns;
showmodal;
 end;
end;

procedure TForm1.BitBtn_theorie2Click(Sender: TObject);
begin
 form1.AffichePageDansNavigateur(repertoire_images+'gum1.'+fallbacklang+'.html',Sender);
 end;

procedure TForm1.Edit_autre_taux_normaleKeyPress(Sender: TObject; var Key: char
  );
begin
   if key=',' then key:='.';
end;

procedure TForm1.Edit_autre_taux_studentKeyPress(Sender: TObject; var Key: char
  );
begin
   if key=',' then key:='.';
end;

procedure TForm1.MenuItem11Click(Sender: TObject);
begin

end;

procedure TForm1.MenuItemavertissementClick(Sender: TObject);
begin
  with Form_ecart_max do begin
  spinedit1.value:=ecart_max_tolere;
  if screen.width>width then left:=(screen.width-width) div 2 else left:=0;
if screen.height>height then top:=(screen.height-height) div 2 else top:=0;
showmodal;
  end;
end;

procedure TForm1.MenuItem_affichage_incertitudeClick(Sender: TObject);
begin
  with Form_affichage_incertitude do begin
  case  mon_genre_affichage_incertitude of
  sans_point_decimal:RadioGroup1.itemindex:=0;
 sans_puissance_de_dix:RadioGroup1.itemindex:=1;
  avec_un_chiffre_avant_virgule_pour_valeur:RadioGroup1.itemindex:=2 ;
  avec_un_chiffre_avant_virgule_pour_incertitude:RadioGroup1.itemindex:=3 ;
  end;
  spinedit1.value:= ma_longueur_chaine_agreable_incertitude;
  if screen.width>width then left:=(screen.width-width) div 2 else left:=0;
if screen.height>height then top:=(screen.height-height) div 2 else top:=0;
  Showmodal;
 end;
end;

procedure TForm1.MenuItem_affichage_individuelClick(Sender: TObject);
begin  with Form_affichage_valeur_individuelle do begin
  case  mon_genre_affichage_valeur_individuelle of
  _sans_point_decimal:RadioGroup1.itemindex:=1;
  _sans_puissance_de_dix:RadioGroup1.itemindex:=2;
   _avec_un_chiffre_avant_virgule:RadioGroup1.itemindex:=0 ;
  end;
  spinedit1.value:= ma_longueur_chaine_agreable_valeur_individuelle;
  if screen.width>width then left:=(screen.width-width) div 2 else left:=0;
if screen.height>height then top:=(screen.height-height) div 2 else top:=0;
  Showmodal;
 end;

end;

procedure TForm1.MenuItem_historiqueClick(Sender: TObject);
begin
 form1.AffichePageDansNavigateur(repertoire_executable+'historique.html',sender);
end;

procedure TForm1.MenuItem_tutorielClick(Sender: TObject);
begin
  form1.AffichePageDansNavigateur(repertoire_aide+'Aide_GUM_MC.html',sender);
end;

procedure TForm1.AffichePageDansNavigateur(nom_fichier_html:string; Sender: TObject);
var
 v: THTMLBrowserHelpViewer;
 BrowserPath, BrowserParams: string;
 p: LongInt;
 URL: String;
 BrowserProcess: TProcessUTF8;
begin
 v:=THTMLBrowserHelpViewer.Create(nil);
 try
   v.FindDefaultBrowser(BrowserPath,BrowserParams);
   //debugln(['Path=',BrowserPath,' Params=',BrowserParams]);

  // url:='file:///'+repertoireexecutable+'historique.html';
  url:='file:///'+nom_fichier_html ;
   p:=System.Pos('%s', BrowserParams);
   System.Delete(BrowserParams,p,2);
   System.Insert(URL,BrowserParams,p);

   // start browser
   BrowserProcess:=TProcessUTF8.Create(nil);
   try
     BrowserProcess.CommandLine:=BrowserPath+' '+BrowserParams;
     BrowserProcess.Execute;
   finally
     BrowserProcess.Free;
   end;
 finally
   v.Free;
 end;

end;

procedure TForm1.BitBtn10Click(Sender: TObject);
var x,i:extended;   n:integer;
begin
  pagecontrol1.ActivePage:=tabsheet_expression;


end;

procedure TForm1.BitBtn11Click(Sender: TObject);
begin
   pagecontrol_resultats_propagation.ActivePage:=tabsheet_gum2;
end;

procedure TForm1.BitBtn12Click(Sender: TObject);
begin
 form1.AffichePageDansNavigateur(repertoire_images+'incertitude_elargie.'+fallbacklang+'.html',Sender);

end;

procedure TForm1.BitBtn13Click(Sender: TObject);
begin
 form1.AffichePageDansNavigateur(repertoire_images+'incertitude_elargie.'+fallbacklang+'.html',Sender);
end;

procedure TForm1.BitBtn14Click(Sender: TObject);
begin
 form1.AffichePageDansNavigateur(repertoire_images+'Welch-Satterthwaite.'+fallbacklang+'.html',Sender);

end;

procedure TForm1.BitBtn15Click(Sender: TObject);
begin
 form1.AffichePageDansNavigateur(repertoire_images+'mc.'+fallbacklang+'.html',Sender);

end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
 pagecontrol_resultats_propagation.ActivePage:=tabsheet_intervalles_normale;
end;

procedure TForm1.BitBtn33Click(Sender: TObject);

var autre_taux,coef_elarg:extended;
begin
  try
  autre_taux:=strtofloat(edit_autre_taux_normale.Text);
  except
    application.MessageBox(pchar(rsValeurIllGal),pchar( rsAttention2), mb_ok);
    edit_autre_taux_normale.Text:='';
    exit;
    end;
 if (autre_taux<=0) or (autre_taux>=100) then begin
  application.MessageBox(pchar(rsLeTauxDoitTr), pchar(rsAttention2), mb_ok);
    edit_autre_taux_normale.Text:='';
    exit;
    end;
 coef_elarg:=
       abs(normstd_invx((1-autre_taux/100)/2));



    stringgrid_autre_taux_normale.ColCount:=6;
  stringgrid_autre_taux_normale.RowCount:=2;

    stringgrid_autre_taux_normale.Cells[0, 0]:=rsTauxDeConfia;
     stringgrid_autre_taux_normale.Cells[1, 0]:=rsFacteurDLarg3;
     stringgrid_autre_taux_normale.Cells[2, 0]:=rsIncertitudeL;
    stringgrid_autre_taux_normale.Cells[3, 0]:=rsIntervalleYU;


     stringgrid_autre_taux_normale.Cells[4, 0]:=rsEcritureFina;
      stringgrid_autre_taux_normale.Cells[5, 0]:=rsEcritureFina2;
  stringgrid_autre_taux_normale.Cells[0,1]:=edit_autre_taux_normale.Text+'%';
    stringgrid_autre_taux_normale.Cells[1,1]:=Donne_Avec_Chiffres_Significatifs(coef_elarg,3,mon_genre_affichage_valeur_individuelle,ma_longueur_chaine_agreable_valeur_individuelle);
    stringgrid_autre_taux_normale.Cells[3,1]:='['+
    (Donne_Selon_Incertitude_Sans_Incertitude(estimateur_sortie-incertitude_type_sortie*coef_elarg,
     incertitude_type_sortie*coef_elarg,3,option_tronque_a_zero_quand_incertitude_trop_grande,option_arrondi_superieur_incertitude,
    mon_genre_affichage_incertitude,ma_longueur_chaine_agreable_incertitude))
    +' ; '+(Donne_Selon_Incertitude_Sans_Incertitude( estimateur_sortie+incertitude_type_sortie*coef_elarg,
     incertitude_type_sortie*coef_elarg,3,option_tronque_a_zero_quand_incertitude_trop_grande,option_arrondi_superieur_incertitude,
    mon_genre_affichage_incertitude,ma_longueur_chaine_agreable_incertitude))
    +']';
    stringgrid_autre_taux_normale.Cells[2,1]:=Donne_Avec_Chiffres_Significatifs(incertitude_type_sortie*coef_elarg,3,mon_genre_affichage_valeur_individuelle,ma_longueur_chaine_agreable_valeur_individuelle);
    stringgrid_autre_taux_normale.Cells[4,1]:=(Donne_Selon_Incertitude(estimateur_sortie,incertitude_type_sortie*coef_elarg,1,option_tronque_a_zero_quand_incertitude_trop_grande,option_arrondi_superieur_incertitude,mon_genre_affichage_incertitude,ma_longueur_chaine_agreable_incertitude))+symbole_unite;
   stringgrid_autre_taux_normale.Cells[5,1]:=(Donne_Selon_Incertitude(estimateur_sortie,incertitude_type_sortie*coef_elarg,2,option_tronque_a_zero_quand_incertitude_trop_grande,option_arrondi_superieur_incertitude,mon_genre_affichage_incertitude,ma_longueur_chaine_agreable_incertitude))+symbole_unite;
   stringgrid_autre_taux_normale.AutoSizeColumns;

end;

procedure TForm1.BitBtn4Click(Sender: TObject);
begin
  pagecontrol_resultats_propagation.ActivePage:=tabsheet_intervalle_student;
end;

procedure TForm1.BitBtn5Click(Sender: TObject);

  var autre_taux,coef_elarg:extended;
  begin

    try
    autre_taux:=strtofloat(edit_autre_taux_student.Text);
    except
      application.MessageBox(pchar(rsValeurIllGal),pchar( rsAttention2), mb_ok);
      edit_autre_taux_student.Text:='';
      exit;
      end;
   if (autre_taux<=0) or (autre_taux>=100) then begin
    application.MessageBox(pchar(rsLeTauxDoitTr), pchar(rsAttention2), mb_ok);
      edit_autre_taux_student.Text:='';
      exit;
      end;

   if degre_effectif_global<>0 then
   begin try
   coef_elarg:=abs(t_invx(floor(degre_effectif_global),(1-autre_taux/100)/2))+
       frac(degre_effectif_global)*(
       abs(t_invx(floor(degre_effectif_global)+1,(1-autre_taux/100)/2))
       -
       abs(t_invx(floor(degre_effectif_global),(1-autre_taux/100)/2))
       )
       except
       coef_elarg:=NAN;
       end;
   end else
        coef_elarg:=
       abs(normstd_invx((1-autre_taux/100)/2));






      stringgrid_autre_taux_student.ColCount:=6;
    stringgrid_autre_taux_student.RowCount:=2;

      stringgrid_autre_taux_student.Cells[0, 0]:=rsTauxDeConfia;
       stringgrid_autre_taux_student.Cells[1,0]:='k';
       stringgrid_autre_taux_student.Cells[2,0]:='U';
      stringgrid_autre_taux_student.Cells[3,0]:='[y-U ; y+U]';


       stringgrid_autre_taux_student.Cells[4, 0]:=rsEcritureFina;
        stringgrid_autre_taux_student.Cells[5, 0]:=rsEcritureFina2;
    stringgrid_autre_taux_student.Cells[0,1]:=edit_autre_taux_student.Text+'%';
      stringgrid_autre_taux_student.Cells[1,1]:=Donne_Avec_Chiffres_Significatifs(coef_elarg,3,mon_genre_affichage_valeur_individuelle,ma_longueur_chaine_agreable_valeur_individuelle);
      stringgrid_autre_taux_student.Cells[3,1]:='['+
      (Donne_Selon_Incertitude_Sans_Incertitude(estimateur_sortie-incertitude_type_sortie*coef_elarg,
       incertitude_type_sortie*coef_elarg,3,option_tronque_a_zero_quand_incertitude_trop_grande,option_arrondi_superieur_incertitude,
    mon_genre_affichage_incertitude,ma_longueur_chaine_agreable_incertitude))
            +' ; '+(Donne_Selon_Incertitude_Sans_Incertitude( estimateur_sortie+incertitude_type_sortie*coef_elarg,
       incertitude_type_sortie*coef_elarg,3,option_tronque_a_zero_quand_incertitude_trop_grande,option_arrondi_superieur_incertitude,
    mon_genre_affichage_incertitude,ma_longueur_chaine_agreable_incertitude))
      +']';
      stringgrid_autre_taux_student.Cells[2,1]:=Donne_Avec_Chiffres_Significatifs(incertitude_type_sortie*coef_elarg,3,mon_genre_affichage_valeur_individuelle,ma_longueur_chaine_agreable_valeur_individuelle);
      stringgrid_autre_taux_student.Cells[4,1]:=(Donne_Selon_Incertitude(estimateur_sortie,incertitude_type_sortie*coef_elarg,1,option_tronque_a_zero_quand_incertitude_trop_grande,option_arrondi_superieur_incertitude,mon_genre_affichage_incertitude,ma_longueur_chaine_agreable_incertitude))+symbole_unite;
     stringgrid_autre_taux_student.Cells[5,1]:=(Donne_Selon_Incertitude(estimateur_sortie,incertitude_type_sortie*coef_elarg,2,option_tronque_a_zero_quand_incertitude_trop_grande,option_arrondi_superieur_incertitude,mon_genre_affichage_incertitude,ma_longueur_chaine_agreable_incertitude))+symbole_unite;
     stringgrid_autre_taux_student.AutoSizeColumns;
end;

procedure TForm1.BitBtn6Click(Sender: TObject);
begin

pagecontrol1.ActivePage:=tabsheet_mc;
 pagecontrol2.ActivePage:=tabsheet_estimation_mc;
end;

procedure TForm1.BitBtn7Click(Sender: TObject);
begin
  pagecontrol2.ActivePage:=tabsheet_integre;
end;

procedure TForm1.BitBtn8Click(Sender: TObject);
begin

  pagecontrol2.ActivePage:=tabsheet_densite;
end;

procedure TForm1.BitBtn9Click(Sender: TObject);
begin
  pagecontrol2.ActivePage:=tabsheet_intervalle_mc;
end;

procedure TForm1.BitBtnpropagationClick(Sender: TObject);
begin
 pagecontrol1.ActivePage:=tabsheet_mc;
end;



procedure TForm1.BitBtn_fonctionClick(Sender: TObject);
  var i,ii:integer;
    tous_les_mesurandes_inchanges,conserver_tous_les_mesurandes:boolean;

  begin



            symbole_grandeur_sortie:=edit_nom_grandeur_sortie.Text;
            symbole_unite:=edit_saisie_unite.Text;
            if   symbole_unite='' then symbole_unite:=rsUnit;
            if  symbole_grandeur_sortie='' then symbole_grandeur_sortie:='Y';
        chaine_expr:=Edit_saisie_expression.Text;

 if chaine_expr='' then begin
   application.MessageBox(pchar(rsVousNAvezPas), pchar(rsAttention), mb_ok);
          self.ModalResult:=mrnone;
             exit;
          end;


        if chaine_expr=old_chaine_expr then begin
        pagecontrol1.ActivePage:=tabsheet_entree;
        exit;
                end;
        try
         Expr_temp:=TExpression.Create(chaine_expr);

        except

          application.MessageBox(pchar(rsErreurDeSynt),pchar( rsAttention), mb_ok);
          self.ModalResult:=mrnone;
             exit;
          end;




        if  Expr_temp.SymbolicValueNames.Count=0 then begin
         application.MessageBox(pchar(rsAucunMesurande), pchar(rsAttention), mb_ok);
          self.ModalResult:=mrnone;
             exit;
        end;


       tous_les_mesurandes_inchanges:=(Expr_temp.SymbolicValueNames.Count=nombre_mesurandes);

       for i:=1 to nombre_mesurandes do
       tous_les_mesurandes_inchanges:=tous_les_mesurandes_inchanges and (liste_mesurandes[i-1].nom_mesurande=Expr_temp.SymbolicValueNames[i-1]);

       conserver_tous_les_mesurandes:=false;
       if  tous_les_mesurandes_inchanges then
       conserver_tous_les_mesurandes:=(application.MessageBox(pchar(rsLesMesurande2),
         pchar(rsAveRtissemen2),
       mb_yesno)=mryes);




       expression_validee:=true;
       old_chaine_expr:=chaine_expr;

   if conserver_tous_les_mesurandes then begin
   pagecontrol1.ActivePage:=tabsheet_entree;
   exit;
   end;


        Liste_Variables:=Expr_temp.SymbolicValueNames;
    nombre_mesurandes:=Liste_Variables.Count;






    if nombre_distributions>0 then     begin
      for i:=1 to nombre_distributions do if liste_images_integre[i-1]<>nil then liste_images_integre[i-1].Free;
            for i:=1 to nombre_distributions do if liste_images_densite[i-1]<>nil then liste_images_densite[i-1].Free;
         end;



       setlength(liste_distributions,0);
       nombre_distributions:=0;
         setlength( liste_descripteur_correlation,0,0);

    setlength(liste_mesurandes,nombre_mesurandes);
      for i:=1 to nombre_mesurandes do  begin
      liste_mesurandes[i-1].nom_mesurande:=liste_variables[i-1];
      liste_mesurandes[i-1].estimateur:=NAN;
      liste_mesurandes[i-1].nombre_erreurs:=0;
      setlength(liste_mesurandes[i-1].liste_des_indices_des_sources_derreur,0);


      end;
    setlength(liste_distribution_est_traitee,nombre_mesurandes);

     Form1.rafraichitstringgridentree(sender);
        tous_calculs_faits:=false;



     Initialise_Generateur(0);



 if expression_validee then
  pagecontrol1.ActivePage:=tabsheet_entree;
end;

procedure TForm1.Edit_saisie_expressionChange(Sender: TObject);
begin
  if  Form1.Edit_saisie_expression.text<>chaine_expr then begin
  expression_validee:=false;
  tous_calculs_faits:=false;

  end;
end;





procedure TForm1.FormCreate(Sender: TObject);
 var newmenuitem:tmenuitem;
S:sysutils.TSearchRec;   il:integer;
  begin
   encreation:=true;
   MenuItemavertissement.Caption:=rsEcartMaximum;
   SpeedButton_paslegitime1.Caption:=rsPasLGitimeIc;
    SpeedButton_paslegitime2.Caption:=rsPasLGitimeIc;
   radiogroup1.Caption:=rsDiagramme;
   radiogroup1.Items.Clear;
   radiogroup1.Items.Add(rsBarres);
   radiogroup1.Items.Add(rsCamembert);
   radiogroup1.ItemIndex:=0;
  speedbutton12.Hint:=rsCopierLeGrap;
  speedbutton13.Hint:=rsCopierLeGrap;
  speedbutton1.Hint:=rsCopierDansLe;
  bitbtn12.caption:=rsThOrieIncert;
bitbtn13.caption:=rsThOrieIncert;
bitbtn14.caption:=rsThOrieDegrDe;
bitbtn15.caption:=rsThOrie;
MenuItem_affichage_incertitude.Caption:=rsTypeDAfficha3;
 bitbtn_theorie1.caption :=rsThOriePropag;
bitbtn_theorie2.caption:=rsThOriePropag;
  BitBtn_correlations.Caption:=rsCorrLationsE;
      label16.Caption:=rsPasLGitimeIc;
  MenuItem_affichage_individuel.Caption:=rsTypeDAfficha2;
   label17.Caption:=rsPasLGitimeDi;
  speedbutton2.Hint:=rsCopierDansLe;
  speedbutton3.Hint:=rsCopierDansLe;
  speedbutton4.Hint:=rsCopierDansLe;
  speedbutton14.Hint:=rsCopierDansLe;
  speedbutton14.Hint:=rsCopierDansLe;
  speedbutton5.Hint:=rsCopierDansLe;
  speedbutton6.Hint:=rsCopierDansLe;
  speedbutton7.Hint:=rsCopierDansLe;
  speedbutton8.Hint:=rsCopierDansLe;
  speedbutton9.Hint:=rsCopierDansLe;
  speedbutton10.Hint:=rsCopierDansLe;
  speedbutton11.Hint:=rsCopierDansLe;
  MenuItem_ouvrir_exemples.Caption:=rsDuRPertoireE;
  MenuItem_ouvrir_personnel.Caption:=rsDeMonRPertoi;
   MenuItem_historique.Caption:=rsHistoriqueDe;

   MenuItem11.Caption:=rsOuvrir;
   MenuItem10.Caption:=rsFichier;

   MenuItem_ouvrir_dernier.Caption:=rsDuDernierRPe;
   MenuItem_enregistrer_perso.Caption:=rsDansLeRPerto;
   MenuItem13.Caption:=rsDansLeDernie;
   MenuItem_enregistrer_exemples.Caption:=rsDansLeRPerto2;
   MenuItem_enregistrer_sous.Caption:=rsEnregistrerS;
   MenuItem_enregistrer.Caption:=rsEnregistrer;
   CAPTION:=rsGum_MCLogici2;
   tabsheet_commentaires.Caption:=rsCommentaires2;
TABSHEET_BIENVENUE.CAPTION:=rsBienvenue;
STATICTEXT1.CAPTION:=rsBienvenueDan;
STATICTEXT2.CAPTION:=rsLeButDeCeLog;
STATICTEXT3.CAPTION:=rsIlTenteDeSui;
 STATICTEXT14.CAPTION:=rsGuideToTheEx;

STATICTEXT5.CAPTION:=Format(rsRemarques1Le, [lineending, lineending]);
STATICTEXT4.CAPTION:=rsLaDMarcheEst;
STATICTEXT15.CAPTION:=rs1VousSaisiss;
STATICTEXT16.CAPTION:=rsEnFonctionDe;
STATICTEXT17.CAPTION:=rs2VousSaisiss;
STATICTEXT18.CAPTION:=rsAEstimationX;
STATICTEXT19.CAPTION:=rsBIncertitude;
STATICTEXT20.CAPTION:=rsCTypeDeLoiDe;
STATICTEXT21.CAPTION:=rs3GUM_MCVousF;
STATICTEXT22.CAPTION:=rsEtCeParCalcu;
STATICTEXT23.CAPTION:=rs4EnfinGUM_MC;
STATICTEXT24.CAPTION:=rsLaProcDureAd;


BITBTN10.CAPTION:=rsCliquezIciPo;
STATICTEXT11.HINT:=rsClicIciPourA;
STATICTEXT11.CAPTION:=rsHttpWwwBipmO;
STATICTEXT12.CAPTION:=rsEtSonSupplMe;
STATICTEXT13.HINT:=rsClicIciPourA;
STATICTEXT13.CAPTION:=rsHttpWwwBipmO2;
TABSHEET_EXPRESSION.CAPTION:=rsExpressionDe;
BITBTN_FONCTION.CAPTION:=rsValiderEtPas;
EDIT_SAISIE_EXPRESSION.HINT:=rsSaisissezIci;
EDIT_NOM_GRANDEUR_SORTIE.HINT:=rsSymboleGrand;
EDIT_NOM_GRANDEUR_SORTIE.TEXT:=rsY;
STATICTEXT6.CAPTION:=rsSymboleGrand2;
STATICTEXT7.CAPTION:=rsExpressionEn;



STATICTEXT8.CAPTION:=rsegal;
EX1_SORTIE.TEXT:=rsCa;
EX1_EXPRESSION.TEXT:=rsCbVbVa;
STATICTEXT9.CAPTION:=rsExemples;
EX2_SORTIE.TEXT:=rsR;
EX2_EXPRESSION.TEXT:=rsRmesuresrepe;
EX3_SORTIE.TEXT:=rsP;
EX3_EXPRESSION.TEXT:=rsRI2;
EDIT_SAISIE_UNITE.HINT:=rsSymboleUnit;
EDIT_SAISIE_UNITE.TEXT:=rsUnit;
STATICTEXT10.CAPTION:=rsSymboleDeLUn;
TABSHEET_ENTREE.CAPTION:=rsGrandeursDEn;
BITBTN1.CAPTION:=rsValiderEtCal;
STRINGGRID_ENTREE.HINT:=rsCliquezSurLa;
TABSHEET_RESULTATS.CAPTION:=rsRSultatsParP;
TABSHEET_GUM1.CAPTION:=rsEstimations;



LABEL2.CAPTION:=rsIncertitudes2;

LABEL3.CAPTION:=rsIncertitudes;
LABEL5.CAPTION:=rsGUMClassique2;
LABEL6.CAPTION:=rsTableauDesTe;
BITBTN2.CAPTION:=rsAccDerAuxInt;
BITBTN11.CAPTION:=rsAccDerAuxRSu2;
TABSHEET_INTERVALLES_NORMALE.CAPTION:=rsIntervallesD;
LABEL9.CAPTION:=rsIntervallesD2;







LABEL8.CAPTION:=rsPourUnAutreT;
LABEL13.CAPTION:=rs2;
BITBTN3.CAPTION:=rsCalculer;
BITBTN4.CAPTION:=rsAccDerAuxInt2;
TABSHEET_INTERVALLE_STUDENT.CAPTION:=rsIntervallesD3;
LABEL10.CAPTION:=rsIntervallesD4;
LABEL7.CAPTION:=rsDegrDeLibert;
LABEL14.CAPTION:=rsPourUnAutreT2;
LABEL15.CAPTION:=rs2;
BITBTN5.CAPTION:=rsCalculer;
BITBTN6.CAPTION:=rsAccDerAuxRSu;
TABSHEET_MC.CAPTION:=rsRSultatsSimu;
TABSHEET_ESTIMATION_MC.CAPTION:=rsEstimateurs;
LABEL4.CAPTION:=rsMThodeMonteC;
BITBTN7.CAPTION:=rsAccDerAuTrac;
TABSHEET_INTEGRE.CAPTION:=rsFonctionDeDi;
BITBTN8.CAPTION:=rsAccDerAuTrac2;
TABSHEET_DENSITE.CAPTION:=rsHistogrammeD;
BITBTN9.CAPTION:=rsAccDerAuxInt3;
TABSHEET_INTERVALLE_MC.CAPTION:=rsIntervallesD5;
LABEL11.CAPTION:=rsIntervallesD6;
LABEL12.CAPTION:=rsIntervallesD7;
MENUITEM1.CAPTION:=rsOptions;

MENUITEM_MONTECARLO.CAPTION:=rsMonteCarlo;
MENUITEM_INCERTITUDE.CAPTION:=rsEnCasDIncert;
MENUITEM_ARRONDI_INC.CAPTION:=rsArrondiSurLI;
MENUITEM_ARRONDI_SUP_INC.CAPTION:=rsSupRieurDFau;
MENUITEM_ARRONDI_NORMAL_INC.CAPTION:=rsNormal;
MENUITEM9.CAPTION:=rsLangue;
MENUITEM2.CAPTION:=rsAide;
MENUITEM4.CAPTION:=rs3;
MENUITEM3.CAPTION:=rsLicenceGPL;
MENUITEM7.CAPTION:=rs3;
MENUITEM8.CAPTION:=rsSiteWeb;
MENUITEM6.CAPTION:=rs3;
MENUITEM5.CAPTION:=rsAPropos;


menuitem_nouveau.Caption:=rsNouveau;
menuitem_ouvrir_exemples.Caption:=rsDuRPertoireE;
menuitem_ouvrir_personnel.Caption:=rsDuRPertoireP;
menuitem11.Caption:=rsOuvrir;
menuitem10.Caption:=rsFichier;

memo1.Lines.Clear;

memo1.Lines.Add(rsLesSymbolesD);
memo1.Lines.Add(rsSymbole_);
memo1.Lines.Add(rsExemplesXTot);
memo1.Lines.Add('');
memo1.Lines.Add(rsLesFonctions);
memo1.Lines.Add(rsTrigonomTriq);
memo1.Lines.Add(rsDiversesSqrC);
memo1.Lines.Add(rsExponentiell);
memo1.Lines.Add(rsArctanh);
memo1.Lines.Add(rsHeavFonction);
memo1.Lines.Add(rsTruncPartieE);
memo1.Lines.Add(rsMinMaxArg);
memo1.Lines.Add('');
memo1.Lines.Add(rsLesOpRateurs);
memo1.Lines.Add(rsPiEstLaVaria);
memo1.Lines.Add('');
memo1.Lines.Add(rsNotationScie);
memo1.Lines.Add('');
memo1.Lines.Add(rsIlNYAPasDeDi);



   expression_validee:=false;
  nombre_mesurandes:=0;

   if liste_langues.Count>0 then
            for il:=1 to  liste_langues.Count do begin
            newmenuitem:=tmenuitem.Create(mainmenu1);
            newmenuitem.Caption:=liste_langues[il-1];
            newmenuitem.Tag:=1000+il;
            newmenuitem.OnClick:=@menuitem9click;
            if  liste_langues[il-1]=fallbacklang then newmenuitem.Checked:=true;
            menuitem9.add(newmenuitem);
            end;








    pagecontrol1.ActivePage:=tabsheet_bienvenue;

    with Form1 do begin
 if screen.width>width then left:=(screen.width-width) div 2 else left:=0;
if screen.height>height then top:=(screen.height-height) div 2 else top:=0;
end;
end;

initialization
  {$I unit1.lrs}
 mon_genre_affichage_incertitude:=sans_puissance_de_dix;
   mon_genre_affichage_valeur_individuelle:=_sans_puissance_de_dix;
   ma_longueur_chaine_agreable_valeur_individuelle:=10;
  ma_longueur_chaine_agreable_incertitude:=20;
  chaine_expr:='';  old_chaine_expr:='';
  nombre_mesurandes:=0;    nombre_distributions:=0;
  setlength(liste_distribution_est_traitee,0);
  setlength(liste_mesurandes,0);
   setlength(liste_distributions,0);
   setlength( liste_descripteur_correlation,0,0);
   expression_validee:=false;    tous_calculs_faits:=false;
  {$ifndef darwin} application.UpdateFormatSettings:=false; {$endif}
  DefaultFormatSettings.DecimalSeparator:='.';
  setlength(liste_echantillons_entree,0);
  setlength(copie_liste_echantillons_entree,0);
  puissance_de_nombre_par_echantillon:=6;
    nombre_par_echantillon:=1000000;
    nombre_de_classes:=500;
    Initialise_Generateur(0);

    option_tronque_a_zero_quand_incertitude_trop_grande:=true;
    option_arrondi_superieur_incertitude:=true;

    repertoire_executable:=AppendPathDelim(extractfilepath(systoutf8(Application.ExeName)));
    repertoire_images:=AppendPathDelim(repertoire_executable+'images');
     nomexecutable:=extractfilename(Application.ExeName);
         repertoire_exemples:=AppendPathDelim(repertoire_executable+'exemples');
         repertoire_aide:=AppendPathDelim(repertoire_executable+'aide');
          repertoire_config_perso:=AppendPathDelim(MyGetAppConfigDirUTF8);

          {$ifdef windows}
  repertoire_propagation_perso:=AppendPathDelim(AppendPathDelim(MyGetMesDocumentsUTF8)+'MesCalculsDIncertitude');
   {$endif}
   {$ifndef windows}
    repertoire_propagation_perso:=AppendPathDelim({repertoire_config_perso}GetUserDir+'MesCalculsDIncertitude');
     {$endif}


     dernier_repertoire_utilise_chargement:=repertoire_exemples;
     dernier_repertoire_utilise_sauvegarde:=repertoire_propagation_perso;
     nom_fichier_sauvegarde:='';
     nom_fichier_chargement:='';

     if not(directoryexistsUTF8(repertoire_config_perso)) then   try
    forcedirectories(UTF8ToSys(repertoire_config_perso));
   except; end;
      if not(directoryexistsUTF8(repertoire_propagation_perso)) then   try
    forcedirectories(UTF8ToSys(repertoire_propagation_perso));
   except; end;

liste_langues:=tstringlist.create;
       chemin_po:=AppendPathDelim(repertoire_executable+'lang');

        If FindFirstutf8(Chemin_po+'gum_mc.*.po',faAnyFile,Search)=0
Then Begin
 Repeat
    if (Search.Name='.') or (Search.Name='..') or (Search.Name='')
      then continue;
            { liste_langues.Add(copy(Search.name,length(Search.name)-4,2)); }
            ID_lang:=copy(Search.name,length('gum_mc.')+1,
               length(Search.Name)-length('gum_mc..po'));
            if (ID_lang<>'') and (Pos('.',ID_lang)<1) and (liste_langues.IndexOf(ID_lang)<0)
    then liste_langues.Add(ID_lang);
            Until FindNextutf8(Search)<>0;
 FindCloseutf8(Search);
End;


    lang:='';  FallbackLang:='';

  nom_ini_file:=repertoire_config_perso+'gum_mc.ini';
   if not(fileexistsutf8(nom_ini_file)) then begin
     GetLanguageIDs(lang,FallbackLang);
           if ((liste_langues.indexof(uppercase(lang))=-1) and
          (liste_langues.indexof(uppercase(FallbackLang))=-1)) then
        begin
      Lang:='fr_FR';  FallbackLang:='fr';
             end;
     goto 1888;
     end;
      assignfile(f_ini,UTF8ToSys(nom_ini_file));
     reset(f_ini);
     readln(f_ini,lang);
            readln(f_ini,FallbackLang);
     closefile(f_ini);


    //GetLanguageIDs(Lang, FallbackLang); // dans l'unité gettext



    1888:
PODirectory:=IncludeTrailingPathDelimiter(
                      IncludeTrailingPathDelimiter(
                       ExtractFilePath(Application.ExeName))+'lang');
    TranslateUnitResourceStrings('LCLStrConsts', PODirectory + 'lclstrconsts.%s.po', Lang, FallbackLang);
    TranslateUnitResourceStrings('UChaines', PODirectory + 'gum_mc.%s.po', Lang, FallbackLang);
  parametre_ligne_commande:=paramcount>=1;
  ecart_max_tolere:=25;
end.

